
angular.module('starter.agentController', [])

//----------------------------------------------------------------------
// 机构列表controller
//----------------------------------------------------------------------
.controller('AgentCtrl', function($ionicScrollDelegate, $ionicLoading, $cordovaToast, $ionicModal, $cordovaGeolocation, CheckLogin, Constants, $cordovaSQLite, Common, Network, $scope, $state, $window, $ionicLoading, $rootScope) {
  $scope.arrow_status = true;
  if (ionic.Platform.isIOS()) {
    $scope.arrow_status = false;
  }

  $scope.$on( "$ionicView.enter", function( scopes, states ) {
    if($rootScope.agentStatus == 1){
      CheckLogin.checkLogin(function(res) {
    if (res != null) {
      userIds = res;
      var json = {
        ids: res
      };

      var apiUrl = "/api/user/info";
      //个人信息获取
      Network.loading(json, apiUrl, function(data) {
        user = data.data.user_info;
        $rootScope.agentStatus = 0;
        $scope.province_code = user.area_code_1;
        $scope.city_code = user.area_code_2;
        $scope.area_name = user.area_name_2;
        $rootScope.area_name = user.area_name_2;
        $rootScope.area_code = user.area_code_2;
        if ($scope.area_name.length > 3) {
          $scope.area_name = $scope.area_name.substr(0, 2);
        }
        $scope.agent.paginated = 1;
        var areajson = {
          city_code: $scope.city_code
        };
        //区域信息获取
        Network.loading(areajson, "/api/mst_area/getArea", function(data) {
          $scope.areaList = data.data.data;
          $scope.searchAgent();
        });
      });
    }
  });
    }
  });

  /**
   * 机构列表
   */
  $scope.agent = $scope;
  $rootScope.appPage = 1;
  $scope.course_type_1 = null;
  $scope.area = '';
  $scope.sortkey = '1';
  $scope.province = null;
  $scope.identification = '2';
  $scope.agent.condition = '';
  $scope.agentType = '';
  $scope.course_type = '分类';
  $scope.agent.paginated = 0;
  var user;
  var count = 0;
  var page = {
    page: count + '',
    count: Constants.pageItem
  };
  var scrollListToTop = function() {
      $ionicScrollDelegate.$getByHandle('agentListScroll').scrollTop();
    };
  var userIds;
  //机构类型列表
  Network.loading({
    pid: '0'
  }, "/api/mst_agent_type/getAgentTypeList", function(data) {
    $scope.agentTypeList = data.data.data;
    $scope.courseType1List = $scope.agentTypeList;
  });
  CheckLogin.checkLogin(function(res) {
    if (res != null) {
      userIds = res;
      var json = {
        ids: res
      };

      var apiUrl = "/api/user/info";
      //个人信息获取
      Network.loading(json, apiUrl, function(data) {
        user = data.data.user_info;
        $scope.province_code = user.area_code_1;
        $scope.city_code = user.area_code_2;
        $scope.area_name = user.area_name_2;
        $rootScope.area_name = user.area_name_2;
        $rootScope.area_code = user.area_code_2;
        if ($scope.area_name.length > 3) {
          $scope.area_name = $scope.area_name.substr(0, 2);
        }
        $scope.agent.paginated = 1;
        var areajson = {
          city_code: $scope.city_code
        };
        //区域信息获取
        Network.loading(areajson, "/api/mst_area/getArea", function(data) {
          $scope.areaList = data.data.data;
        });
      });
    } else {
      $scope.province_code = '11';
      $scope.city_code = '1101';
      $scope.area_name = '北京';
      $rootScope.area_name = '北京';
      $rootScope.area_code = '1101';
      $scope.agent.paginated = 1;
      var areajson = {
        city_code: $scope.city_code
      };
      //区域信息获取
      Network.loading(areajson, "/api/mst_area/getArea", function(data) {
        $scope.areaList = data.data.data;
      });
    }
  });
  
  /**
   * 机构检索
   */
  $scope.searchAgent = function() {
    count = 1;
    var identificat;
    page = {
      page: count + '',
      count: Constants.pageItem
    };
    if ($scope.identification == 2) {
      identificat = '';
    } else {
      identificat = $scope.identification;
    }
    if ($scope.sortkey == 2) {
      if (latitude == null || longitude == null) {
        $cordovaToast.showShortCenter('请开启GPS');
        return false;
      }
    }
    $ionicLoading.show({
            template: '努力加载中...',
            duration: 20000
          });
    var json = {
      pagination: page,
      condition: $scope.agent.condition,
      city: $scope.city_code + '',
      identification: identificat + '',
      agentCode1: $scope.course_type1 + '',
      agentCode2: $scope.course_type2 + '',
      agentCode3: $scope.course_type3 + '',
      province: $scope.province_code + '',
      area: $scope.area + '',
      latitude: latitude,
      longitude: longitude,
      sortkey: $scope.sortkey,
      user_ids: $rootScope.userIds
    };
    //机构获取
    Network.loading(json, "/api/agent_info/getAgentInfoList", function(data) {
      scrollListToTop();
      $scope.agentInfoList = data.data;
      console.log($scope.agentInfoList);
      $ionicLoading.hide();
      $scope.agent.paginated = data.paginated.more;
      if (!$scope.agentInfoList || $scope.agentInfoList.length == 0) {
        $cordovaToast.showShortCenter('无此类机构，请更换条件或关键字重试');
      }
    });
  };

  /*
   * 机构列表页地图
   */
  $scope.agentMap = function() {
    $state.go('tab.map');
  };

  /*
   * 机构页面刷新
   */
  $scope.agentRefresh = function() {
    $scope.searchAgent();
    $scope.$broadcast("scroll.refreshComplete");
  };

  /**
   * 机构列表刷新
   */
  $scope.load_more_agent = function() {
    $ionicLoading.show({
        template: '努力加载中',
        duration: 20000
      });
    count = count + 1;
    var identificat;
    page = {
      page: count + '',
      count: Constants.pageItem
    };
    if ($scope.identification == 2) {
      identificat = '';
    } else {
      identificat = $scope.identification;
    }
    var json = {
      pagination: page,
      condition: $scope.agent.condition + '',
      city: $scope.city_code + '',
      identification: identificat + '',
      agentCode1: $scope.course_type1 + '',
      agentCode2: $scope.course_type2 + '',
      agentCode3: $scope.course_type3 + '',
      province: $scope.province_code + '',
      area: $scope.area + '',
      latitude: latitude,
      longitude: longitude,
      sortkey: $scope.sortkey,
      user_ids: $rootScope.userIds
    };
    console.log(json);
    //机构获取
    Network.loading(json, "/api/agent_info/getAgentInfoList", function(data) {
      console.log(data);
      $ionicLoading.hide();
      $scope.agent.paginated = data.paginated.more;
      if ($scope.agentInfoList) {
        $scope.agentInfoList = $scope.agentInfoList.concat(data.data);
      } else {
        $scope.agentInfoList = data.data;
      }
      $scope.$broadcast("scroll.infiniteScrollComplete");
      if (!$scope.agentInfoList || $scope.agentInfoList.length == 0) {
        $cordovaToast.showShortCenter('无此类机构，请更换条件或关键字重试');
      }
    });
  };

  /**
   * 进入机构详情
   */
  $scope.goDtail = function(agentId, name, tabType, agentPics, distance, reward_flag) {
    $rootScope.agentPics = agentPics;
    $rootScope.rewardFlag = reward_flag;
    $state.go('tab.agent-agentDetail', {
      'agentId': agentId,
      'tabType': tabType,
      'name': name,
      'distance': distance
    });
  };
  //省份信息获取
  if($rootScope.provinceList){
    $scope.provinceList = $rootScope.provinceList;
  }else{
    Network.loading({}, "/api/mst_area/getProvince", function(data) {
      $scope.provinceList = data.data.data;
    });
  }
  var province;
  var city;
  var cityName;
  var provinceIds;
  var cityIds;
  var province_code;
  var city_code;
  /**
   * 选择区域
   */
  $scope.choseArea = function() {
    if(user){
      if(provinceIds == null){
        provinceIds = user.area_code_1
      }
      if(cityIds == null){
        cityIds = user.area_code_2;
      }
    }
    else{
      if(provinceIds == null){
        provinceIds = '11';
      }
      if(cityIds == null){
        cityIds = '1101';
      }
    }
    province_code = $scope.province_code;
    city_code = $scope.city_code;
    $ionicModal.fromTemplateUrl("templates/agent/agent_area.html", {
      scope: $scope
    }).then(function(modal) {
      $scope.areaModal = modal;
      $scope.areaModal.show();
    });
    json = {
      province_code: provinceIds
    };
    //城市信息获取
    Network.loading(json, "/api/mst_area/getCity", function(data) {
      $scope.cityList = data.data.data;
    });
  };

  /**
   * 取得城市
   */

  $scope.getAgentCity = function(provinceId, provinceNames) {
    $ionicScrollDelegate.$getByHandle('small').scrollTop();
    city_code = null;
    province_code = provinceId;
    $(".agentprovince").removeClass('assertive');
    $("#ap" + provinceId).addClass('assertive');
    provinceName = provinceNames;
    $scope.cityList = null;
    var id = provinceId + '';
    json = {
      province_code: id
    };
    //城市信息获取
    Network.loading(json, "/api/mst_area/getCity", function(data) {
      $scope.cityList = data.data.data;
    });
  };

  /**
   *  取得区域
   */
  $scope.getAgentArea = function(cityId, cityNames) {
    $(".city").removeClass('assertive');
    city_code = cityId;
    $("#ac" + cityId).addClass('assertive');
    cityName = cityNames;
  };

  /**
   * [closeModal 关闭区域model]
   */
  $scope.closeModal = function() {
    $scope.areaModal.remove();
    $scope.province_code = provinceIds;
    $scope.city_code = cityIds;
    province_code = provinceIds;
    city_code = cityIds;
    if (user) {
      if($scope.province_code == null){
        $scope.province_code = user.area_code_1;
      }
      if($scope.city_code == null){
        $scope.city_code = user.area_code_2;
      }
      if(cityName == null){
        $scope.area_name = user.area_name_2;
      }
    }
    else{
      if($scope.province_code == null){
        $scope.province_code = '11';
      }
      if($scope.city_code == null){
        $scope.city_code = '1101';
      }
      if(cityName == null){
        $scope.area_name = '市辖区';
      }
    }
    if ($scope.area_name.length > 3) {
        $scope.area_name = $scope.area_name.substr(0, 2);
      }
    var areajson = {
      city_code: $scope.city_code
    };
    Network.loading(areajson, "/api/mst_area/getArea", function(data) {
      $scope.areaList = data.data.data;
    });
  };

  /**
   * 根据区域筛选机构列表
   */
  $scope.areaMessage = function() {
    if (province_code == null || province_code == '') {
      $cordovaToast.showShortCenter('请选择省份');
      return false;
    }
    if (city_code == null || city_code == '') {
      $cordovaToast.showShortCenter('请选择城市');
      return false;
    }
    $scope.areaModal.remove();
    provinceIds = province_code;
    cityIds = city_code;
    $scope.province_code = province_code;
    $scope.city_code = city_code;
    if (cityName != null && cityName != '') {
      $scope.area_name = cityName;
      $rootScope.area_name = cityName;
      if ($scope.area_name.length > 2) {
        $scope.area_name = $scope.area_name.substr(0, 2);
      }
    }

    var areajson = {
      city_code: $scope.city_code
    };
    $scope.areaList = null;
    $scope.area = '';
    Network.loading(areajson, "/api/mst_area/getArea", function(data) {
      $scope.areaList = data.data.data;
      $rootScope.area_code = $scope.city_code;
      $scope.searchAgent();
    });
  };

  /**
   * [choseCourse 选择类别]
   */
  $scope.course_type1 = '';
  $scope.course_type2 = '';
  $scope.course_type3 = '';
  var type1 = '';
  var type2 = '';
  var type3 = '';
  $scope.choseCourse = function() {
    $ionicModal.fromTemplateUrl("templates/agent/agent_type.html", {
      scope: $scope
    }).then(function(modal) {
      $scope.agentModal = modal;
      $scope.courseType1List = $scope.agentTypeList;
      $scope.agentModal.show();
    });
  };

  /**
   * 选择二级类别
   */
  $scope.getType2 = function(id, pid,name) {
    $ionicScrollDelegate.$getByHandle('typeSmallOne').scrollTop();
    type1 = pid + '';
    $(".course_type1").removeClass('assertive');
    $("#ag" + id).addClass('assertive');
    if (id == 'all') {
      type1 = '';
      type2 = '';
      type3 = '';
      $scope.courseType2List = '';
      $scope.courseType3List = '';
      $scope.course_type = '全部';
      $("#ag" + id).addClass('assertive');
    } else {
      $scope.courseType2List = '';
      $scope.courseType3List = '';
      type2 = '';
      type3 = '';
      $scope.course_type = name;
      Network.loading({
        pid: pid + ''
      }, "/api/mst_agent_type/getAgentTypeList", function(data) {
        $scope.courseType2List = data.data.data;
        $("#ag" + id).addClass('assertive');
        console.log($scope.courseType2List);
      });
    }
  };

  /**
   * 选择三级类别
   */
  $scope.getType3 = function(id, pid,name) {
    $ionicScrollDelegate.$getByHandle('typeSmallTwo').scrollTop();
    type2 = pid + '';
    $scope.course_type = name;
    $(".course_type2").removeClass('assertive');
    Network.loading({
      pid: pid + ''
    }, "/api/mst_agent_type/getAgentTypeList", function(data) {
      $scope.courseType3List = data.data.data;
      $("#ag" + id).addClass('assertive');
      console.log($scope.courseType3List);
    });
  };

  /**
   *  三级类别选中
   */
  $scope.setType3 = function(id, pid, name) {
    $(".course_type3").removeClass('assertive');
    type3 = pid + '';
    $scope.course_type = name;
    $("#ag" + id).addClass('assertive');
  };

  /**
   *  关闭类别model
   */
  $scope.closeCourseModal = function() {
    $scope.course_type1 = '';
    $scope.course_type2 = '';
    $scope.course_type3 = '';
    type1 = '';
    type2 = '';
    type3 = '';
    $scope.courseType2List = '';
    $scope.courseType3List = '';
    $scope.course_type = '分类';
    $scope.agentModal.remove();
  };

  /**
   *  根据类别检索机构
   */
  $scope.courseTypeMessage = function() {
    $scope.course_type1 = type1;
    $scope.course_type2 = type2;
    $scope.course_type3 = type3;
    $scope.searchAgent();
    $scope.agentModal.remove();
  };

})

//----------------------------------------------------------------------
// 机构详情controller
//----------------------------------------------------------------------
.controller('AgentDetailCtrl', function(Constants, Share, $cordovaToast, $ionicLoading, $rootScope, CheckLogin, $scope, Network, $stateParams, $state, $ionicActionSheet, $ionicPopup, $ionicModal) {

  $scope.agentId = $stateParams.agentId;
  $scope.tabType = $stateParams.tabType;
  $scope.agent_name = $stateParams.name;
  $scope.distance = $stateParams.distance;
  $scope.agentPics = $rootScope.agentPics;
  $scope.rewardFlag = $rootScope.rewardFlag;
  $rootScope.rewardFlag = null;
  var description = '';
  $rootScope.agentPics = null;
  $scope.isShare = true;
  $scope.isGuide = false;
  $scope.isAgent = true;
  $scope.amount = 0;
  Network.loading({agent_ids: $scope.agentId + ''}, "/api/agent_info/addBrowseCount", function(data) {});
  if ($scope.rewardFlag == 1) {
    $ionicModal.fromTemplateUrl("templates/agent/agent-rewardout.html", {
      scope: $scope,
      animation: "slide-in-up"
    }).then(function(modal) {
      $scope.rewardListModal = modal;
      getRewardList();
    });

    $ionicModal.fromTemplateUrl("templates/agent/agent-rewardresultout.html", {
      scope: $scope,
      animation: "slide-in-up"
    }).then(function(modal) {
      $scope.rewardModal = modal;
    });

    $scope.rewardRule = function() {
      $ionicPopup.alert({
        title: "红包规则",
        template: Constants.rewardRuleString
      });
    };

    /**
     *  取得红包列表
     */
    var getRewardList = function() {
      var userId;
      CheckLogin.checkLogin(function(res) {
        if (res != null) {
          userId = res;
          var rewardJson = {
            agent_ids: $scope.agentId,
            user_ids: $rootScope.userIds
          };
          $ionicLoading.show({
            template: "努力加载中...",
            duration: 30000,
            noBackdrop: true,
            hideOnStateChange: true
          });
          //机构红包列表获取
          Network.loading(rewardJson, "/api/reward_info/getRewardInfoListByAgentIds", function(data) {
            $scope.rewards = data.data;
            if (!$scope.rewards || $scope.rewards.length == 0) {
              $cordovaToast.showShortCenter('红包都已抢过或无红包');
              $scope.closeModalDetail();
            } else {
              $scope.rewardListModal.show();
            }
          });
        } else {
          $cordovaToast.showShortCenter('请登录后，再来抢红包');
        }
      });
    };

    $scope.onSwipeRight = function() {
      return false;
    };

    /**
     *  抢红包
     */
    $scope.clickredpacket = function(rewardId, agentName) {
      $scope.shareRewardIds = rewardId;
      $scope.shareAgentName = agentName;
      CheckLogin.checkLogin(function(res) {
        if (res != null) {
          userId = res;
          var json = {
            reward_ids: rewardId,
            user_ids: $rootScope.userIds
          };
          var apiUrl = '/api/user_reward_detail/robReward';
          $ionicLoading.show({
            template: "努力加载中...",
            duration: 30000,
            noBackdrop: true,
            hideOnStateChange: true
          });

          Network.loading(json, apiUrl, function(data) {
            $scope.rewardModal.show();
            $scope.rewardagent = data.data.userRewardDetail;
            console.log(data);
          });
        }
      });
    };

    /**
     *  关闭红包页面
     */
    $scope.closeModalDetail = function() {
      $scope.rewardListModal.hide();
      $scope.rewardModal.hide();
    };

  }

  /**
   * 机构详情信息获取
   */
  var userId;
  CheckLogin.checkLogin(function(res) {
    if (res != null) {
      userId = res;
    }
    ////////////////////////////////////机构详情获取///////////////////////////
    var courseJson = {
      user_ids: $rootScope.userIds,
      ids: $scope.agentId
    };
    $ionicLoading.show({
      template: "努力加载中...",
      duration: 30000,
      noBackdrop: true,
      hideOnStateChange: true
    });
    //机构详情获取
    Network.loading(courseJson, "/api/agent_info/getAgentInfoByIds", function(data) {
      $scope.agentInfo = data.data;
      console.log($scope.agentInfo);
      description = $scope.agentInfo.instruction;
      if ($scope.agentInfo.favorite_ids) {
        $scope.favoriteIds = $scope.agentInfo.favorite_ids;
        $scope.collectTitle = '取消收藏';
      } else {
        $scope.collectTitle = '收藏';
      }
    });
  });
  
  /**
   *  关闭红包列表页
   */
  $scope.rewardModalHide = function() {
    $scope.rewardListModal.hide();
  };
  /**
   *  红包详情页回退
   */
  $scope.agentrewardModal = function() {
    getRewardList();
    $scope.rewardModal.hide();
  };

  /**
   *  右上角分享
   */
  $scope.share = function(shareId, type) {
    Share.ActionSheetShare("/www/images/share.png", $scope.agent_name, description, shareId, type, $scope.shareAgentName, function(res) {
      if (res == 1) {
        agentreward();
      }
    });
  };

  /**
   *  分享后积分增加
   */
  function agentreward() {
    if ($rootScope.userIds != null) {
      Network.loading({
        ids: $rootScope.userIds,
        point: Constants.pointcode
      }, "/api/user/addPointForUser", function(data) {
        $cordovaToast.showShortCenter('感谢您的分享');
      });
    }
  }

  /**
   *  点击收藏
   */
  $scope.agentCollect = function(agentId) {
    var json;
    CheckLogin.checkLogin(function(res) {
      if (res != null) {
        if ($scope.favoriteIds) {
          json = {
            user_ids: res,
            favorite_ids: $scope.favoriteIds
          };
          $ionicLoading.show({
            template: "努力加载中...",
            duration: 30000,
            noBackdrop: true,
            hideOnStateChange: true
          });
          //取消收藏
          Network.loading(json, "/api/user_favorite/cancelUserFavorite", function(data) {
            $scope.favoriteIds = null;
            $scope.agentInfo.favorite_ids = null;
            $scope.collectTitle = '收藏';
            $ionicLoading.show({
              template: "您已成功取消收藏！",
              duration: 2000,
              noBackdrop: true,
              hideOnStateChange: true
            });
          });
        } else {
          json = {
            user_ids: res,
            agent_ids: agentId,
            course_ids: '',
            favorite_type: '1'
          };
          $ionicLoading.show({
            template: "努力加载中...",
            duration: 30000,
            noBackdrop: true,
            hideOnStateChange: true
          });
          //收藏
          Network.loading(json, "/api/user_favorite/InsertUserFavorite", function(data) {
            $scope.favoriteIds = data.data.favorite_ids;
            $scope.agentInfo.favorite_ids = data.data.favorite_ids;
            $scope.collectTitle = '取消收藏';
            $ionicLoading.show({
              template: "您已成功收藏！",
              duration: 2000,
              noBackdrop: true,
              hideOnStateChange: true
            });
          });
        }
      } else {
        $scope.collectTitle = '收藏';
        if ($scope.tabType == 1) {
          $state.go('tab.clogin');
        } else if ($scope.tabType == 2) {
          $state.go('tab.alogin');
        } else if ($scope.tabType == 3) {
          $state.go('tab.nlogin');
        } else if ($scope.tabType == 4) {
          $state.go('tab.login');
        }
      }
    });
  };

  /**
   *  开启model
   */
  $scope.openModal = function() {
    $scope.modal.show();
  };
  $scope.closeModal = function() {
    $scope.modal.hide();
  };
  $scope.backRedPacket = function() {
    $scope.modal2.hide();
    $scope.modal.show();
  };

  /**
   *  机构课程列表
   */
  $scope.courseList = function() {
    window.tabs('ChatsCtrl');
  };
  /**
   *  机构路由chose
   */
  $scope.select = function(index, agentId, type, distance) {
    switch (index) {
      case 0:
        {
          if ($scope.tabType == 1) {
            $state.go("tab.course-agent-course", {
              'agentId': agentId,
              'tabType': $scope.tabType
            });
          } else if ($scope.tabType == 2) {
            $state.go("tab.agent-course", {
              'agentId': agentId,
              'tabType': $scope.tabType,
              'distance': distance
            });
          } else if ($scope.tabType == 4) {
            $state.go("tab.user-agent-course", {
              'agentId': agentId,
              'tabType': $scope.tabType
            });
          }
        }
        break;
      case 1:
        {
          if ($scope.tabType == 1) {
            $state.go("tab.course-teacher", {
              'agentId': agentId,
              'type': 5
            });
          } else if ($scope.tabType == 2) {
            $state.go("tab.agent-teacher", {
              'agentId': agentId,
              'type': 5
            });
          } else if ($scope.tabType == 4) {
            $state.go("tab.user-teacher", {
              'agentId': agentId,
              'type': 5
            });
          }
        }
        break;
      case 2:
        {
          if ($scope.tabType == 1) {
            $state.go("tab.course-teacher", {
              'agentId': agentId,
              'type': 6
            });
          } else if ($scope.tabType == 2) {
            $state.go("tab.agent-teacher", {
              'agentId': agentId,
              'type': 6
            });
          } else if ($scope.tabType == 4) {
            $state.go("tab.user-teacher", {
              'agentId': agentId,
              'type': 6
            });
          }
        }
        break;
      case 3:
        {
          if ($scope.tabType == 1) {
            $state.go("tab.course-evaluation", {
              'evaluationId': agentId,
              'evaluationType': 2,
              'tabType': $scope.tabType
            });
          } else if ($scope.tabType == 2) {
            $state.go("tab.agent-evaluation", {
              'evaluationId': agentId,
              'evaluationType': 2,
              'tabType': $scope.tabType
            });
          } else if ($scope.tabType == 4) {
            $state.go("tab.user--evaluation", {
              'evaluationId': agentId,
              'evaluationType': 2,
              'tabType': $scope.tabType
            });
          }
        }
        break;
      default:
        break;
    }
  };

  /**
   * 机构详情地图
   */
  $scope.goAgentMap = function(lon, lat, address, name, instruction, identity, distance, grade) {
    if($scope.tabType == 1){
      $state.go("tab.agent-course-map", {
        'lon': lon,
        'lat': lat,
        'address': address,
        'name': name,
        'instruction': instruction,
        'identity': identity,
        'distance': distance,
        'grade': grade
      });
    }
    else if($scope.tabType == 2){
      $state.go("tab.agent-agent-map", {
        'lon': lon,
        'lat': lat,
        'address': address,
        'name': name,
        'instruction': instruction,
        'identity': identity,
        'distance': distance,
        'grade': grade
      });
    }
    else if($scope.tabType == 4){
        $state.go("tab.agent-user-map", {
        'lon': lon,
        'lat': lat,
        'address': address,
        'name': name,
        'instruction': instruction,
        'identity': identity,
        'distance': distance,
        'grade': grade
      });
    }
    
  };
})

/**
 * 机构课程列表
 */
.controller('AgentCourseCtrl', function(Constants, Network, $scope, $state, $stateParams, $rootScope, $cordovaToast) {
  $scope.agentId = $stateParams.agentId;
  $scope.tabType = $stateParams.tabType;
  $scope.agentCourse = $scope;
  $scope.agentCourse.paginated = 1;
  $scope.agentCourse.distance = $stateParams.distance;
  var count = 0;

  /**
   * 切换至课程详情
   */
  $scope.goDtail = function(courseId, tabType, picList) {
    $rootScope.coursePics = picList;
    if (tabType == 1) {
      $state.go("tab.course-detail", {
        'courseId': courseId,
        'tabType': tabType,
        'status': '1'
      });
    } else if (tabType == 2) {
      $state.go("tab.agent-course-detail", {
        'courseId': courseId,
        'tabType': tabType,
        'status': '1'
      });
    } else if (tabType == 4) {
      $state.go("tab.user-course-detail", {
        'courseId': courseId,
        'tabType': tabType,
        'status': '1'
      });
    }
  };

  /**
   * 课程列表加载
   */
  $scope.load_more = function() {
    count = count + 1;
    page = {
      page: count + '',
      count: Constants.pageItem
    };
    var json = {
      agent_ids: $scope.agentId,
      pagination: page
    };
    //机构课程列表获取
    Network.loading(json, "/api/course_info/getCourseInfoListByAgentIds", function(data) {
      console.log(data);
      var courses = data.data;
      $scope.agentCourse.paginated = data.paginated.more;
      if ($scope.courses) {
        $scope.courses = $scope.courses.concat(data.data);
      } else {
        $scope.courses = data.data;
      }
      $scope.$broadcast("scroll.infiniteScrollComplete");
      if (!$scope.courses || $scope.courses.length == 0) {
        $scope.isPrompt = true;
      } else {
        $scope.isPrompt = false;
      }
    });
  };

  /**
   * 课程列表刷新
   */
  $scope.searchCourse = function() {
    page = {
      page: '1',
      count: Constants.pageItem
    };
    var json = {
      agent_ids: $scope.agentId,
      pagination: page
    };
    Network.loading(json, "/api/course_info/getCourseInfoListByAgentIds", function(data) {
      $scope.courses = data.data;
      $scope.agentCourse.paginated = data.paginated.more;
      if (!$scope.courses || $scope.courses.length == 0) {
        $scope.isPrompt = true;
      } else {
        $scope.isPrompt = false;
      }
    });
    $scope.$broadcast("scroll.refreshComplete");
    count = 1;
  };
})


//----------------------------------------------------------------------
// 评价列表controller
//----------------------------------------------------------------------
.controller('EvaluationCtrl', function($ionicModal, $ionicPopover, $ionicLoading, Constants, $scope, $stateParams, Network, $cordovaToast) {
  $scope.evaluationType = $stateParams.evaluationType;
  $scope.evaluationId = $stateParams.evaluationId;
  console.log($scope.evaluationType + "--" + $scope.evaluationId);
  $scope.title = '评价';

  var apiUrl;
  var json;
  var pageNum = '1';
  $scope.isMore = 1;
  $ionicPopover.fromTemplateUrl('my-popover.html', {
    scope: $scope
  }).then(function(popover) {
    $scope.popover = popover;
  });

  $ionicModal.fromTemplateUrl("templates/agent/agent-picture.html", {
    scope: $scope,
    animation: "slide-in-up"
  }).then(function(modal) {
    $scope.modal = modal;
  });

  /**
   * 取得评价列表
   */
  var funEvaList = function() {
    if ($stateParams.evaluationType == 1) {
      $scope.title = '课程评价';
      json = {
        course_ids: $scope.evaluationId + '',
        pagination: {
          page: pageNum + '',
          count: Constants.pageItem
        }
      };
      apiUrl = "/api/evaluate_course/getEvaluateListByCourseIds";
    } else if ($stateParams.evaluationType == 2) {
      $scope.title = '机构评价';
      json = {
        agent_ids: $scope.evaluationId + '',
        pagination: {
          page: pageNum + '',
          count: Constants.pageItem
        }
      };
      apiUrl = "/api/evaluate_agent/getEvaluateListByAgentIds";
    }
    //评价列表获取
    Network.loading(json, apiUrl, function(data) {
      $scope.isMore = data.paginated.more;
      if (pageNum == 1) {
        $scope.evaluateList = data.data.evaluateList;
        console.log($scope.evaluateList);
      } else {
        $scope.evaluateList = $scope.evaluateList.concat(data.data.evaluateList);
      }
      if (!$scope.evaluateList || $scope.evaluateList.length == 0) {
        if ($stateParams.evaluationType == 1) {
          $scope.isPrompt = true;
        } else if ($stateParams.evaluationType == 2) {
          $scope.isPrompt = true;
        }
      } else {
        $scope.isPrompt = false;
      }
      pageNum = parseInt(pageNum) + 1;
      $scope.$broadcast("scroll.refreshComplete");
      $scope.$broadcast("scroll.infiniteScrollComplete");
    });
  };
  
  /**
   *  刷新
   */
  $scope.institutionRefresh = function() {
    pageNum = '1';
    funEvaList();
  };
  /**
   *  加载
   */
  $scope.load_more = function() {
    funEvaList();
  };  
  $scope.openPopover = function(eval,picUrl) {
    $ionicModal.fromTemplateUrl("templates/agent/agent-picture.html", {
                                scope: $scope,
                                animation: "slide-in-up"
                                }).then(function(modal) {
                                  $scope.pictureModal = modal;
                                  $scope.data = eval.pic_b;
                                });
    setTimeout(function() {
                  $scope.pictureModal.show();
               },500);
    console.log($scope.data);
    console.log(picUrl);
    console.log(eval.pic_s.indexOf(picUrl));
  };
  /**
   * 关闭图片大图model
   */
  $scope.closeModal = function() {
  $scope.pictureModal.remove();
  };
})

//----------------------------------------------------------------------
// 机构地图controller
//----------------------------------------------------------------------
.controller('AgentMapCtrl', function($cordovaToast, $scope, $http, $stateParams) {
  var lon = $stateParams.lon;
  var lat = $stateParams.lat;
  var address = $stateParams.address;
  var name = $stateParams.name;
  var distance = $stateParams.distance;
  var instruction = $stateParams.instruction;

  var identity = $stateParams.identity;
  var soce = $stateParams.grade;
  var img = '';
  if (identity == 1) {
    img = '<img src="img/icon-level.svg" style="width:25px;height:14px;" title="认证">';
  } 
  if (distance == null || distance == '') {
    distance = '0';
  }
  var height = window.screen.availHeight;
  $('#allmap').css({
    "height": (height - 64) + "px"
  });

  var map = new BMap.Map("allmap");
  map.addEventListener("tilesloaded", function() {
    $(".BMap_cpyCtrl").hide();
    $("a[target='_blank']").removeAttr("href");
    $("a[target='_blank']").removeAttr("target");
  });
  var point = new BMap.Point(lon, lat);
  map.centerAndZoom(point, 11);
  map.enableScrollWheelZoom(true);
  map.addControl(new BMap.NavigationControl());
  map.addControl(new BMap.ScaleControl());
  map.addControl(new BMap.OverviewMapControl());
  map.disableDoubleClickZoom();
  var marker = new BMap.Marker(point); // 创建标注
  map.addOverlay(marker); // 将标注添加到地图中
  map.panTo(point);
  var grade = '';
  for (var i = 1; i < 6; i++) {
    if (soce >= i) {
      grade = grade + '<a class="icon ion-ios-star energized"></a>';
    } else if (soce < i && soce > (i - 1)) {
      grade = grade + '<a class="icon ion-ios-star-half energized"></a>';
    } else {
      grade = grade + '<a class="icon ion-ios-star-outline energized" ng-repeat="edit in [1,2,3,4,5]" ng-if="edit-course.score>=0.5"></a>';
    }
  }

  var sContent =
    '<h3 style="margin:0 0 5px 0;padding:0.2em 0">' + name + '&nbsp; &nbsp; ' + img + '</i></h3>' +
    '<div class="row">地址：' +
    address + '</div><div class="row">简介：' +
    instruction + '</div>' +
    '<div class="row">评分：' + grade + '</div><div class="row">' +
    '距离：' + distance + 'km</div>';
  var infoWindow = new BMap.InfoWindow(sContent);
  marker.openInfoWindow(infoWindow);
  marker.addEventListener("click", function() {
    this.openInfoWindow(infoWindow);
  });
})

//----------------------------------------------------------------------
// 课程评价、机构评价controller
//----------------------------------------------------------------------
.controller('gotoEvaluationCtrl', function($ionicLoading, $rootScope, Constants, Share, $ionicModal, $cordovaToast, $ionicPopup, $ionicHistory, AppConfig, Common, Network, $cordovaFileTransfer, $cordovaImagePicker, $cordovaCamera, $ionicActionSheet, $stateParams, $scope, $http) {

  var userId = $rootScope.userIds;
  var orderId = $stateParams.orderId;
  var agentId = $stateParams.agentId;
  var courseId = $stateParams.courseId;
  var agentName = $stateParams.agentName;
  var courseName = $stateParams.courseName;
  var namereg = new RegExp(/^([\u4E00-\u9FA5]|[\x00-\x80]|[\uFE30-\uFFA0]|[\u3002\uff1b\uff0c\uff1a\u201c\u201d\uff08\uff09\u3001\uff1f\u300a\u300b]|[\x21-\x7e]|\s)*$/);

  $scope.images1 = "img/jiahao.png";
  $scope.images2 = "img/jiahao.png";
  $scope.images3 = "img/jiahao.png";
  $scope.images4 = "img/jiahao.png";
  $scope.images5 = "img/jiahao.png";
  $scope.images6 = "img/jiahao.png";

  $scope.evaluation = $scope;
  $scope.evaluation.agent_evaluation = null;
  $scope.evaluation.course_evaluation = null;
  $scope.isAgent = false;

  var courseSmallPic = [];
  var agentSmallPic = [];
  var courseBigPic = [];
  var agentBigPic = [];
  //评价标签获取
  Network.loading({}, "/api/mst_code/getEvaluateTagList", function(data) {
    $scope.agentList = data.data.agent_evaluate_list;
    $scope.courseList = data.data.course_evaluate_list;
  });

  /**
   *  星级评分
   */
  $scope.grade = function(id, qianzhui) {
    var gradeClass = '';
    if (qianzhui == 'a') {
      gradeClass = 'course_grade';
    } else {
      gradeClass = 'agent_grade';
    }
    for (var i = 1; i < 6; i++) {
      if (i <= id) {
        $("#" + qianzhui + i).removeClass('ion-ios-star-outline').addClass('ion-ios-star ' + gradeClass);
      } else {
        $("#" + qianzhui + i).removeClass('ion-ios-star ' + gradeClass).addClass('ion-ios-star-outline');
      }
    }
  };

  /**
   *  评价标签
   */
  $scope.label = function(id, type) {

    var card = '';
    var classType = '';
    if (type == 'c') {
      classType = 'course_label';
      //card = "card course eva_label ng-binding activated";
    } else {
      classType = 'agent_label';
      //card = "card agent eva_label ng-binding activated";
    }
      var lb = $("#" + type + id);
      if(lb.hasClass("active")){
          lb.removeClass("active").removeClass(classType);
      }else{
          lb.addClass("active").addClass(classType);
      }
/*    var css = $("#" + type + id).attr('class');
    if ($.trim(css) == $.trim(card)) {
      $("#" + type + id).addClass('positive-bg light ' + classType);
    } else {
      $("#" + type + id).removeClass('positive-bg light ' + classType);
    }*/
  };

/**
   * 调取手机选择照片、拍照
   */
  var funAppendByCamera = function(sourceType, num) {
    var options = {
      quality: 100,
      destinationType: 1,
      sourceType: sourceType,
      allowEdit: false,
      encodingType: 0,
      targetWidth: 800,
      targetHeight: 800,
      correctOrientation: true,
      popoverOptions: CameraPopoverOptions,
      saveToPhotoAlbum: false
    };
    $cordovaCamera.getPicture(options)
      .then(function(results) {
        if (num == 1) {
          $scope.images1 = results;
        } else if (num == 2) {
          $scope.images2 = results;
        } else if (num == 3) {
          $scope.images3 = results;
        } else if (num == 4) {
          $scope.images4 = results;
        } else if (num == 5) {
          $scope.images5 = results;
        } else if (num == 6) {
          $scope.images6 = results;
        }
        //图片上传
        var apiUrl = AppConfig.getConfig().BASE_API + "/api/evaluate_course/imageUpload";
        var header = Common.commonHeaders(apiUrl, null);
        var fileName = results.substr(results.lastIndexOf('/') + 1);
        if (!ionic.Platform.isIOS() && fileName.lastIndexOf('?') > 0) {
          fileName = fileName.substr(0, fileName.lastIndexOf('?'));
        }

        var options = {
          "fileKey": "file",
          "fileName": fileName,
          "mimeType": "image/jpeg",
          params: {
            "ids": $rootScope.userIds
          },
          headers: header
        };

        $cordovaFileTransfer.upload(apiUrl, results, options)
          .then(function(result) {
            var picJson = JSON.parse(result.response);
            // var picJson = eval("(" + result.response + ")");
            if (num == 1 || num == 2 || num == 3) {
              courseSmallPic.push(picJson.data.small_image);
              var coupicJson = {bigImage:picJson.data.big_image, width:picJson.data.destw, height:picJson.data.desth}
              courseBigPic.push(picJson);
            } else {
              var agentpicJson = {bigImage:picJson.data.big_image, width:picJson.data.destw, height:picJson.data.desth}
              agentSmallPic.push(picJson.data.small_image);
              agentBigPic.push(agentpicJson);
            }
          }, function(err) {
              $cordovaToast.showShortCenter(err);
          }, function(progress) {});
      },function(error) {
        if(error == 'Unable to retrieve path to picture!'){
          $cordovaToast.showShortCenter('请上传png,jpg格式的图片');
        }
        console.error(error);
      });
  };

  /**
   *  选择照片
   */
  $scope.getPhoto = function(number) {
    var num = number;
    $ionicActionSheet.show({
      buttons: [
          {text: '<div class="top-icon energized-bg"><i class="ion-ios-camera white"></i></div><div class="bottom-text">相机</div>'},
          {text: '<div class="top-icon balanced-bg"><i class="ion-images white"></i></div><div class="bottom-text">图库</div>'}
      ],
      titleText: '选择照片',
      cancelText: '关闭',
      cancel: function() {
        return true;
      },
      buttonClicked: function(index) {
        switch (index) {
          case 0:
            funAppendByCamera(1, num);
            break;
          case 1:
            funAppendByCamera(0, num);
            break;
          default:
            break;
        }
        return true;
      }
    });
  };

  /**
   * 保存评价信息
   */
  var hideSheet = null;
  $scope.save = function() {
    var agentList = [];
    var agentLabel = $('.agent_label');
    if (agentLabel) {
      for (var i = 0; i < agentLabel.length; i++) {
        agentList.push($(agentLabel[i]).html());
      }
    }

    var courseList = [];
    var courseLabel = $('.course_label');
    if (courseLabel) {
      for (var j = 0; j < courseLabel.length; j++) {
        courseList.push($(courseLabel[j]).html());
      }
    }

    var agentGrade = $('.agent_grade').length;
    var courseGrade = $('.course_grade').length;
    if (agentGrade == 0 && courseGrade == 0) {
      $cordovaToast.showShortCenter('请评价机构或课程');
      return false;
    }
    if (agentGrade != 0 ) {
      if(($scope.evaluation.agent_evaluation == '' || $scope.evaluation.agent_evaluation == null) && agentList.length == 0){
        $cordovaToast.showShortCenter('请选择评价标签或者输入评价内容');
        return false;
      }
      // if(namereg.test($scope.evaluation.agent_evaluation) != true){
      //   $cordovaToast.showShortCenter('输入内容有误，请重新输入');
      //   return false;
      // }
    }
    if (courseGrade != 0 ) {
      if(($scope.evaluation.course_evaluation == '' || $scope.evaluation.course_evaluation == null) && courseList.length == 0){
        $cordovaToast.showShortCenter('请选择评价标签或者输入评价内容');
        return false;
      }
      // if(namereg.test($scope.evaluation.course_evaluation) != true){
      //   $cordovaToast.showShortCenter('输入内容有误，请重新输入');
      //   return false;
      // }
    }
    var evaluationJson = {
      agent_ids: agentId,
      course_ids: courseId,
      user_ids: userId,
      order_ids: orderId,
      evaluate_content_course: $scope.evaluation.course_evaluation,
      evaluate_content_agent: $scope.evaluation.agent_evaluation,
      evaluate_agent: agentGrade,
      evaluate_course: courseGrade,
      evaluate_tag_course: courseList,
      evaluate_tag_agent: agentList,
      course_small_path: courseSmallPic,
      course_big_path: courseBigPic,
      agent_small_path: agentSmallPic,
      agent_big_path: agentBigPic
    };
    $ionicLoading.show({
        template: '请稍候...',
        duration: 10000
      });
    // 插入评价
    Network.loading(evaluationJson, '/api/evaluate_course/insertEvaluate', function(data) {
        $ionicLoading.hide();
        if (data.data.evaluate_course_ids) {
          $scope.shareTitle = courseName;
          $scope.content_des = $scope.evaluation.course_evaluation;
          $scope.shareId = "courseId=" + data.data.evaluate_course_ids;
        } else {
          $scope.shareTitle = agentName;
          $scope.content_des = $scope.evaluation.agent_evaluation;
          $scope.shareId = "agentId=" + data.data.evaluate_agent_ids;
        }
        hideSheet = $ionicActionSheet.show({
        buttons: [
            {text: '<div class="top-icon calm-bg"><i class="custom-share-icon"><img src="img/qzone.svg"></i></div><div class="bottom-text">QQ空间</div>'},
            {text: '<div class="top-icon balanced-bg"><i class="fa fa-weixin white"></i></div><div class="bottom-text">微信</div>'},
            {text: '<div class="top-icon energized-bg"><i class="ion-aperture white"></i></div><div class="bottom-text">朋友圈</div>'},
            {text: '<div class="top-icon assertive-bg"><i class="fa fa-weibo white"></i></div><div class="bottom-text">新浪微博</div>'}
        ],
        destructiveText: '评价提交成功，将评价内容及课程信息分享可获得一次抢红包机会！',//destructiveText: '删除的(可取消不写)',
        titleText: '分享至',
        cancelText: '取消',
        cancel: function() {
          return $ionicHistory.goBack();
        },
        buttonClicked: function(index) {
          switch (index) {
            case 0:
              $scope.QQshare();
              break;
            case 1:
              $scope.Wecharshare();
              break;
            case 2:
              $scope.weshare();
              break;
            case 3:
              $scope.Weiboshare();
              break;
            default:
              break;
          }
          return true;
        }
      });
    });
  };


  $ionicModal.fromTemplateUrl("templates/agent/agent-rewardout.html", {
    scope: $scope,
    animation: "slide-in-up"
  }).then(function(modal) {
    $scope.rewardListModal = modal;
  });

  /**
   * 分享后增加积分、抢红包
   */
  var funReward = function() {
    Network.loading({
      ids: $rootScope.userIds,
      point: Constants.pointcode
    }, "/api/user/addPointForUser", function(data) {
      $cordovaToast.showShortCenter('感谢您的分享');
    });

    var rewardJson = {
      user_ids: $rootScope.userIds
    };
    Network.loading(rewardJson, "/api/reward_info/getRewardInfoListForShare", function(data) {
      $scope.rewards = data.data;
      if ($scope.rewards != null) {
        $ionicPopup.confirm({
                            title: "分享成功",
                            template: "分享成功是否抢红包",
                            buttons: [
                                      { text: "放弃" },
                                      {text: "<b>抢红包</b>",
                                      type: "button-positive",
                                      onTap: function() {
                                              return true;
                                            }
                                      }
                                     ]
                            })
        .then(function(res) {
                if(res) {
                  if ($rootScope.userIds != null) {
                    $scope.rewardListModal.show();
                    if (!$scope.rewards || $scope.rewards.length == 0) {
                      $cordovaToast.showShortCenter('红包都已抢过或无红包');
                        $scope.rewardListModal.hide();
                        $ionicHistory.goBack();
                    }
                  } else {
                    $cordovaToast.showShortCenter('您未登陆，请登陆后操作');
                  }
                }
              });
      } else {
        $ionicHistory.goBack();
      }
    });
  };

  /**
   * 分享链接
   */

  $scope.QQshare = function() {
    Share.PopupShare("/www/images/share.png", $scope.shareTitle, $scope.content_des, $scope.shareId, 3, 0, $scope.shareAgentName, function(res) {
      if (res == 1) {
        funReward();
      }
    });
  };

  $scope.Wecharshare = function() {
    Share.PopupShare("/www/images/share.png", $scope.shareTitle, $scope.content_des, $scope.shareId, 3, 1, $scope.shareAgentName, function(res) {
      if (res == 1) {
        funReward();
      }
    });
  };

  $scope.Weiboshare = function() {
    Share.PopupShare("/www/images/share.png", $scope.shareTitle, $scope.content_des, $scope.shareId, 3, 3, $scope.shareAgentName, function(res) {
      if (res == 1) {
        funReward();
      }
    });
  };

  $scope.weshare = function() {
    Share.PopupShare("/www/images/share.png", $scope.shareTitle, $scope.content_des, $scope.shareId, 3, 2, $scope.shareAgentName, function(res) {
      if (res == 1) {
        funReward();
      }
    });
  };

  $scope.rewardRule = function() {
    $ionicPopup.alert({
      title: "红包规则",
      template: Constants.rewardRuleString
    });
  };

  $ionicModal.fromTemplateUrl("templates/agent/agent-rewardresultout.html", {
    scope: $scope,
    animation: "slide-in-up"
  }).then(function(modal) {
    $scope.rewardModal = modal;
  });

  /**
   * 评价分享后红包页面回退
   */
  $scope.rewardModalHide = function() {
    $scope.rewardListModal.hide();
    $ionicHistory.goBack();
  };

  $scope.agentrewardModal = function() {
    $scope.rewardModal.hide();
    $ionicHistory.goBack();
  };

  $scope.isEvaluation = true;

  /**
   * 抢红包
   */
  $scope.clickredpacket = function(rewardId, agentName) {
    $scope.shareRewardIds = rewardId;
      $scope.shareAgentName = agentName;
    var json = {
      reward_ids: rewardId,
      user_ids: $rootScope.userIds
    };
    var apiUrl = '/api/user_reward_detail/robReward';

    Network.loading(json, apiUrl, function(data) {
      $scope.rewardagent = data.data.userRewardDetail;
      $scope.rewardListModal.hide();
      $scope.rewardModal.show();
      console.log(data);
    });
  };

  /**
   * 分享后加分
   */
  var evalutreward = function() {
    if ($rootScope.userIds != null) {
      Network.loading({
        ids: userId,
        point: Constants.pointcode
      }, "/api/user/addPointForUser", function(data) {
        $cordovaToast.showShortCenter('感谢您的分享');
      });
    }
  };

  /**
   * 评价后分享
   */
  $scope.share = function(shareId, type) {
    Share.ActionSheetShare("/www/images/share.png", $scope.shareTitle, $scope.content_des, shareId, type, $scope.shareAgentName, function(res) {
      if (res == 1) {
        funReward();
      }
    });
  };
})

//----------------------------------------------------------------------
// 地图：附近机构地图controller
//----------------------------------------------------------------------
.controller('MapCtrl', function($rootScope, Common, $cordovaToast, Network, Constants, $scope, $state, $ionicModal, $window, $ionicLoading, $cordovaGeolocation, $ionicGesture) {
  Common.getGPS(function (){
  
  if($rootScope.area_code == 1102 || $rootScope.area_code == 1101){
    $rootScope.area_name = '北京市';
  }
  if($rootScope.area_code == 1201 || $rootScope.area_code == 1202){
    $rootScope.area_name = '天津市';
  }
  if($rootScope.area_code == 3101 || $rootScope.area_code == 3102){
    $rootScope.area_name = '上海市';
  }
  if($rootScope.area_code == 3101 || $rootScope.area_code == 3102){
    $rootScope.area_name = '上海市';
  }
  var agentList = null;
  var lat = 116.403119 + '';
  var lon = 39.914714 + '';
  //var identity = null;
  var opts = {};
  var height = window.screen.height;
  var grade = '';
  var soce = null;
  var point = null;
  var img = '';

  /**
   * [addClickHandler 百度地图添加标注]
   */
  var addClickHandler = function(content, marker, id, agent) {

    var infoWindow = new BMap.InfoWindow(content, marker.getPosition(), 0); //建议使用 marker来定位，这样infoWindow下面的小箭头会指向 marker的上部
    //infoWindow 打开后的回调方法
    infoWindow.onopen = function(){
      var $b = angular.element(document.querySelector('#' + id)); //转换成angularElement
      //查看详情按钮定义点击事件
      $ionicGesture.on("click", function(){
         Network.loading({ids:agent.ids}, '/api/agent_info/getAgentPic', function(data) {
            $rootScope.agentPics = data.data.data;
            $state.go("tab.agent-agentDetail", {name: agent.agent_name, agentId: agent.ids, distance:agent.distance, tabType: 2});
         });
      }, $b);
    };
    marker.addEventListener("click", function(e) {
      //openInfo(content, e);
      this.openInfoWindow(infoWindow);
    });

  };

  var openInfo = function(content, e) {
    var p = e.target;
    var point = new BMap.Point(p.getPosition().lng, p.getPosition().lat);
    var infoWindow = new BMap.InfoWindow(content, opts); // 创建信息窗口对象 
    map.openInfoWindow(infoWindow, point); //开启信息窗口
  };

  $('#allmap').css({
    "height": height - 64
  });
  var map = new BMap.Map("allmap");
  map.addEventListener("tilesloaded", function() {
    $(".BMap_cpyCtrl").hide();
    $("a[target='_blank']").removeAttr("href");
    $("a[target='_blank']").removeAttr("target");
  });
      map.centerAndZoom($rootScope.area_name, 11);
      map.enableScrollWheelZoom(true);
      map.addControl(new BMap.NavigationControl());
      // map.addControl(new BMap.ScaleControl());
      map.disableDoubleClickZoom();
      map.addControl(new BMap.OverviewMapControl());

      if (latitude != '' && latitude != null) {
        lat = latitude + '';
        lon = longitude + '';
        var pt = new BMap.Point(longitude, latitude);
        var myIcon = new BMap.Icon("img/my.png", new BMap.Size(30,30));
        var marker2 = new BMap.Marker(pt,{icon:myIcon});
        var label2 = new BMap.Label('我的位置',{offset:new BMap.Size(20,-10)});
        label2.setStyle({ padding: "0 5px", color : "#666", fontSize : "12px", height : "20px", lineHeight : "20px", fontFamily: "Microsoft YaHei", borderColor: "#999", borderRadius: "3px", boxShadow: "3px 3px 5px #999" });
        marker2.setLabel(label2);
        marker2.setAnimation(BMAP_ANIMATION_BOUNCE); //跳动的动画
        map.addOverlay(marker2); 
      }
      var mapjson = {
        latitude: lat,
        longitude: lon,
        drift_rate: $rootScope.area_code
      };
      //附近机构list
      Network.loading(mapjson, '/api/agent_info/getAgentListByLatAndLon', function(data) {
        agentList = data.data.data;
        console.log(data.data.data);
        for (var i = 0; i < agentList.length; i++) {
          var identityTemp = agentList[i].identity_flag;
          soce = agentList[i].evaluate_avg;
          if (identityTemp == 1) {
            img = '<img src="img/icon-level.svg" style="width:25px;height:14px;" title="认证">';
          }else{
              img = '';
          }
          for (var k = 1; k < 6; k++) {
            if (soce >= k) {
              grade = grade + '<a class="icon ion-ios-star energized"></a>';
            } else if (soce < k && soce > (k - 1)) {
              grade = grade + '<a class="icon ion-ios-star-half energized"></a>';
            } else {
              grade = grade + '<a class="icon ion-ios-star-outline energized"></a>';
            }
          }
          var p0 = agentList[i].longitude;
          var p1 = agentList[i].latitude;


          var id = 'btn-' + agentList[i].ids;
          var info =
            "<h2 style='margin:10px 0 5px 0;padding:0.2em 0'>" + agentList[i].agent_name + "&nbsp; &nbsp;" + img + "</h2>" +
            '<div style="margin:0;line-height:1.5;font-size:12px;width:100%;white-space:nowrap;">' + agentList[i].address +
            '<br>' +
            '<div class="row row-no-padding"><div class="col">评分:' + grade +'</div><div id="' + id + '" class="col text-right"><button class="button button-small" data-tap-disabled="true">查看详情</button></div></div>';

            if (latitude != '' && latitude != null) {
              info = info + '<div>距离:' + agentList[i].distance + 'km</div>';
            }
          //Todo 注：上面button中的 data-tap-disabled="true" 属性，可以使click事件起作用，否则自定义的click事件会被屏蔽


          var  typeTemp = agentList[i].type;  //1:加盟机构 0:普通机构
          if(typeTemp == 1){
            var pt1 = new BMap.Point(p0,p1);
            var myIcon1 = new BMap.Icon("img/authed.png", new BMap.Size(30,30));
            var marker1 = new BMap.Marker(pt1,{icon:myIcon1});
            var label1 = new BMap.Label(agentList[i].agent_name,{offset:new BMap.Size(20,-10)});
            label1.setStyle({ padding: "0 5px", color : "#666", fontSize : "12px", height : "20px", lineHeight : "20px", fontFamily: "Microsoft YaHei", borderColor: "#999", borderRadius: "3px", boxShadow: "3px 3px 5px #999" });
            marker1.setLabel(label1);
            map.addOverlay(marker1);
            //ToDo agentList[i] 本身的数据是不全面的，需要重新查询数据，具体所需要的数据是根据机构详情页面而定
            addClickHandler(info, marker1, id, agentList[i]);//传递参数，以便在打开机构详情页面的时候使用

            grade = '';
          }else{
            var pt3 = new BMap.Point(p0, p1);
            var myIcon3 = new BMap.Icon("img/unauthed.png", new BMap.Size(30,30));
            var marker3 = new BMap.Marker(pt3,{icon:myIcon3});
            var label3 = new BMap.Label(agentList[i].agent_name,{offset:new BMap.Size(20,-10)});
            label3.setStyle({ padding: "0 5px", color : "#666", fontSize : "12px", height : "20px", lineHeight : "20px", fontFamily: "Microsoft YaHei", borderColor: "#999", borderRadius: "3px", boxShadow: "3px 3px 5px #999" });
            marker3.setLabel(label3);
            map.addOverlay(marker3);

            //ToDo agentList[i] 本身的数据是不全面的，需要重新查询数据，具体所需要的数据是根据机构详情页面而定
            addClickHandler(info, marker3, id, agentList[i]);//传递参数，以便在打开机构详情页面的时候使用
            grade = '';
          }

        }
      });
    });
})
//----------------------------------------------------------------------
// 教师风采、学生风采controller
//----------------------------------------------------------------------
.controller('TeacherCtrl', function(Network, $stateParams, $scope, $ionicModal, $http, $ionicSlideBoxDelegate, $cordovaToast) {
  if ($stateParams.type == 5) {
    $scope.title = '教师风采';
  } else {
    $scope.title = '学生风采';
  }
  var json = {
    agent_ids: $stateParams.agentId,
    pic_type: $stateParams.type
  };
  //风采图片获取
  var apiUrl = "/api/picture_agent/getPictureListForShowByAgentIds";
  Network.loading(json, apiUrl, function(data) {
    $scope.data = data.data.data.picture_list;
    if (!$scope.data || $scope.data.length == 0) {
      $cordovaToast.showShortCenter('暂无图片观看');
    }
  });
  /////////////////////////////////////////////////////////////////////////
  /**
   *  查看图片大图
   */
  $scope.look = function(number2) {
    $scope.number = $scope.data.indexOf(number2);
    $ionicModal.fromTemplateUrl("templates/agent/agent-picture.html", {
      scope: $scope,
      animation: "slide-in-up"
    }).then(function(modal) {
      $scope.modal = modal;
      $scope.modal.show();
    });
  };
  /**
   * 关闭图片大图model
   */
  $scope.closeModal = function() {
    $scope.modal.remove();
    $scope.modal = null;
  };
});