angular.module('starter.courseController', [])

//----------------------------------------------------------------------
// 课程列表Controller
//----------------------------------------------------------------------
.controller('CourseCtrl', function($ionicScrollDelegate, $interval, $ionicLoading, Common, $cordovaToast, $rootScope, $cordovaGeolocation, CheckLogin, $ionicModal, $scope, $state, $http, Constants, Network) {
    $scope.arrow_status = true;
    if (ionic.Platform.isIOS()) {
      $scope.arrow_status = false;
    }

    $scope.$on( "$ionicView.enter", function( scopes, states ) {
    if($rootScope.courseStatus == 1){
      CheckLogin.checkLogin(function(res) {
          if (res != null) {
            var json = {
              ids: res
            };
            // 通讯路径
            var apiUrl = "/api/user/info";
            Network.loading(json, apiUrl, function(data) {
              user = data.data.user_info;
              $rootScope.courseStatus = 0;
              $scope.province_code = user.area_code_1;
              $scope.city_code = user.area_code_2;
              $scope.area_name = user.area_name_2;
              if ($scope.area_name.length > 3) {
                $scope.area_name = $scope.area_name.substr(0, 2);
              }
              $scope.course.paginated = 1;
              var areajson = {
                city_code: $scope.city_code
              };
              Network.loading(areajson, "/api/mst_area/getArea", function(data) {
                $scope.areaList = data.data.data;
                $scope.searchCourse();
              });
            });
          }
        });
    }
  });

  $scope.course = $scope;
  $rootScope.appPage = 1;
  $scope.course_type_1 = null;
  $scope.area = '';
  $scope.sortkey = '1';
  $scope.province = null;
  $scope.course.courseInput = '';
  $scope.course_type = '分类';
  $scope.area = '';
  $scope.course.paginated = 0;
  var courseTypeName;
  var user;
  var count = 0;
  var page = {
    page: count + '',
    count: Constants.pageItem
  };
  var scrollListToTop = function() {
      $ionicScrollDelegate.$getByHandle('courseListScroll').scrollTop();
    };
  // if (db != null) {
    var timer = $interval(function() {
      if(db != null){
        CheckLogin.checkLogin(function(res) {
          if (res != null) {
            var json = {
              ids: res
            };
            // 通讯路径
            var apiUrl = "/api/user/info";
            Network.loading(json, apiUrl, function(data) {
              user = data.data.user_info;
              $scope.province_code = user.area_code_1;
              $scope.city_code = user.area_code_2;
              $scope.area_name = user.area_name_2;
              if ($scope.area_name.length > 3) {
                $scope.area_name = $scope.area_name.substr(0, 2);
              }
              $scope.course.paginated = 1;
              var areajson = {
                city_code: $scope.city_code
              };
              Network.loading(areajson, "/api/mst_area/getArea", function(data) {
                $scope.areaList = data.data.data;
                $rootScope.loginstatus = true;
              });
            });
          } else {
            $scope.province_code = '11';
            $scope.city_code = '1101';
            $scope.area_name = '北京';
            $scope.course.paginated = 1;
            var areajson = {
              city_code: $scope.city_code
            };
            Network.loading(areajson, "/api/mst_area/getArea", function(data) {
              $scope.areaList = data.data.data;
            });
          }
        });
        $interval.cancel(timer);
      }
    }, 100);

  // } else {
  //   $scope.province_code = '11';
  //   $scope.city_code = '1101';
  //   $scope.area_name = '北京';
  //   $scope.course.paginated = 1;
  //   console.log('DB NULL');
  //   var areajson = {
  //     city_code: $scope.city_code
  //   };
  //   Network.loading(areajson, "/api/mst_area/getArea", function(data) {
  //     $scope.areaList = data.data.data;
  //   });
  // }
          /**
         * 上拉加载
         */
        $scope.load_more = function() {
          $ionicLoading.show({
            template: '努力加载中...',
            duration: 20000
          });
          count = count + 1;
          page = {
            page: count + '',
            count: Constants.pageItem
          };
          var json = {
            pagination: page,
            condition: $scope.course.courseInput,
            // city: $('#cityAll').find("option:selected").val,
            city: $scope.city_code + '',
            courseType1: $scope.course_type1 + '',
            courseType2: $scope.course_type2 + '',
            courseType3: $scope.course_type3 + '',
            province: $scope.province_code + '',
            area: $scope.area + '',
            latitude: latitude,
            longitude: longitude,
            sortkey: $scope.sortkey
          };
          // 通讯路径
          Network.loading(json, "/api/course_info/getCourseInfoList", function(data) {
            console.log(data);
            $ionicLoading.hide();
            var courses = data.data;
            $scope.course.paginated = data.paginated.more;
            if ($scope.courses) {
              $scope.courses = $scope.courses.concat(data.data);
            } else {
              $scope.courses = data.data;
            }
            $scope.$broadcast("scroll.infiniteScrollComplete");
          });
        };
  /**
   * 课程列表检索
   */
  $scope.searchCourse = function() {
    // Common.getGPS(function(){
        if ($scope.sortkey == 2) {
        if (latitude == null || longitude == null) {
          $cordovaToast.showShortCenter('请开启GPS');
          return false;
        }
      }
      $ionicLoading.show({
            template: '努力加载中...',
            duration: 20000
          });
      count = 1;
      page = {
        page: count + '',
        count: Constants.pageItem
      };
      var json = {
        pagination: page,
        condition: $scope.course.courseInput,
        city: $scope.city_code + '',
        courseType1: $scope.course_type1 + '',
        courseType2: $scope.course_type2 + '',
        courseType3: $scope.course_type3 + '',
        province: $scope.province_code + '',
        area: $scope.area + '',
        latitude: latitude,
        longitude: longitude,
        sortkey: $scope.sortkey
      };
      // 通讯路径
      var apiUrl = "/api/course_info/getCourseInfoList";
      Network.loading(json, apiUrl, function(data) {
        console.log(data);
        scrollListToTop();
        $ionicLoading.hide();
        $scope.courses = data.data;
        $scope.course.paginated = data.paginated.more;
        if (!$scope.courses || $scope.courses.length == 0) {
          $cordovaToast.showShortCenter('无此类课程，请更换条件或关键字重试');
        }
      });
    // });
  };

  /**
   * 下拉刷新
   */
  $scope.courseRefresh = function() {
    $scope.searchCourse();
    $scope.$broadcast("scroll.refreshComplete");
  };


  /**
   * 课程详细画面迁移
   */
  $scope.goDtail = function(courseId, tabType, coursePics, agentId) {
    $rootScope.coursePics = coursePics;
    $state.go('tab.course-detail', {
      'courseId': courseId,
      'agentId': agentId,
      'tabType': tabType
    });
  };
  if($rootScope.provinceList){
    $scope.provinceList = $rootScope.provinceList;
  }else{
    Network.loading({}, "/api/mst_area/getProvince", function(data) {
      $scope.provinceList = data.data.data;
    });
  }



  var provinceIds;
  var provinceName;
  var cityIds;
  var cityName;
  var province_code;
  var city_code;
  /**
   * 选择区域
   */
  $scope.choseArea = function() {
    if(user){
      if(provinceIds == null){
        provinceIds = user.area_code_1
      }
      if(cityIds == null){
        cityIds = user.area_code_2;
      }
    }else{
      if(provinceIds == null){
        provinceIds = '11';
      }
      if(cityIds == null){
        cityIds = '1101';
      }
    }
    province_code = $scope.province_code;
    city_code = $scope.city_code;

    $ionicModal.fromTemplateUrl("templates/course/course_area.html", {
      scope: $scope,
      animation: "slide-in-up"
    }).then(function(modal) {
      $scope.areaModal = modal;
      $scope.areaModal.show();
    });

    //机构分类选择
    $scope.cityList = null;
    var json = {
      province_code: provinceIds + ''
    };
    Network.loading(json, "/api/mst_area/getCity", function(data) {
      $scope.cityList = data.data.data;
    });
  };

  /**
   * 取得区域列表
   */
  $scope.getCodeList = function(code, callBack) {
    var json = {
      province_code: code
    };
    Network.loading(json, url, function(data) {
      console.log(data.data.data);
      callBack(data.data.data);
    });
  };

  /**
   * 取得市区列表
   */
  $scope.getCourseCity = function(provinceId, provinceName) {
    $ionicScrollDelegate.$getByHandle('small').scrollTop();
    city_code = null;
    $(".courseprovince").removeClass('assertive');
    $("#cp" + provinceId).addClass('assertive');
    province_code = provinceId;
    provinceName = provinceName;
    cityName = '';
    $scope.cityList = null;
    var id = provinceId + '';
    var json = {
      province_code: id
    };
    Network.loading(json, "/api/mst_area/getCity", function(data) {
      $scope.cityList = data.data.data;
    });
  };

  /**
   * 取得市区列表
   */
  $scope.getCourseArea = function(cityId, cityNames) {
    $(".city").removeClass('assertive');
    city_code = cityId;
    cityName = cityNames;
    $("#cc" + cityId).addClass('assertive');
  };

  /**
   * 关闭省市区选择画面
   */
  $scope.closeModal = function() {
    $scope.areaModal.remove();
    $scope.province_code = provinceIds;
    $scope.city_code = cityIds;
    province_code = provinceIds;
    city_code = cityIds;
    if (user) {
      if($scope.province_code == null){
        $scope.province_code = user.area_code_1;
      }
      if($scope.city_code == null){
        $scope.city_code = user.area_code_2;
      }
      if(cityName == null){
        $scope.area_name = user.area_name_2;
      }

    }
    else{
      if($scope.province_code == null){
        $scope.province_code = '11';
      }
      if($scope.city_code == null){
        $scope.city_code = '1101';
      }
      if(cityName == null){
        $scope.area_name = '市辖区';
      }
    }
    if ($scope.area_name.length > 3) {
        $scope.area_name = $scope.area_name.substr(0, 2);
      }
    var areajson = {
      city_code: $scope.city_code
    };
    Network.loading(areajson, "/api/mst_area/getArea", function(data) {
      $scope.areaList = data.data.data;
    });
  };

  /**
   * 关闭省市区选择画面
   */
  $scope.areaMessage = function() {

    if (province_code == null || province_code == '') {
      $cordovaToast.showShortCenter('请选择省份');
      return false;
    }
    if (city_code == null || city_code == '') {
      $cordovaToast.showShortCenter('请选择城市');
      return false;
    }
    $scope.areaModal.remove();
    provinceIds = province_code;
    cityIds = city_code;
    $scope.province_code = province_code;
    $scope.city_code = city_code;
    if (cityName != null && cityName != '') {
      $scope.area_name = cityName;
      if ($scope.area_name.length > 3) {
        $scope.area_name = $scope.area_name.substr(0, 2);
      }
    }
    var areajson = {
      city_code: $scope.city_code
    };
    $scope.area = '';
    Network.loading(areajson, "/api/mst_area/getArea", function(data) {
      $scope.areaList = data.data.data;
      $scope.searchCourse();
    });
  };

  // 取得课程分类
  $scope.course_type1 = '';
  $scope.course_type2 = '';
  $scope.course_type3 = '';
  var type1 = '';
  var type2 = '';
  var type3 = '';
  Network.loading({
    pid: '0'
  }, "/api/mst_course_type/getCourseTypeList", function(data) {
    $scope.courseType1List = data.data.data;
  });

  /**
   * 选择课程分类
   */
  $scope.choseCourse = function() {
    $ionicModal.fromTemplateUrl("templates/course/course_type.html", {
      scope: $scope,
      animation: "slide-in-up"
    }).then(function(modal) {
      $scope.courseModal = modal;
      courseTypeName = '分类';
      $scope.courseModal.show();
    });
  };

  /**
   * 选择课程分类
   */
  $scope.getType2 = function(id, pid, name) {
    $ionicScrollDelegate.$getByHandle('smallOne').scrollTop();
    $(".course_type1").removeClass('assertive');
    $("#cou" + id).addClass('assertive');
    type2 = '';
    type3 = '';
    if (id == 'all') {
      type1 = '';
      $scope.courseType2List = '';
      $scope.courseType3List = '';
      courseTypeName = '全部';
    } else {
      type1 = pid + '';
      $scope.courseType2List = '';
      $scope.courseType3List = '';
      courseTypeName = name;
      Network.loading({
        pid: pid + ''
      }, "/api/mst_course_type/getCourseTypeList", function(data) {
        $scope.courseType2List = data.data.data;
        console.log($scope.courseType2List);
      });
    }
  };

  /**
   * 选择课程分类
   */
  $scope.getType3 = function(id, pid, name) {
    $ionicScrollDelegate.$getByHandle('smallTwo').scrollTop();
    type2 = pid + '';
    type3 = '';
    courseTypeName = name;
    $(".course_type2").removeClass('assertive');
    $("#cou" + id).addClass('assertive');
    Network.loading({
      pid: pid + ''
    }, "/api/mst_course_type/getCourseTypeList", function(data) {
      $scope.courseType3List = data.data.data;
      console.log($scope.courseType3List);
    });
  };

  /**
   * 设定课程分类
   */
  $scope.setType3 = function(id, pid, name) {
    $(".course_type3").removeClass('assertive');
    type3 = pid + '';
    courseTypeName = name;
    $("#cou" + id).addClass('assertive');
  };

  /**
   * 关闭课程分类选择画面
   */
  $scope.closeCourseModal = function() {
    $scope.course_type1 = '';
    $scope.course_type2 = '';
    $scope.course_type3 = '';
    type1 = '';
    type2 = '';
    type3 = '';
    $scope.courseType2List = '';
    $scope.courseType3List = '';
    $scope.courseModal.remove();
  };

  /**
   * 关闭课程分类选择画面
   */
  $scope.courseTypeMessage = function() {
    $scope.course_type1 = type1;
    $scope.course_type2 = type2;
    $scope.course_type3 = type3;
    $scope.course_type = courseTypeName;
    $scope.searchCourse();
    $scope.courseModal.remove();
  };
})

//----------------------------------------------------------------------
// 课程详细Controller
//----------------------------------------------------------------------
.controller('CourseDetailCtrl', function(Constants, Share, $ionicPopup, $cordovaSQLite, $cordovaToast, $ionicLoading, CheckLogin, $rootScope, $scope, $state, Network, $http, $ionicModal, $ionicActionSheet, $stateParams) {

  var courseId = $stateParams.courseId;
  var agentId = $stateParams.agentId;
  $scope.tabType = $stateParams.tabType;
  $scope.coursePics = $rootScope.coursePics;
  $rootScope.coursePics = null;
  $rootScope.isHideTab = true;
  $scope.status = $stateParams.status;
  $scope.isShare = false;
  $scope.isShow = false;
  $scope.amount = 0;
  $scope.isAgent = false;
  var userId;
  var courseName;
  var courseDescription;
  console.log($scope.coursePics);
  Network.loading({
    course_ids: courseId + ''
  }, "/api/course_info/addBrowseCount", function(data) {});
  if (window.Connection) {
    if (navigator.connection.type == Connection.WIFI) {
      console.log("wifi");
      $scope.isShow = true;
      console.log($scope.isShow);
    } else {
      $cordovaSQLite.execute(db, 'SELECT * FROM setInfo').then(function(res) {
        console.log(res.rows.item(0));
        if (res.rows.length > 0) {
          if (res.rows.item(0).flag == 0) {
            $scope.isShow = true;
          } else if (res.rows.item(0).flag == 1) {
            $scope.isShow = false;
          }
        } else {
          $scope.isShow = false;
        }
        console.log($scope.isOn);
        console.log($scope.isShow);
      }, function(error) {
        $scope.statusMessage = "Error on checking: " + error.message;
      });
    }
  }

  CheckLogin.checkLogin(function(res) {
    if (res != null) {
      userId = res;
    }
    ////////////////////////////////////课程详情获取///////////////////////////
    // 通讯参数
    var json = {
      user_ids: userId,
      course_ids: courseId
    };
    $ionicLoading.show({
      template: "努力加载中...",
      duration: 30000,
      noBackdrop: true,
      hideOnStateChange: true
    });
    // 通讯路径
    var apiUrl = "/api/course_info/getCourseInfoByCourseIds";
    Network.loading(json, apiUrl, function(data) {
      console.log(data);
      $scope.course = data.data;
      $scope.course.bespeak_count = '预约' + $scope.course.bespeak_count;
      $scope.course.buy_count = '购买' + $scope.course.buy_count;
      $scope.course.favorite_count = '收藏' + $scope.course.favorite_count;
      $scope.telNumber = $scope.course.agent_tel_1;
      courseName = $scope.course.course_name;
      courseDescription = $scope.course.course_summary;
      $scope.agentId = $scope.course.agent_ids;
      if ($scope.course.bespeak_ids) {
        $scope.bespeakIds = $scope.course.bespeak_ids;
        $scope.bespeakTitle = '取消预约';
      } else {
        $scope.bespeakTitle = '预约';
      }
      if ($scope.course.favorite_ids) {
        $scope.favoriteIds = $scope.course.favorite_ids;
        $scope.collectTitle = '取消收藏';
      } else {
        $scope.collectTitle = '收藏';
      }
      // 视频播放
      if($scope.status != 1){
        var player = polyvObject('#plv_24b4f0f7335218bdf7b5728ba61cb14d_2').videoPlayer({
          'vid': $scope.course.course_video,
          'width': "100%",
          'height': "0"
        });
      }else{
        var player = polyvObject('#plv_25b4f0f7335218bdf7b5728ba71cb14d_2').videoPlayer({
          'vid': $scope.course.course_video,
          'width': "100%",
          'height': "0"
        });
      }
    });
    /////////////////////////////////////////////////////////////////////////
  });

  $ionicModal.fromTemplateUrl("templates/agent/agent-rewardout.html", {
    scope: $scope,
    animation: "slide-in-up"
  }).then(function(modal) {
    $scope.rewardListModal = modal;
  });

  $ionicModal.fromTemplateUrl("templates/agent/agent-rewardresultout.html", {
    scope: $scope,
    animation: "slide-in-up"
  }).then(function(modal) {
    $scope.rewardModal = modal;
  });

  /**
   * 红包规则说明
   */
  $scope.rewardRule = function() {
    $ionicPopup.alert({
      title: "红包规则",
      template: Constants.rewardRuleString
    });
  };

  /**
   * 抢红包
   */
  $scope.clickredpacket = function(rewardId, agentName) {
    $scope.shareAgentName = agentName;
    $scope.shareRewardIds = rewardId;
    CheckLogin.checkLogin(function(res) {
      if (res != null) {
        userId = res;
      }
      var json = {
        reward_ids: rewardId,
        user_ids: userId
      };
      var apiUrl = '/api/user_reward_detail/robReward';
      ////////////////////////////////////抢红包///////////////////////////////
      Network.loading(json, apiUrl, function(data) {
        $scope.rewardagent = data.data.userRewardDetail;
        $scope.rewardListModal.hide();
        $scope.rewardModal.show();
        console.log(data);
      });
      /////////////////////////////////////////////////////////////////////////
    });
  };

  /**
   * 课程收藏／取消
   */
  $scope.collect = function(agentId, courseId) {
    CheckLogin.checkLogin(function(res) {
      if (res != null) {
        var json = {};
        if ($scope.favoriteIds) {
          // 通讯参数
          json = {
            user_ids: res,
            favorite_ids: $scope.favoriteIds
          };
          Network.loading(json, "/api/user_favorite/cancelUserFavorite", function(data) {
            console.log(data);
            if (data.status.succeed == 1) {
              $scope.favoriteIds = null;
              $scope.course.favorite_ids = null;
              $scope.collectTitle = '收藏';
              $ionicLoading.show({
                template: "您已成功取消收藏！",
                duration: 2000,
                noBackdrop: true,
                hideOnStateChange: true
              });
            } else {
              $ionicLoading.show({
                template: "发生未知错误，取消收藏失败",
                duration: 2000,
                noBackdrop: true,
                hideOnStateChange: true
              });
            }
          });
        } else {
          // 通讯参数
          json = {
            user_ids: res,
            agent_ids: agentId,
            course_ids: courseId,
            favorite_type: '2'
          };
          Network.loading(json, "/api/user_favorite/InsertUserFavorite", function(data) {
            console.log(data);
            if (data.status.succeed == 1) {
              $scope.favoriteIds = data.data.favorite_ids;
              $scope.course.favorite_ids = data.data.favorite_ids;
              $scope.collectTitle = '取消收藏';
              $ionicLoading.show({
                template: "您已成功收藏",
                duration: 2000,
                noBackdrop: true,
                hideOnStateChange: true
              });
            } else {
              $ionicLoading.show({
                template: "发生未知错误，取消收藏失败",
                duration: 2000,
                noBackdrop: true,
                hideOnStateChange: true
              });
            }
          });
        }
      } else {
        $scope.collectTitle = '收藏';
        if ($scope.tabType == 1) {
          $state.go('tab.clogin');
        } else if ($scope.tabType == 2) {
          $state.go('tab.alogin');
        } else if ($scope.tabType == 3) {
          $state.go('tab.nlogin');
        } else if ($scope.tabType == 4) {
          $state.go('tab.login');
        }
      }
    });
  };

  /**
   * 机构详细页面迁移
   */
  $scope.goInstitutionDtail = function(agentId, tabType, agentPics, name) {
    $rootScope.agentPics = agentPics;
    if (tabType == 1) {
      $state.go('tab.course-agentDetail', {
        'agentId': agentId,
        'tabType': tabType,
        'name': name
      });
    } else if (tabType == 2) {
      $state.go('tab.agent-agentDetail', {
        'agentId': agentId,
        'tabType': tabType,
        'name': name
      });
    } else if (tabType == 4) {
      $state.go('tab.user-agentDetail', {
        'agentId': agentId,
        'tabType': tabType,
        'name': name
      });
    }
  };

  /**
   * 课程预约／取消
   */
  var pop;
  $scope.bespeak = function(courseId, agentId) {
    CheckLogin.checkLogin(function(res) {
      if (res != null) {
        var json = {};
        if ($scope.bespeakIds) {
          // 通讯参数
          json = {
            user_ids: res,
            bespeak_ids: $scope.bespeakIds
          };
          Network.loading(json, "/api/user_bespeak/cancelUserBespeak", function(data) {
            console.log(data);
            if (data.status.succeed == 1) {
              $scope.bespeakIds = null;
              $scope.bespeakTitle = '预约';
              $ionicLoading.show({
                template: "您已成功取消预约",
                duration: 2000,
                noBackdrop: true,
                hideOnStateChange: true
              });
            } else {
              $ionicLoading.show({
                template: "发生未知错误，取消预约失败",
                duration: 2000,
                noBackdrop: true,
                hideOnStateChange: true
              });
            }
          });
        } else {
          // 通讯参数
          json = {
            user_ids: res,
            agent_ids: agentId,
            course_ids: courseId
          };
          Network.loading(json, "/api/user_bespeak/InsertUserBespeak", function(data) {
            console.log(data);
            if (data.status.succeed == 1) {
              $scope.bespeakIds = data.data.bespeak_ids;
              $scope.bespeakTitle = '取消预约';
              $scope.share(courseId, 5);
            } else {
              $ionicLoading.show({
                template: "发生未知错误，预约失败",
                duration: 2000,
                noBackdrop: true,
                hideOnStateChange: true
              });
            }
          });
        }
      } else {
        if ($scope.tabType == 1) {
          $state.go('tab.clogin');
        } else if ($scope.tabType == 2) {
          $state.go('tab.alogin');
        } else if ($scope.tabType == 3) {
          $state.go('tab.nlogin');
        } else if ($scope.tabType == 4) {
          $state.go('tab.login');
        }
      }
    });
  };

  /**
   * 分享后抢红包
   */
  var beakreward = function() {
    if (userId != null) {
      Network.loading({
        ids: userId,
        point: Constants.pointcode
      }, "/api/user/addPointForUser", function(data) {
        pop.close();
        $cordovaToast.showShortCenter('感谢您的分享');
      });
      var rewardJson = {
        user_ids: userId
      };
      Network.loading(rewardJson, "/api/reward_info/getRewardInfoListForShare", function(data) {
        $scope.rewards = data.data;
        if ($scope.rewards != null || $scope.rewards.size != 0) {
          $ionicPopup.confirm({
                              title: "分享成功",
                              template: "分享成功是否抢红包",
                              buttons: [
                                        { text: "放弃" },
                                        {text: "<b>抢红包</b>",
                                        type: "button-positive",
                                        onTap: function() {
                                                return true;
                                              }
                                        }
                                       ]
                              })
          .then(function(res) {
                  if(res) {
                    $scope.rewardListModal.show();
                    if (!$scope.rewards || $scope.rewards.length == 0) {
                      $cordovaToast.showShortCenter('红包都已抢过或无红包');
                        $scope.rewardListModal.hide();
                    }
                  }
                });
        }
      });
    }
  };

  /**
   * 分享
   */
  var url = Constants.downloadURL();
  $scope.QQshare = function() {
    Share.QQshare("", courseName, courseDescription, url, function(res) {
      if (res == 1) {
        beakreward();
      }
    });
  };
  $scope.Wecharshare = function() {
    Share.Wecharshare("", courseName, courseDescription, url, function(res) {
      if (res == 1) {
        beakreward();
      }
    });
  };
  $scope.Weiboshare = function() {
    Share.Weiboshare("", courseName, courseDescription, url, function(res) {
      if (res == 1) {
        beakreward();
      }
    });
  };
  $scope.weshare = function() {
    Share.weshare("", courseName, courseDescription, url, function(res) {
      if (res == 1) {
        beakreward();
      }
    });
  };

  /**
   * 红包页面隐藏
   */
  $scope.rewardModalHide = function() {
    $scope.rewardListModal.hide();
  };

  /**
   * 机构红包页面
   */
  $scope.agentrewardModal = function() {
    $scope.rewardModal.hide();
  };

  /**
   * 查看评价
   */
  $scope.evaluationClick = function(courseId, tabType) {
    if ($scope.tabType == 1) {
      $state.go("tab.course-evaluation", {
        'evaluationId': courseId,
        'evaluationType': 1,
        'tabType': $scope.tabType
      });
    } else if ($scope.tabType == 2) {
      $state.go("tab.agent-evaluation", {
        'evaluationId': courseId,
        'evaluationType': 1,
        'tabType': $scope.tabType
      });
    } else if ($scope.tabType == 4) {
      $state.go("tab.user--evaluation", {
        'evaluationId': courseId,
        'evaluationType': 1,
        'tabType': $scope.tabType
      });
    }
  };

  /**
   * 点击分享
   */
  $scope.share = function(shareId, type) {
    Share.ActionSheetShare("/www/images/share.png", $scope.course.course_name, courseDescription, shareId, type, $scope.shareAgentName, function(res) {
      if (res == 1) {
        if (type == 5) {
          beakreward();
        } else {
          sharePoint();
        }
      }
    });
  };

  /**
   *  分享后积分增加
   */
  function sharePoint() {
    if (userId != null) {
      Network.loading({
        ids: userId,
        point: Constants.pointcode
      }, "/api/user/addPointForUser", function(data) {
        $cordovaToast.showShortCenter('感谢您的分享');
      });
    }
  };

  /**
   * 点击分享
   */
  $scope.goAffirmPage = function(courseId, name, price, agentId) {
    if (navigator.connection.type == Connection.NONE) {
      $cordovaToast.showShortCenter('网络异常，请检查网络');
      return false;
    }
    CheckLogin.checkLogin(function(res) {
      if (res != null) {
        if ($scope.tabType == 1) {
          $state.go('tab.course-pay', {
            courseid: courseId,
            userid: res,
            name: name,
            price: price,
            agentid: agentId
          });
        } else if ($scope.tabType == 2) {
          $state.go('tab.agent-course-pay', {
            courseid: courseId,
            userid: res,
            name: name,
            price: price,
            agentid: agentId
          });
        } else if ($scope.tabType == 4) {
          $state.go('tab.user-course-pay', {
            courseid: courseId,
            userid: res,
            name: name,
            price: price,
            agentid: agentId
          });
        }
      } else {
        if ($scope.tabType == 1) {
          $state.go('tab.clogin');
        } else if ($scope.tabType == 2) {
          $state.go('tab.alogin');
        } else if ($scope.tabType == 3) {
          $state.go('tab.nlogin');
        } else if ($scope.tabType == 4) {
          $state.go('tab.login');
        }
      }
    });
  };
})

.controller('PayCtrl', function(Pay, $ionicHistory, $cordovaToast, $stateParams, CheckLogin, Network, Constants, Common, $scope, $state, $ionicPopup) {

  $scope.pay = $scope;
  $scope.reward = Number('0').toFixed(2);
  $scope.showPayText = true;
  $scope.courseId = $stateParams.courseid;
  $scope.name = $stateParams.name;
  $scope.userId = $stateParams.userid;
  $scope.price = $stateParams.price;
  $scope.agentId = $stateParams.agentid;
  $scope.orderId = $stateParams.orderid;
  $scope.pay.paychoose = '0';
  $scope.pay.flag = null;
  $scope.pay.otherpay = '0';
  $scope.pay.wallet = '';
  $scope.choseReward = 1;

  var payflag = 1;
  var userId = $stateParams.userid;
  var rewardJson = {
    user_ids: $scope.userId + '',
    agent_ids: $scope.agentId + ''
  };

  Network.loading(rewardJson, "/api/user_reward_detail/getCouponRewardListForOrder", function(data) {
    $scope.payreward = data.data;
    $scope.pay.paychoose = '0';
    $scope.pay.rewardNumber = '0+0';
    console.log(data.data);
  });

  var json = {
    ids: userId
  };
  Network.loading(json, "/api/user/getBalance", function(data) {
    $scope.pay.wallet = data.data;
  });

  /**
   * 支付方式的选择
   */
  $scope.select = function(money, price) {
    if ($scope.pay.paychoose == '1') {
      $scope.pay.showstatus = '1';
      var paymoney = Number(money) + Number($scope.reward);
      if (parseFloat(price) > parseFloat(paymoney)) {
        $scope.pay.money = null;
        $scope.pay.type = null;
        $scope.pay.otherpay = '0';
        $scope.pay.flag = 1;
        $scope.pay.walmoney = $scope.pay.wallet.toFixed(2);
        $cordovaToast.showShortCenter('钱包余额不足,请选择其他支付方式');
        $scope.pay.showstatus = 0;
      } else {
        var actualMoney = price - $scope.reward;
        if (actualMoney <= 0) {
          actualMoney = 0;
        }
        $scope.pay.walmoney = actualMoney.toFixed(2);
        var otherpay_money = (price - $scope.pay.walmoney).toFixed(2);
        $scope.pay.money = '¥' + otherpay_money;
      }
    } else {
      var otherpayMoney = price - $scope.reward;
      if (otherpayMoney <= 0) {
        $scope.showprice = 0;
        $scope.pay.paychoose = '1';
        $scope.pay.money = 0;
        $scope.pay.walmoney = $scope.pay.money.toFixed(2);
        $scope.pay.flag = 0;
      } else {
        var otherpay = ($scope.price - $scope.reward).toFixed(2);
        $scope.showprice = otherpay;
        $scope.pay.money = '¥' + money.toFixed(2);
        $scope.pay.flag = 0;
      }
    }
  };

  /**
   * 抵用券的选择
   */
  $scope.rewardSelect = function(money, price) {
    $scope.pay.paychoose = '0';
    $scope.reward = Number($scope.pay.rewardNumber.substr($scope.pay.rewardNumber.lastIndexOf('+') + 1)).toFixed(2);
    $scope.rewardId = $scope.pay.rewardNumber.substr(0, $scope.pay.rewardNumber.lastIndexOf('+'));
    $scope.pay.flag = 0;
    if(parseFloat($scope.reward) >= parseFloat(price)){
      $scope.pay.paychoose = '1';
      $scope.paychooseshow = 1;
    }
    if(parseFloat($scope.reward) < parseFloat(price)){
      $scope.paychooseshow = 0;
    }
  };

  /**
   * 其它支付方式的选择
   */
  $scope.selectOtherPay = function(money, price) {
    $scope.pay.showstatus = 0;
    if ($scope.pay.otherpay == '3') {
      $scope.pay.type = '微信支付：';
    } else if ($scope.pay.otherpay == '2') {
      $scope.pay.type = '支付宝：';
    }
    var pay = price - (money + $scope.reward);
    var price2;
    if ((price - pay) < 0) {
      price2 = 0;
    } else {
      price2 = (price - money - $scope.reward).toFixed(2);
    }
    $scope.pay.money = '¥' + price2;
  };


  // 通讯路径
  ////////////////////////////////////用户钱包信息///////////////////////////
  $scope.pay = function(courseId, userId, agentId, price, money) {

    if ($scope.pay.paychoose == '0' || $scope.pay.paychoose == null) {
      $cordovaToast.showShortCenter('请选择支付方式');
      return false;
    }
    if ($scope.pay.flag == 1) {
      if ($scope.pay.otherpay == '0' || $scope.pay.otherpay == null) {
        $cordovaToast.showShortCenter('请选择其他支付方式');
        return false;
      }
    }
    $scope.pay.paybutton = 0;

    var aliPay = function(orderId, name, price, callBack) {
      var payJson = {
        out_trade_no: orderId,
        subject: name,
        total_fee: price + ''
      };
      Network.loading(payJson, "/api/payment/alipay", function(data) {
        console.log(data.data);
        alipay.payment(data.data, function(success) {
          var result = JSON.parse(success);
           // eval("(" + success + ")");
           $scope.pay.paybutton = 1;
          if (result.resultStatus == 9000) {
            Network.loading({
              ids: orderId
            }, "/api/payment", function(data) {
              console.log(data);
              $scope.pay.paybutton = 0;
              $cordovaToast.showShortCenter('支付成功');
              callBack('1');
            });
          } else {
            $scope.pay.paybutton = 1;
            $cordovaToast.showShortCenter('支付取消');
            callBack('2');
          }
        }, function(error) {
          $scope.pay.paybutton = 1;
          $cordovaToast.showShortCenter('支付失败');
          callBack('3');
        });
      });
    };

    var updatePayAPI = function(json, callBack) {
      Network.loading(json, "/api/order/updateOrderForPayFinish", function(data) {
        console.log(data);
        callBack();
      });
    };

    var updatepay = function(payflag, money, price, backToOrder) {
      var json;
      var balance;
      if (payflag == 1) {
        var otherpayMoney;
        if ($scope.pay.paychoose == '1') {
          if ($scope.pay.otherpay == '0' || $scope.pay.otherpay == null) {
            //钱包支付
            if ($scope.rewardId == 0 || $scope.rewardId == null) {
              balance = price;
              json = {
                ids: $scope.orderId,
                pay_type: '4',
                balance: balance + ''
              };
            } else {
              balance = (price - $scope.reward).toFixed(2);
              if (balance <= 0) {
                balance = 0;
              }
              json = {
                ids: $scope.orderId,
                pay_type: '4',
                balance: balance + '',
                coupon_ids: $scope.rewardId + '',
                coupon_money: $scope.reward + ''
              };
            }
            console.log(json);
            updatePayAPI(json, function() {
              $cordovaToast.showShortCenter('支付成功');
              backToOrder();
            });
          }
          var otherpay;
          if ($scope.pay.otherpay == '2') {
            //钱包 and 支付宝 支付
            otherpay = (price - money - $scope.reward).toFixed(2);
            aliPay($scope.orderId, $scope.name, otherpay, function(res) {
              $scope.$apply(function() {
                $scope.pay.paybutton = 1;
                console.log("refresh");
              });
              balance = money;
              if ($scope.rewardId == 0 || $scope.rewardId == null) {
                json = {
                  ids: $scope.orderId,
                  pay_type: '6',
                  balance: balance + '',
                  other_pay: otherpay + '',
                  mode: '2'
                };
              } else {
                json = {
                  ids: $scope.orderId,
                  pay_type: '6',
                  balance: balance + '',
                  other_pay: otherpay + '',
                  coupon_ids: $scope.rewardId + '',
                  coupon_money: $scope.reward + '',
                  mode: '2'
                };
              }
              if (res == 1) {
                updatePayAPI(json, function(data) {
                  backToOrder();
                });
              }
            });
          } else if ($scope.pay.otherpay == '3') {
            //钱包 and 微信 支付
            otherpay = (price - money - $scope.reward).toFixed(2);
            Pay.wxPay($scope.orderId, $scope.name, otherpay, function(res) {

              $scope.$apply(function() {
                $scope.pay.paybutton = 1;
                console.log("refresh");
              });

              balance = money;
              if ($scope.rewardId == 0 || $scope.rewardId == null) {
                json = {
                  ids: $scope.orderId,
                  pay_type: '7',
                  balance: balance + '',
                  other_pay: otherpay + '',
                  mode: '2'
                };
              } else {
                json = {
                  ids: $scope.orderId,
                  pay_type: '7',
                  balance: balance + '',
                  other_pay: otherpay + '',
                  coupon_ids: $scope.rewardId + '',
                  coupon_money: $scope.reward + '',
                  mode: '2'
                };
              }
              if (res == 1) {
                $cordovaToast.showShortCenter('支付成功');
                updatePayAPI(json, function(data) {
                  console.log(data);
                  backToOrder();
                });
              } else if (res == 2) {
                $cordovaToast.showShortCenter('支付取消');
              } else if(res == 3){
                $cordovaToast.showShortCenter('支付失败');
              } else {
                $scope.$apply(function() {
                  $scope.pay.paybutton = 1;
                  console.log("refresh");
                });
              }
            });
          }
        } else if ($scope.pay.paychoose == '2') {
          otherpayMoney = Number($scope.price) - Number($scope.reward);
          otherpayMoney = otherpayMoney.toFixed(2);
          if (otherpayMoney <= 0) {
            otherpayMoney = 0;
          }
          Pay.wxPay($scope.orderId, $scope.name, otherpayMoney, function(res) {
            $scope.$apply(function() {
                $scope.pay.paybutton = 1;
                console.log("refresh");
              });
            if ($scope.rewardId == 0 || $scope.rewardId == null) {
              json = {
                ids: $scope.orderId,
                pay_type: '3',
                other_pay: otherpayMoney + '',
                mode: '3'
              };
            } else {
              json = {
                ids: $scope.orderId,
                pay_type: '3',
                other_pay: otherpayMoney + '',
                coupon_ids: $scope.rewardId + '',
                coupon_money: $scope.reward + '',
                mode: '3'
              };
            }
            if (res == 1) {
              $cordovaToast.showShortCenter('支付成功');
              updatePayAPI(json, function(data) {
                console.log(data);
                backToOrder();
              });
            } else if (res == 2) {
              $cordovaToast.showShortCenter('支付取消');
            }  else if(res == 3){
              $cordovaToast.showShortCenter('支付失败');
            } else {
              $scope.$apply(function() {
                $scope.pay.paybutton = 1;
                console.log("refresh");
              });
            }
          });
        } else if ($scope.pay.paychoose == '3') {
          otherpayMoney = Number($scope.price) - Number($scope.reward);
          otherpayMoney = otherpayMoney.toFixed(2);
          if (otherpayMoney <= 0) {
            otherpayMoney = 0;
          }
          aliPay($scope.orderId, $scope.name, otherpayMoney + '', function(res) {
            $scope.$apply(function() {
                $scope.pay.paybutton = 1;
                console.log("refresh");
              });
            if ($scope.rewardId == 0 || $scope.rewardId == null) {
              json = {
                ids: $scope.orderId,
                pay_type: '2',
                other_pay: otherpayMoney + '',
                mode: '2'
              };
            } else {
              json = {
                ids: $scope.orderId,
                pay_type: '2',
                other_pay: otherpayMoney + '',
                coupon_ids: $scope.rewardId + '',
                coupon_money: $scope.reward + '',
                mode: '2'
              };
            }
            if (res == 1) {
              updatePayAPI(json, function(data) {
                backToOrder();
              });
            }
          });
        }
      } else {
        //添加订单失败

        $scope.pay.paybutton = 1;
        $cordovaToast.showShortCenter('添加订单失败');
      }
    };
    if ($scope.orderId == null || $scope.orderId == '') {
      payflag = 0;
      var payjson = {
        user_ids: userId,
        agent_ids: agentId,
        course_ids: courseId,
        price: price
      };

      Network.loading(payjson, "/api/order/insertOrderInfo", function(data) {
        console.log(data);
        $scope.orderId = data.data.data;
        if (data.status.succeed == 1) {
          payflag = data.status.succeed;
          updatepay(payflag, money, price, function() {
            $scope.pay.paybutton = 1;
            $ionicHistory.goBack();
          });
        }
      });
    } else {
      updatepay(payflag, money, price, function() {
        $ionicHistory.goBack();
      });
    }
  };
})

;