angular.module('starter.noticeController', [])

/**
 * [首页红包页面]
 */
.controller('RewardCtrl', function($ionicPlatform, $cordovaSQLite, InmobiService,ChanceService, Constants, $rootScope, AppConfig, Common, $http, $ionicPopup, Share, $cordovaFile, $stateParams, CheckLogin, $cordovaToast, $ionicActionSheet, Network, $scope, $ionicModal, $state, $ionicLoading) {
    $ionicPlatform.ready(function(){
         CheckLogin.checkLogin(function(res) {
             if (res !== null) {
                 userId = res;
                 $cordovaSQLite.execute(db, 'SELECT * FROM Login WHERE user_id = "' + res + '"').then(function (result) {
                     if (result.rows.item(0).flag != '0') {
                         var apiKey = "";
                         if (window.baidu_push) {
                             if (ionic.Platform.isIOS()) {
                                 apiKey = AppConfig.getConfig().BD_PUSH_IOS_API_KEY;
                             } else {
                                 apiKey = AppConfig.getConfig().BD_PUSH_AND_API_KEY;
                             }
                             baidu_push.startWork(apiKey, function (resultJson) {
                             });
                         }
                     }
                 }, function (error) {
                 });
             }
         });
    });

  $scope.amount = 0;
  var userId = '1';
  var description = '';
  // 首页显示判断
  var funIsFrist = function() {
    var json = {};
    var apiUrl = AppConfig.getConfig().BASE_API + "/api/reward_info/isHaveGroupReward";
    var header = Common.commonHeaders(apiUrl, json);
    var request = $http({
      method: 'post',
      url: apiUrl,
      data: 'json=' + JSON.stringify(json),
      headers: header,
      timeout: 30000
    }).success(function(data, status, headers, config) {
      if (data.status.succeed == 1) {
        $scope.isReward = data.data;
        if ($scope.isReward != 1 && (!$scope.isFirst)) {
          $state.go('tab.course');
        }
      } else {
        $cordovaToast.showShortCenter(data.status.error_desc);
        $scope.isReward = 0;
      }
    }).error(function(data, status, headers, config) { // 通讯失败
      $cordovaToast.showShortCenter("网络环境较差，请检查网络");
      $scope.isReward = 0;
      $state.go('tab.course');
      return false;
    });
  };

  var getRewardList = function() {
    var json = {
      user_ids: userId
    };
      $ionicLoading.show({
        template: "努力加载中...",
        duration: 30000,
        noBackdrop: true,
        hideOnStateChange: true
      });
    Network.loading(json, "/api/reward_info/getGroupRewardInfoList", function(data) {
      $scope.rewards = data.data;
      if ($scope.rewards && $scope.rewards.length != 0) {
        $scope.rewardListModal.show();
      } else {
        $cordovaToast.showShortCenter('已没有您可抢的红包，感谢您的支持');
        $scope.rewardListModal.hide();
        $state.go('tab.course');
      }
      $scope.rewardModal.hide();
      console.log($scope.rewards);
    });
  };

  // check是否是首次打开应用
  if (cordova && cordova.file && cordova.file.dataDirectory) {
    $cordovaFile.checkFile(cordova.file.dataDirectory, 'first.txt').then(function(success) {
      $scope.isFirst = false;
      funIsFrist();
    }, function(error) {
        if(ionic.Platform.isIOS()){
            InmobiService.activate();
            ChanceService.activate();
        }
      $scope.isFirst = true;
      $cordovaFile.createFile(cordova.file.dataDirectory, 'first.txt', true).then(function(success) {
        console.log('写入成功');
      }, function(error) {
        console.log('写入失败');
      });
      funIsFrist();
    });
  } else {
    $scope.isFirst = false;
    funIsFrist();
  }

  // 红包列表页引入
  $ionicModal.fromTemplateUrl("templates/agent/agent-reward.html", {
    scope: $scope,
    animation: "slide-in-up"
  }).then(function(modal) {
    $scope.rewardListModal = modal;
  });

  // 红包信息也引入
  $ionicModal.fromTemplateUrl("templates/agent/agent-reward-result.html", {
    scope: $scope,
    animation: "slide-in-up"
  }).then(function(modal) {
    $scope.rewardModal = modal;
  });

  // 集团分享后红包信息也引入
  $ionicModal.fromTemplateUrl("templates/agent/group-reward.html", {
    scope: $scope,
    animation: "slide-in-up"
  }).then(function(modal) {
    $scope.groupRewardModal = modal;
  });

  // 集团分享后红包信息也引入
  $ionicModal.fromTemplateUrl("templates/agent/group-reward-result.html", {
    scope: $scope,
    animation: "slide-in-up"
  }).then(function(modal) {
    $scope.groupRewardResultModal = modal;
  });

  /**
   * 进入首页
   */
  $scope.goHome = function() {
    $state.go('tab.course');
    $scope.rewardModal.hide();
    $scope.rewardListModal.hide();
    $scope.groupRewardModal.hide();
    $scope.groupRewardResultModal.hide();
  };

  /**
   * 红包规则
   */
  $scope.rewardRule = function() {
    $ionicPopup.alert({
      title: "红包规则",
      template: Constants.rewardRuleString
    });
  };

  /**
   * 点击进入红包列表页
   */
  $scope.grab = function() {
    CheckLogin.checkLogin(function(res) {
      userId = res;
      if (res != null) {
        getRewardList();
      } else {
        $state.go('login');
      }
    });
  };

  /**
   * 抢红包
   */

  $scope.clickredpacket = function(rewardId, agentName) {
    $scope.shareAgentName = agentName;
    $scope.shareRewardIds = rewardId;
    CheckLogin.checkLogin(function(res) {
      if (res != null) {
        userId = res;
      }
      var json = {
        reward_ids: rewardId,
        user_ids: userId
      };
      var apiUrl = '/api/user_reward_detail/robReward';
      $ionicLoading.show({
        template: "努力加载中...",
        duration: 30000,
        noBackdrop: true,
        hideOnStateChange: true
      });
      Network.loading(json, apiUrl, function(data) {
        $scope.reward = data.data.userRewardDetail;
        $scope.rewardModal.show();
        console.log(data);
      });
    });
  };

  /**
   * 继续抢红包
   */
  $scope.continue = function() {
    $scope.rewardModal.hide();
    getRewardList();
  };

  /**
   * 点击分享
   */
  $scope.share = function(shareId, type) {
    Share.ActionSheetShare("/www/images/share.png", $scope.agent_name, description, shareId, type, $scope.shareAgentName, function(res) {
      if (res == 1) {
        rewardPoint();
      }
    });
  };

  /**
   *  分享后积分增加
   */
  function rewardPoint() {
    if ($rootScope.userIds != null) {
      $scope.rewardModal.hide();
      $scope.groupRewardModal.show();
      Network.loading({
        ids: $rootScope.userIds,
        point: Constants.pointcode
      }, "/api/user/addPointForUser", function(data) {
        console.log("积分增加");
      });
    }
  }
  $scope.getGroupReward = function(){
    $ionicLoading.show({
      template: "努力加载中...",
      duration: 30000,
      noBackdrop: true,
      hideOnStateChange: true
    });
    Network.loading({user_ids: $rootScope.userIds}, "/api/user_reward_detail/getGroupReward", function(data) {
      $scope.groupRewardResult = data.data;
      $scope.groupStatus = data.status;

      $scope.groupRewardModal.hide();
      $scope.groupRewardResultModal.show();
    });
  }
})

.controller('NoticeCtrl', function($rootScope, $scope, News, CheckLogin, $state) {
  $scope.news = News.all(News);
  $rootScope.appPage = 1;

  $scope.goNoticeList = function(id) {
    CheckLogin.checkLogin(function(res) {
      console.log(res);
      if (res) {
        switch (id) {
          case 0:
            {
              $state.go('tab.notice-reward');
            }
            break;
            case 1:
            {
              $state.go('tab.notice-affiche');
            }
            break;
            case 2:
            {
              $state.go('tab.notice-course');
            }
            break;
            case 3:
            {
              $state.go('tab.notice-refund');
            }
            break;
            default:
            break;
        }

      }
      else {
         $state.go('tab.nlogin');
      }
    });
  };
})

/**
 * [红包消息]
 */
.controller('NoticeRewardCtrl', function($rootScope, CheckLogin, Network, Constants, Common, $scope, $state, $http, $ionicPopup, $cordovaToast) {

  var pageNum = '0';
  $scope.isMore = 1;

  /**
   * [institutionRefresh 红包列表刷新]
   */
  $scope.institutionRefresh = function() {
    pageNum = '1';
    var page = {
      page: pageNum + '',
      count: Constants.pageItem
    };

    CheckLogin.checkLogin(function(res) {
      console.log(res);
      if (res) {
        var json = {
          pagination: page,
          user_ids: res
        };

        var apiUrl = "/api/notice_user_reward/getNoticeUserRewardList";
        Network.loading(json, apiUrl, function(data) {
          $scope.rewardList = data.data;
          console.log($scope.rewardList);
          $scope.isMore = data.paginated.more;
          $scope.$broadcast("scroll.refreshComplete");
          if (!$scope.rewardList || $scope.rewardList.length == 0) {
            $scope.isPrompt = true;
          } else {
            $scope.isPrompt = false;
          }
        });
        /////////////////////////////////////////////////////////////////////////
      } else {
        $scope.isPrompt = true;
      }
    });
  };

  /**
   * [load_more 红包列表加载]
   */
  $scope.load_more = function() {
    pageNum = parseInt(pageNum) + 1;
    var page = {
      page: pageNum + '',
      count: Constants.pageItem
    };
    CheckLogin.checkLogin(function(res) {
      if (res) {
        var json = {
          pagination: page,
          user_ids: res
        };

        var apiUrl = "/api/notice_user_reward/getNoticeUserRewardList";
        var data = Network.loading(json, apiUrl, function(data) {
          $scope.isMore = data.paginated.more;
          if ($scope.rewardList) {
            $scope.rewardList = $scope.rewardList.concat(data.data);
          } else {
            $scope.rewardList = data.data;
          }
          if (!$scope.rewardList || $scope.rewardList.length == 0) {
            $scope.isPrompt = true;
          } else {
            $scope.isPrompt = false;
          }
          $scope.$broadcast("scroll.infiniteScrollComplete");
        });
      } else {
        $scope.isPrompt = true;
      }
    });
  };

  /**
   * [goReward 进入红包信息页面]
   */
  $scope.goReward = function(rewardId) {
    CheckLogin.checkLogin(function(res) {
      if (res != null) {
        var json = {
          reward_ids: rewardId,
          user_ids: res
        };
        var apiUrl = "/api/reward_info/getRewardInfoByRewardIds";
        var data = Network.loading(json, apiUrl, function(data) {
          $scope.reward = data.data;
          $rootScope.rewardInfo = $scope.reward;
          console.log($scope.reward);
        $state.go('tab.reward', {
         'rewardId': rewardId
        });
        });
      }
    });
  };

  /**
   * [clickredpacket 抢红包]
   */
  $scope.clickredpacket = function(rewardId, agentName) {
    $scope.shareAgentName = agentName;
    $scope.shareRewardIds = rewardId;
    var json = {
      reward_ids: rewardId,
      user_ids: $rootScope.userIds
    };
    var apiUrl = '/api/user_reward_detail/robReward';
    Network.loading(json, apiUrl, function(data) {
      $scope.rewardagent = data.data.userRewardDetail;
      $scope.rewardListModal.hide();
      $scope.rewardModal.show();
      console.log(data);
    });
  };
})

/**
 * [红包信息]
 */
.controller('RewardInfoCtrl', function($state, $cordovaToast, $ionicPopup, Constants, $ionicActionSheet, $ionicHistory, $ionicModal, CheckLogin, Network, $rootScope, $scope, $stateParams, $ionicLoading, Share) {
  $scope.reward = $rootScope.rewardInfo;
  console.log($scope.reward);
  $rootScope.rewardInfo = null;
  $scope.rewardId = $stateParams.rewardId;
  $scope.isEvaluation = true;
  var userId;
  $ionicModal.fromTemplateUrl("templates/agent/agent-rewardresultout.html", {
    scope: $scope,
    animation: "slide-in-up"
  }).then(function(modal) {
    $scope.rewardModal = modal;
  });

    // 集团分享后红包信息也引入
    $ionicModal.fromTemplateUrl("templates/agent/group-reward.html", {
        scope: $scope,
        animation: "slide-in-up"
    }).then(function(modal) {
        $scope.groupRewardModal = modal;
    });

    // 集团分享后红包信息也引入
    $ionicModal.fromTemplateUrl("templates/agent/group-reward-result.html", {
        scope: $scope,
        animation: "slide-in-up"
    }).then(function(modal) {
        $scope.groupRewardResultModal = modal;
    });


  /**
   * 红包规则
   */
  $scope.rewardRule = function() {
    $ionicPopup.alert({
      title: "红包规则",
      template: Constants.rewardRuleString
    });
  };

  //抢红包
  $scope.grab = function(rewardId, agentName) {
    $scope.shareAgentName = agentName;
    CheckLogin.checkLogin(function(res) {
      if (res != null) {
              userId = res;
              var json = {
                  reward_ids: rewardId,
                  user_ids: userId
              };
              var apiUrl = '/api/user_reward_detail/robReward';
              $ionicLoading.show({
                  template: "努力加载中...",
                  duration: 30000,
                  noBackdrop: true,
                  hideOnStateChange: true
        });

        Network.loading(json, apiUrl, function(data) {
          $scope.rewardagent = data.data.userRewardDetail;
          $scope.groupRewardFlag = data.data.group_reward_flag;
          $scope.rewardModal.show();
          console.log(data);
        });
      }
    });
  };

  /**
   * [agentrewardModal 红包页面关闭]
   */
  $scope.agentrewardModal = function() {
    $scope.rewardModal.hide();
    $ionicHistory.goBack();
  };

  /**
   * [share 分享]
   */
  $scope.share = function(shareId, type) {
    Share.ActionSheetShare("/www/images/share.png", "红包分享", "我抢到了一个红包", shareId, type, $scope.shareAgentName, function(res) {
      if (res == 1) {
        evalutreward();
      }
    });
  };

  /**
   * 分享后加分
   */
  var evalutreward = function() {
    if ($rootScope.userIds != null) {
      Network.loading({
        ids: userId,
        point: Constants.pointcode
      }, "/api/user/addPointForUser", function(data) {
          if( $scope.groupRewardFlag == '1') {
              $scope.rewardModal.hide();
              $scope.groupRewardModal.show();
          }
          else{
              $cordovaToast.showShortCenter('感谢您的分享');
          }
      });
    }
  };

    $scope.goHome = function() {
        $state.go('tab.course');
        $scope.groupRewardModal.hide();
        $scope.groupRewardResultModal.hide();
    };

    $scope.getGroupReward = function(){
        $ionicLoading.show({
            template: "努力加载中...",
            duration: 30000,
            noBackdrop: true,
            hideOnStateChange: true
        });
        Network.loading({user_ids: $rootScope.userIds}, "/api/user_reward_detail/getGroupReward", function(data) {
            $scope.groupRewardResult = data.data;
	    $scope.groupStatus = data.status;			
            $scope.groupRewardModal.hide();
            $scope.groupRewardResultModal.show();
        });
    }
})

// 公告列表
.controller('NoticeAfficheCtrl', function(CheckLogin, Network, Constants, Common, $scope, $state, $ionicPopup, $cordovaToast, $rootScope) {

  var pageNum = '0';
  $scope.isMore = 1;

  /**
   * [institutionRefresh 公告列表刷新]
   */
  $scope.institutionRefresh = function() {
    pageNum = '1';
    var page = {
      page: pageNum + '',
      count: Constants.pageItem
    };
    CheckLogin.checkLogin(function(res) {
      if (res) {
        var json = {
          pagination: page,
          user_ids: res
        };
        var apiUrl = "/api/notice_affiche/getNoticeAfficheList";
        Network.loading(json, apiUrl, function(data) {
          $scope.afficheList = data.data;
          $scope.isMore = data.paginated.more;
          $scope.$broadcast("scroll.refreshComplete");
          if (!$scope.afficheList || $scope.afficheList.length == 0) {
            $scope.isPrompt = true;
          } else {
            $scope.isPrompt = false;
          }
        });
      } else {
        $scope.isPrompt = true;
      }
    });
  };

  /**
   * [load_more 公告消息列表加载]
   */
  $scope.load_more = function() {
    pageNum = parseInt(pageNum) + 1;
    var page = {
      page: pageNum + '',
      count: Constants.pageItem
    };
    CheckLogin.checkLogin(function(res) {
      if (res) {
        var json = {
          pagination: page,
          user_ids: res
        };
        var apiUrl = "/api/notice_affiche/getNoticeAfficheList";
        Network.loading(json, apiUrl, function(data) {
          $scope.isMore = data.paginated.more;
          if ($scope.afficheList) {
            $scope.afficheList = $scope.afficheList.concat(data.data);
          } else {
            $scope.afficheList = data.data;
          }
          $scope.$broadcast("scroll.infiniteScrollComplete");
          if (!$scope.afficheList || $scope.afficheList.length == 0) {
            $scope.isPrompt = true;
          } else {
            $scope.isPrompt = false;
          }
          console.log($scope.afficheList);
        });
        /////////////////////////////////////////////////////////////////////////
      } else {
        $scope.isPrompt = true;
      }
    });
  };

  /**
   * [goDetail 进入公告详情]
   */
  $scope.goDetail = function(afficheIds) {
    $state.go('tab.affiche-detail', {
      'afficheIds': afficheIds
    });
  };

  $scope.flag = {
    showDelete: false,
    showReorder: false
  };
})

/**
 * [公告详情]
 */
.controller('NoticeDetailCtrl', function(Network, Constants, $scope, $stateParams, $ionicLoading) {
  $scope.afficheIds = $stateParams.afficheIds;
  var json = {
    ids: $scope.afficheIds
  };
  var apiUrl = "/api/affiche/getAfficheByIds";
  $ionicLoading.show({
    template: "努力加载中...",
    duration: 30000,
    noBackdrop: true,
    hideOnStateChange: true
  });
  Network.loading(json, apiUrl, function(data) {
    $scope.notice = data.data;
    console.log(data);
  });
})

/**
 * [课程消息]
 */
.controller('NoticeCourseCtrl', function(CheckLogin, Network, Constants, Common, $scope, $state, $http, $ionicPopup, $cordovaToast, $rootScope) {
  var pageNum = '0';
  $scope.isMore = 1;
  /**
   * [institutionRefresh 课程消息刷新]
   */
  $scope.institutionRefresh = function() {
    pageNum = '1';
    var page = {
      page: pageNum + '',
      count: Constants.pageItem
    };
    CheckLogin.checkLogin(function(res) {
      var json = {
        pagination: page,
        user_ids: res
      };
      var apiUrl = "/api/notice_course/getNoticeCourseList";
      Network.loading(json, apiUrl, function(data) {
        $scope.courseList = data.data;
        $scope.isMore = data.paginated.more;
        $scope.$broadcast("scroll.refreshComplete");
        if (!$scope.courseList || $scope.courseList.length == 0) {
          $scope.isPrompt = true;
        } else {
          $scope.isPrompt = false;
        }
      });
    });
  };

  /**
   * [load_more 课程消息加载]
   */
  $scope.load_more = function() {
    pageNum = parseInt(pageNum) + 1;
    var page = {
      page: pageNum + '',
      count: Constants.pageItem
    };
    CheckLogin.checkLogin(function(res) {
      var json = {
        pagination: page,
        user_ids: res
      };
      var apiUrl = "/api/notice_course/getNoticeCourseList";
      Network.loading(json, apiUrl, function(data) {
        $scope.isMore = data.paginated.more;
        if ($scope.courseList) {
          $scope.courseList = $scope.courseList.concat(data.data);
        } else {
          $scope.courseList = data.data;
        }
        $scope.$broadcast("scroll.infiniteScrollComplete");
        if (!$scope.courseList || $scope.courseList.length == 0) {
          $scope.isPrompt = true;
        } else {
          $scope.isPrompt = false;
        }
      });
    });
  };
})

/**
 * [退款消息]
 */
.controller('NoticeRefundCtrl', function(CheckLogin, Network, Constants, Common, $scope, $state, $http, $ionicPopup, $cordovaToast, $rootScope) {
  var pageNum = '0';
  $scope.isMore = 1;

  /**
   * [institutionRefresh 退款消息刷新]
   */
  $scope.institutionRefresh = function() {
    pageNum = '1';
    var page = {
      page: pageNum + '',
      count: Constants.pageItem
    };
    CheckLogin.checkLogin(function(res) {
      var json = {
        pagination: page,
        user_ids: res
      };
      var apiUrl = "/api/notice_refund/getNoticeRefundList";
      Network.loading(json, apiUrl, function(data) {
        $scope.negotiationList = data.data;
        $scope.isMore = data.paginated.more;
        $scope.$broadcast("scroll.refreshComplete");
        if (!$scope.negotiationList || $scope.negotiationList.length == 0) {
          $scope.isPrompt = true;
        } else {
          $scope.isPrompt = false;
        }
      });
    });
  };

  /**
   * [load_more 退款消息加载]
   */
  $scope.load_more = function() {
    pageNum = parseInt(pageNum) + 1;
    var page = {
      page: pageNum + '',
      count: Constants.pageItem
    };
    CheckLogin.checkLogin(function(res) {
      var json = {
        pagination: page,
        user_ids: res
      };
      var apiUrl = "/api/notice_refund/getNoticeRefundList";
      Network.loading(json, apiUrl, function(data) {
        $scope.isMore = data.paginated.more;
        if ($scope.negotiationList) {
          $scope.negotiationList = $scope.negotiationList.concat(data.data);
        } else {
          $scope.negotiationList = data.data;
        }
        $scope.$broadcast("scroll.infiniteScrollComplete");
        if (!$scope.negotiationList || $scope.negotiationList.length == 0) {
          $scope.isPrompt = true;
        } else {
          $scope.isPrompt = false;
        }
      });
    });
  };
});