var changeMobile = '';
angular.module('starter.userController', ['ngCordova'])

//----------------------------------------------------------------------
// 登录Controller
//----------------------------------------------------------------------
        .controller('LoginCtrl', function ($ionicScrollDelegate, $ionicLoading, Constants, AppConfig, $interval, $cordovaToast, $cordovaSQLite, $scope, Network, $ionicModal, $ionicHistory, $rootScope) {

            // 配置初始值
            var id = 100;
            $scope.registeruser = $scope;
            $scope.forget = $scope;
            $scope.registeruser.mobile = null;
            $scope.registeruser.password = null;
            $scope.registeruser.passwordagain = null;
            $scope.registeruser.checking = null;
            var checkCode = 0;

            $ionicModal.fromTemplateUrl('templates/privacy.html', {
                scope: $scope
            }).then(function (modal) {
                $scope.privacy = modal;
            });
            $scope.area_code_1 = '';
            $scope.area_code_2 = '';
            $scope.area_code_3 = '';
            $scope.area_message = '';
            var province = '';
            var city = '';
            var area = '';
            var provinceName = '';
            var cityName = '';
            var areaName = '';
            var reg = new RegExp(/^(0|86|17951)?(13[0-9]|15[012356789]|17[0-9]|18[0-9]|14[57])[0-9]{8}$/);
            var passwordreg = new RegExp(/^\w{6,16}$/);
            var checkingreg = new RegExp(/^[0-9]*$/);
            /**
             * 登陆
             */
            $scope.login = function () {
                var telephone = $scope.login.telephone;
                var password = $scope.login.password;
                if (telephone == null || telephone == '') {
                    $cordovaToast.showShortCenter('请输入手机号');
                    return false;
                }
                if (reg.test(telephone) != true) {
                    $cordovaToast.showShortCenter('手机号格式错误');
                    return false;
                }
                if (passwordreg.test(password) != true) {
                    $cordovaToast.showShortCenter('密码必须由6～16位字母、数字、下划线组成');
                    return false;
                }
                $ionicLoading.show({
                    template: '正在登录，请稍候...',
                    duration: 10000
                });
                var json = {
                    mobile: telephone + '',
                    password: password
                };
                var apiUrl = "/api/user/signin";
                Network.loading(json, apiUrl, function (data) {
                    console.log(data);
                    var user = data.data.data.user;
                    console.log(user);
                    $ionicLoading.hide();
                    var ids = user.ids + '';
                    $rootScope.userIds = user.ids;
                    $rootScope.courseStatus = 1;
                    $rootScope.agentStatus = 1;
                    var newday = new Date().format('yyyy-MM-dd');
                    $cordovaSQLite.execute(db, 'SELECT * FROM Integration WHERE user_id = "' + ids + '"').then(function (res) {
                        if (res.rows.length > 0) {
                            var data = new Date(res.rows.item(0).login_date).format('yyyy-MM-dd');
                            if (newday > data) {
                                $cordovaToast.showShortCenter('登录积分+3');
                                Network.loading({
                                    ids: user.ids + '',
                                    point: Constants.logincode
                                }, "/api/user/addPointForUser", function (data) {
                                    console.log(data);
                                });
                                newday = newday + '';
                                $cordovaSQLite.execute(db, 'UPDATE Integration SET login_date = "' + newday + '" WHERE user_id ="' + ids + '"')
                                        .then(function (result) {
                                            console.log('时间信息更新成功' + result);
                                        }, function (error) {
                                            console.log(error);
                                            console.log('时间信息更新失败' + error);
                                        });
                            }

                        } else {
                            $cordovaToast.showShortCenter('登录积分+3');
                            Network.loading({
                                ids: user.ids + '',
                                point: Constants.logincode
                            }, "/api/user/addPointForUser", function (data) {
                                console.log(data);
                            });
                            newday = newday + '';
                            $cordovaSQLite.execute(db, 'INSERT INTO Integration (login_date, user_id)VALUES (?, ?)', [newday, ids]).then(function (result) {
                                console.log('时间信息插入保存成功' + result);
                            }, function (error) {
                                console.log(error);
                                console.log('时间信息插入保存失败' + error);
                            });
                        }
                    });
                    $cordovaSQLite.execute(db, 'DELETE FROM Login').then(function (result) {
                        console.log('删除' + result);
                    }, function (error) {
                        console.log('删除' + error);
                    });
                    $cordovaSQLite.execute(db, 'INSERT INTO Login VALUES (?, ?, ?)', [100, ids, '1']).then(function (result) {
                        getBaiduInfo(ids);
                        console.log('登录信息插入保存成功' + result);
                    }, function (error) {
                        console.log('登录信息插入保存失败' + error);
                    });
                    $ionicHistory.goBack();
                });
            };

            /**
             * 获取百度信息，并传入API保存至MySQL
             */
            var getBaiduInfo = function (ids) {
                var baiduId = "";
                var baiduChannelId = "";
                var apiKey = "";

                if (window.baidu_push) {
                    if (ionic.Platform.isIOS()) {
                        apiKey = AppConfig.getConfig().BD_PUSH_IOS_API_KEY;
                    } else {
                        apiKey = AppConfig.getConfig().BD_PUSH_AND_API_KEY;
                    }
                    baidu_push.startWork(apiKey, function (resultJson) {
                        var result = resultJson.data;
                        if (resultJson.type == 'onbind') {
                            baiduId = result.appId;
                            baiduChannelId = result.channelId;
                            var apiUrl = "/api/user/bindBaidu";
                            var reqJson = {
                                ids: ids,
                                baidu_id: baiduId,
                                baidu_channel_id: baiduChannelId
                            };
                            Network.loading(reqJson, apiUrl, function (data) {
                            });
                        }
                    });
                }
            };

            /**
             * 注册
             */
            $scope.registerUser = function () {
                var registerTelephone = $scope.registeruser.mobile;
                var password1 = $scope.registeruser.password;
                var password2 = $scope.registeruser.passwordagain;
                var checking = $scope.registeruser.checking;

                if (registerTelephone == null || registerTelephone == '') {
                    $cordovaToast.showShortCenter('请输入手机号');
                    return false;
                }
                if (reg.test(registerTelephone) != true) {
                    $cordovaToast.showShortCenter('手机号格式错误');
                    return false;
                }
                if (checking.length < 6) {
                    $cordovaToast.showShortCenter('验证码少于6位');
                    return false;
                }
                if (checkingreg.test(checking) != true) {
                    $cordovaToast.showShortCenter('验证码格式错误');
                    return false;
                }
                if (checking != $scope.registerCheckCode) {
                    $cordovaToast.showShortCenter('验证码错误');
                    return false;
                }
                if (passwordreg.test(password1) != true) {
                    $cordovaToast.showShortCenter('密码必须由6～16位字母、数字、下划线组成');
                    return false;
                }
                if (passwordreg.test(password2) != true) {
                    $cordovaToast.showShortCenter('密码必须由6～16位字母、数字、下划线组成');
                    return false;
                }
                if (password1 != password2) {
                    $cordovaToast.showShortCenter('两次输入的密码不符');
                    return false;
                }
                if ($scope.area_code_1 == null || $scope.area_code_1 == '') {
                    $cordovaToast.showShortCenter('请选择省份');
                    return false;
                }
                if ($scope.area_code_2 == null || $scope.area_code_2 == '') {
                    $cordovaToast.showShortCenter('请选择城市').then(function (success) {
                    }, function (error) {
                    });
                    return false;
                }
                if ($scope.area_code_3 == null || $scope.area_code_3 == '') {
                    $cordovaToast.showShortCenter('请选择区域').then(function (success) {
                    }, function (error) {
                    });
                    return false;
                }
                $ionicLoading.show({
                    template: '正在注册，请稍候...',
                    duration: 20000
                });
                var json = {
                    mobile: registerTelephone + '',
                    password: password1 + '',
                    area_code_1: $scope.area_code_1,
                    area_code_2: $scope.area_code_2,
                    area_code_3: $scope.area_code_3,
                    verification_code: checking
                };
                var apiUrl = "/api/user/signup";

                Network.loading(json, apiUrl, function (data) {
                    $ionicLoading.hide();
                    $cordovaToast.showShortCenter('注册成功');
                    $scope.registerCheckCode = null;
                    $scope.registeruser.mobile = null;
                    $scope.registeruser.password = null;
                    $scope.registeruser.passwordagain = null;
                    $scope.registeruser.checking = null;
                    $scope.area_message = null;
                    $scope.goRegister.remove();
                });
            };

            /**
             * 打开地区选择
             */
            json = {};
            Network.loading(json, "/api/mst_area/getProvince", function (data) {
                $scope.provinceList = data.data.data;
                console.log($scope.provinceList);
            });
            $scope.showarea = function () {
                $ionicModal.fromTemplateUrl('templates/user/user_register_area.html', {
                    scope: $scope
                }).then(function (modal) {
                    $scope.goRegisterArea = modal;
                    $scope.privacyDis = false;
                    province = '';
                    city = '';
                    area = '';
                    provinceName = '';
                    cityName = '';
                    areaName = '';
                    $scope.province_code = '';
                    $scope.city_code = '';
                    $scope.area_code = '';
                    $scope.cityList = '';
                    $scope.areaList = '';
                    $scope.goRegisterArea.show();
                    if ($scope.province_code) {
                        $scope.getCity($scope.province_code);
                    }
                    if ($scope.city_code) {
                        $scope.getArea($scope.city_code);
                    }
                });
            };

            /**
             * 设置省获取市list
             */
            $scope.getCity = function (provinceId) {
                $ionicScrollDelegate.$getByHandle('smallOne').scrollTop();
                $(".province").removeClass('assertive');
                province = provinceId;
                provinceName = $("#p" + provinceId).html();
                city = '';
                cityName = '';
                area = '';
                areaName = '';
                $scope.areaList = null;
                var id = provinceId + '';
                json = {
                    province_code: id
                };
                Network.loading(json, "/api/mst_area/getCity", function (data) {
                    $scope.cityList = data.data.data;
                    $("#reg" + provinceId + "").addClass('assertive');
                    console.log($scope.cityList);
                });
            };

            /**
             * 设置市获取区list
             */
            $scope.getArea = function (cityId) {
                $ionicScrollDelegate.$getByHandle('smallTwo').scrollTop();
                $(".city").removeClass('assertive');
                city = cityId;
                cityName = $("#c" + cityId).html();
                area = '';
                areaName = '';
                var id = cityId + '';
                json = {
                    city_code: id
                };
                Network.loading(json, "/api/mst_area/getArea", function (data) {
                    $scope.areaList = data.data.data;
                    $("#reg" + cityId + "").addClass('assertive');
                    console.log($scope.areaList);
                });
            };

            /**
             * 设置区
             */
            $scope.setArea = function (areaId) {
                $(".area").removeClass('assertive');
                area = areaId;
                areaName = $("#a" + areaId).html();
                $("#reg" + areaId + "").addClass('assertive');
            };

            /**
             * 取消地区选择
             */
            $scope.closeModal = function () {
                provinceName = $scope.provinceName;
                cityName = $scope.cityName;
                areaName = $scope.areaName;
                $scope.area_message = '';
                $scope.goRegisterArea.remove();
            };

            /**
             * 确定地区选择
             */
            $scope.areaMessage = function () {
                if (provinceName != '' && provinceName != null) {
                    if (cityName != '' && cityName != null) {
                        if (areaName != '' && areaName != null) {
                            $scope.provinceName = provinceName;
                            $scope.cityName = cityName;
                            $scope.areaName = areaName;
                        } else {
                            $cordovaToast.showShortCenter('请选择区域');
                            return false;
                        }
                    } else {
                        $cordovaToast.showShortCenter('请选择城市');
                        return false;
                    }
                } else {
                    $cordovaToast.showShortCenter('请选择省份');
                    return false;
                }
                $scope.area_message = provinceName + "-" + cityName + "-" + areaName;
                $scope.area_code_1 = province + '';
                $scope.area_code_3 = area + '';
                $scope.area_code_2 = city + '';
                $scope.goRegisterArea.remove();
            };

            /**
             * 忘记密码确定改密
             */
            $scope.select = function () {
                var telephone_forget = $scope.forget.telephone;
                var password_forget = $scope.forget.password;
                var password_new_forget = $scope.forget.passwordagien;
                var verification_forget = $scope.forget.checking;

                if (telephone_forget == null || telephone_forget == '') {
                    $cordovaToast.showShortCenter('请输入电话号码');
                    return false;
                }
                if (reg.test(telephone_forget) != true) {
                    $cordovaToast.showShortCenter('手机号格式错误');
                    return false;
                }
                if (verification_forget == null || verification_forget == '') {
                    $cordovaToast.showShortCenter('请输入验证码');
                    return false;
                }
                if (checkingreg.test(verification_forget) != true) {
                    $cordovaToast.showShortCenter('验证码格式错误');
                    return false;
                }
                if (verification_forget != $scope.forgetCheckCode) {
                    $cordovaToast.showShortCenter('验证码错误');
                    return false;
                }
                if (verification_forget.length > 6) {
                    $cordovaToast.showShortCenter('验证码少于6位');
                    return false;
                }
                if (passwordreg.test(password_forget) != true) {
                    $cordovaToast.showShortCenter('密码必须由6～16位字母、数字、下划线组成');
                    return false;
                }
                if (passwordreg.test(password_new_forget) != true) {
                    $cordovaToast.showShortCenter('密码必须由6～16位字母、数字、下划线组成');
                    return false;
                }
                if (password_forget != password_new_forget) {
                    $cordovaToast.showShortCenter('两次输入的密码不符');
                    return false;
                }
                $ionicLoading.show({
                    template: '正在重置密码，请稍候...',
                    duration: 20000
                });
                var json = {
                    mobile: telephone_forget + '',
                    password: password_forget + '',
                    verification_code: verification_forget + ''
                };
                var apiUrl = "/api/user/forgetPassword";
                Network.loading(json, apiUrl, function (data) {
                    $ionicLoading.hide();
                    $cordovaToast.showShortCenter('密码修改成功');
                    $scope.forgetCheckCode = '';
                    $scope.goForget.remove();
                });
            };

            $scope.registeruser.checkcodenum = null;

            $scope.goRegisterModel = function () {
                $ionicModal.fromTemplateUrl('templates/user/user-register.html', {
                    scope: $scope
                }).then(function (modal) {
                    $scope.goRegister = modal;
                    $scope.registeruser.count = 0;
                    $scope.forget.checking = '';
                    $scope.registeruser.checkcodenum = '';
                    $scope.registeruser.mobile = null;
                    $scope.registeruser.password = null;
                    $scope.registeruser.passwordagain = null;
                    $scope.registeruser.checking = null;
                    $scope.area_message = null;
                    $scope.goRegister.show();
                });
            };
            $scope.goForgetModel = function () {
                $ionicModal.fromTemplateUrl('templates/user/user-password-forget.html', {
                    scope: $scope
                }).then(function (modal) {
                    $scope.goForget = modal;
                    $scope.forget.checking = '';
                    $scope.registeruser.forgetcount = 0;
                    $scope.registeruser.checkforgetcodenum = '';
                    $scope.forget.telephone = '';
                    $scope.forget.password = '';
                    $scope.forget.passwordagien = '';
                    $scope.forget.checking = '';
                    $scope.goForget.show();
                });
            };
            var timer;
            var forgettimer;
            $scope.goRegisterModelHidden = function () {
                $scope.registeruser.count = 0;
                $scope.registeruser.checkcodenum = '';
                $interval.cancel(timer);
                timer = null;
                $scope.goRegister.remove();
            };
            $scope.goForgetModelHidden = function () {
                $scope.registeruser.forgetcount = 0;
                $scope.registeruser.checkforgetcodenum = '';
                $interval.cancel(forgettimer);
                forgettimer = null;
                $scope.goForget.remove();
            };

            /**
             * 获取验证码
             */

            $scope.getChecking = function (status) {
                var telephone = '';
                if (status == 1) {
                    if ($scope.registeruser.mobile == null || $scope.registeruser.mobile == '') {
                        $cordovaToast.showShortCenter('请输入手机号');
                        return false;
                    }
                    if (reg.test($scope.registeruser.mobile) != true) {
                        $cordovaToast.showShortCenter('手机号格式错误');
                        return false;
                    }
                    telephone = $scope.registeruser.mobile + '';
                    $('#checknum').show();
                }
                Network.loading({
                    mobile: telephone + '',
                    status: '1'
                }, "/api/user/validate", function (data) {
                    $scope.registerCheckCode = data.data;
                });
                $scope.registeruser.count = 1;
                $scope.registeruser.checkcodenum = 60;
                timer = $interval(function () {
                    $scope.registeruser.checkcodenum = $scope.registeruser.checkcodenum - 1;
                    if ($scope.registeruser.checkcodenum <= 0) {
                        $scope.registeruser.checkcodenum = '';
                        $scope.registeruser.count = 0;
                        $interval.cancel(timer);
                        timer = null;
                        return false;
                    }
                }, 1000);
            };
            $scope.getForgetChecking = function (status) {
                var telephone = '';
                if ($scope.forget.telephone == null || $scope.forget.telephone == '') {
                    $cordovaToast.showShortCenter('请输入手机号');
                    return false;
                }
                if (reg.test($scope.forget.telephone) != true) {
                    $cordovaToast.showShortCenter('手机号格式错误');
                    return false;
                }
                telephone = $scope.forget.telephone + '';

                Network.loading({
                    mobile: telephone + '',
                    status: '2'
                }, "/api/user/validate", function (data) {
                    $scope.forgetCheckCode = data.data;
                    console.log($scope.forgetCheckCode);
                });
                $scope.registeruser.forgetcount = 1;
                $scope.registeruser.checkforgetcodenum = 60;
                forgettimer = $interval(function () {
                    $scope.registeruser.checkforgetcodenum = $scope.registeruser.checkforgetcodenum - 1;
                    if ($scope.registeruser.checkforgetcodenum <= 0) {
                        $scope.registeruser.checkforgetcodenum = '';
                        $scope.registeruser.forgetcount = 0;
                        $interval.cancel(forgettimer);
                        forgettimer = null;
                        return false;
                    }
                }, 1000);

            };
        })

//----------------------------------------------------------------------
// 提现Controller
//----------------------------------------------------------------------
        .controller('WithdrawCtrl', function (CheckLogin, $state, $cordovaToast, Network, $scope, $stateParams, $ionicHistory) {
            $scope.wallet = $stateParams.wallet;
            $scope.purse = $scope;
            var userId = '';
            CheckLogin.checkLogin(function (res) {
                console.log(res);
                if (res != null) {
                    userId = res;
                }
            });

            /**
             * 确认提现
             */
            $scope.purseWithdraw = function () {
                var money = $scope.purse.money;
                var bank = $scope.purse.bank;
                var subbank = $scope.purse.sonbank;
                var name = $scope.purse.name;
                var card = $scope.purse.cardNumber;
                var namecheck = new RegExp(/^([\u4E00-\u9FA5]+|[a-zA-Z]+)$/);
                var moneycheck1 = new RegExp(/^[0-9]+\.?[0-9]{0,2}$/);
                var moneycheck2 = new RegExp(/^[0-9]+(.[0-9]{2})?$/);
                if (money == null || money == '') {
                    $cordovaToast.showShortCenter('请输入转出金额');
                    return false;
                }
                if (money > $scope.wallet) {
                    $cordovaToast.showShortCenter('转出金额超出账户余额');
                    return false;
                }
                if (money < 50 || money > 2000) {
                    $cordovaToast.showShortCenter('转出金额须大于50小于2000');
                    return false;
                }

                if (moneycheck1.test(money) != true || moneycheck2.test(money) != true) {
                    $cordovaToast.showShortCenter('请输入正确的金钱格式');
                    return false;
                }
                if (bank == null || bank == '') {
                    $cordovaToast.showShortCenter('请输入开户行');
                    return false;
                }
                if (subbank == null || subbank == '') {
                    $cordovaToast.showShortCenter('请输开户支行');
                    return false;
                }
                if (name == null || name == '') {
                    $cordovaToast.showShortCenter('请输入账户姓名');
                    return false;
                }
                if (namecheck.test(name) != true) {
                    $cordovaToast.showShortCenter('请输入正确无误的银行账号信息');
                    return false;
                }
                if (card == null || card == '') {
                    $cordovaToast.showShortCenter('请输入银行卡号');
                    return false;
                }
                if (card.length < 14) {
                    $cordovaToast.showShortCenter('银行卡号不能少于14位');
                    return false;
                }
                var json = {
                    user_ids: userId + '',
                    bank_name: bank + '',
                    bank_sub_name: subbank + '',
                    bank_account: card + '',
                    card_holder: name + '',
                    current_money: money + ''
                };
                Network.loading(json, "/api/user_in_out_detail/userWithdrawals", function (data) {
                    $cordovaToast.showShortCenter('提现申请成功，请耐心等候到账。');
                    $ionicHistory.goBack();
                });
            };
        })

//----------------------------------------------------------------------
// 设置Controller
//----------------------------------------------------------------------
        .controller('SettingCtrl', function ($ionicLoading, $cordovaToast, $ionicModal, $rootScope, AppConfig, $scope, $stateParams, Network, CheckLogin, $cordovaSQLite, $ionicHistory, VersionCheck) {
            cordova.getAppVersion.getVersionNumber(function (version) {
                $scope.version = version;
            });
            if ($rootScope.userIds == null) {
                $cordovaToast.showShortCenter('请重新登录');
                $ionicHistory.goBack();
            }
            $scope.isCheckVer = false;
            if(ionic.Platform.isIOS()){
                $scope.isCheckVer = true;
            }
            $scope.mobile = $stateParams.mobile;
            $scope.video = {
                isOn: false
            };
            if ($rootScope.notice == 1) {
                $scope.message = {
                    isOn: true
                };
                $scope.message24 = {
                    isOn: true
                };
                $scope.message2 = {
                    isOn: false
                };
            } else if ($rootScope.notice == 2) {
                $scope.message = {
                    isOn: true
                };
                $scope.message2 = {
                    isOn: true
                };
                $scope.message24 = {
                    isOn: false
                };
            }
            else {
                $scope.message = {
                    isOn: false
                };
            }
            // 查询视频播放设置
            $cordovaSQLite.execute(db, 'SELECT * FROM setInfo').then(
                    function (res) {
                        if (res.rows.length > 0) {
                            if (res.rows.item(0).flag == 0) {
                                $scope.video.isOn = false;
                            } else if (res.rows.item(0).flag == 1) {
                                $scope.video.isOn = true;
                            }
                        } else {
                            $scope.video.isOn = true;
                        }
                    },
                    function (error) {
                        $scope.statusMessage = "Error on checking: " + error.message;
                    });
            var userId = '';
            CheckLogin.checkLogin(function (res) {
                console.log(res);
                if (res != null) {
                    userId = res;
                }
            });

            $ionicModal.fromTemplateUrl('templates/privacy.html', {
                scope: $scope
            }).then(function (modal) {
                $scope.privacy = modal;
            });

            $ionicModal.fromTemplateUrl('templates/refund-agreement.html', {
                scope: $scope
            }).then(function (modal) {
                $scope.refund_agreement = modal;
            });
            /**
             * 退出登录
             */
            $scope.logout = function () {
                // 通讯参数
                var type = 1;
                var json = {
                    ids: userId
                };
                var showMsg = '正在注销登录，请稍候...';
                $ionicLoading.show({
                    template: showMsg,
                    duration: 10000
                });
                // 通讯路径
                Network.loading(json, "/api/user/signout", function (data) {
                    console.log(data);
                    $rootScope.loginStatus = 0;
                    $cordovaSQLite.execute(db, 'DELETE FROM Login').then(function (result) {
                        $ionicLoading.hide();
                        console.log('删除' + result);
                    }, function (error) {
                        console.log('删除' + error);
                    });
                    $scope.status = 0;
                    $rootScope.userIds = null;
                    $ionicHistory.goBack();
                    baidu_push.stopWork(function (resultJson) {
                        // 解除与百度的绑定
                    });
                });
            };

            /**
             * 打开消息推送
             */
            var startBaiduPush = function (ids) {
                var wifiFlag;
                var showMsg;
                wifiFlag = 0;
                showMsg = '正在开启，请稍候...';

                $ionicLoading.show({
                    template: showMsg,
                    duration: 10000
                });
                var apiKey = "";
                if (ionic.Platform.isIOS()) {
                    apiKey = AppConfig.getConfig().BD_PUSH_IOS_API_KEY;
                } else {
                    apiKey = AppConfig.getConfig().BD_PUSH_AND_API_KEY;
                }
                baidu_push.startWork(apiKey, function (resultJson) {
                    var result = resultJson.data;
                    if (resultJson.type == 'onbind') {
                        var baiduId = result.appId;
                        var baiduChannelId = result.channelId;
                        var apiUrl = "/api/user/bindBaidu";
                        var reqJson = {
                            ids: userId,
                            baidu_id: baiduId,
                            baidu_channel_id: baiduChannelId
                        };
                        Network.loading(reqJson, apiUrl, function (data) {
                            $ionicLoading.hide();
                            $cordovaSQLite.execute(db, 'UPDATE Login SET flag = "1" WHERE user_id ="' + userId + '"').then(function (result) {

                                console.log('登录信息插入保存成功' + result);
                            }, function (error) {
                                console.log('登录信息插入保存失败' + error);
                            });
                        });
                    }
                });
            };

            /**
             * 关闭消息推送
             */
            var stopBaiduPush = function (ids) {
                var wifiFlag = 1;
                var showMsg = '正在关闭，请稍候...';
                $ionicLoading.show({
                    template: showMsg,
                    duration: 10000
                });
                baidu_push.stopWork(function (resultJson) {
                    $ionicLoading.hide();
                    $cordovaSQLite.execute(db, 'UPDATE Login SET flag = "0" WHERE user_id ="' + userId + '"').then(function (result) {

                        console.log('登录信息插入保存成功' + result);
                    }, function (error) {
                        console.log('登录信息插入保存失败' + error);
                    });
                    // 解除与百度的绑定
                });
            };

            /**
             * 设置信息接收开关
             */
            $scope.messageSet = function () {

                var json = null;
                if ($scope.message.isOn) {
                    $scope.message24 = {
                        isOn: true
                    };
                    $scope.message2 = {
                        isOn: false
                    };
                    json = {
                        ids: userId,
                        notice_flg: '1'
                    };
                } else {
                    $scope.message24 = {
                        isOn: false
                    };
                    $scope.message2 = {
                        isOn: false
                    };
                    json = {
                        ids: userId,
                        notice_flg: '0'
                    };
                }

                Network.loading(json, "/api/user/setNoticeFlag", function (data) {
                    console.log(data);
                    if ($scope.message.isOn) {
                        startBaiduPush(userId);
                    } else {
                        stopBaiduPush(userId);
                    }
                });
            };

            /**
             * 设置信息接收开关
             */
            $scope.messageH24Set = function () {
                var json = null;
                console.log($scope.message24);
                if ($scope.message24.isOn) {
                    $scope.message2 = {
                        isOn: false
                    };
                    json = {
                        ids: userId,
                        notice_flg: '1'
                    };
                } else {
                    $scope.message2 = {
                        isOn: true
                    };
                    json = {
                        ids: userId,
                        notice_flg: '2'
                    };
                }

                Network.loading(json, "/api/user/setNoticeFlag", function (data) {
                    console.log(data);
                });
            };
            /**
             * 设置信息接收开关
             */
            $scope.messageH2Set = function () {
                var json = null;
                if ($scope.message2.isOn) {
                    $scope.message24 = {
                        isOn: false
                    };
                    json = {
                        ids: userId,
                        notice_flg: '2'
                    };
                } else {
                    $scope.message24 = {
                        isOn: true
                    };
                    json = {
                        ids: userId,
                        notice_flg: '1'
                    };
                }


                Network.loading(json, "/api/user/setNoticeFlag", function (data) {
                    console.log(data);
                });
            };

            /**
             * 设置视频播放开关
             */
            $scope.videoSet = function () {
                var wifiFlag;
                var showMsg;
                var video_flg = null;
                if ($scope.video.isOn) {
                    wifiFlag = 0;
                    showMsg = '正在开启，请稍候...';
                    video_flg = 1;
                } else {
                    wifiFlag = 0;
                    showMsg = '正在关闭，请稍候...';
                    video_flg = 0;
                }
                $ionicLoading.show({
                    template: showMsg,
                    duration: 10000
                });
                $cordovaSQLite.execute(db, 'SELECT * FROM setInfo').then(function (res) {
                    if (res.rows.length > 0) {
                        $cordovaSQLite.execute(db, 'UPDATE setInfo SET flag = "' + video_flg + '"').then(function (result) {
                            console.log('信息更新成功' + result);
                            $ionicLoading.hide();
                        }, function (error) {
                            console.log('信息更新失败' + error);
                            $ionicLoading.hide();
                        });
                    } else {
                        $cordovaSQLite.execute(db, 'INSERT INTO setInfo VALUES (?, ?)', [100, video_flg + '']).then(function (result) {
                            console.log('登录信息插入保存成功' + result);
                            $ionicLoading.hide();
                        }, function (error) {
                            console.log('登录信息插入保存失败' + error);
                            $ionicLoading.hide();
                        });
                    }
                }, function (error) {
                    $scope.statusMessage = "Error on checking: " + error.message;
                    $ionicLoading.hide();
                });
            };

            $scope.versionUpdate = function () {
                VersionCheck.check();
            };
        })

//----------------------------------------------------------------------
// 个人中心Controller
//----------------------------------------------------------------------
        .controller('UserCtrl', function ($rootScope, CheckLogin, Network, $scope, $state, $rootScope) {
            $rootScope.payStatus = 0;
            $scope.settings = {
                enableFriends: true
            };
            var userId = null;
            $rootScope.hideTabs = false;
            $rootScope.appPage = 1;
            CheckLogin.checkLogin(function (res) {
                if (res != null) {
                    userId = res;
                    $rootScope.userIds = res;
                    $scope.status = 1;
                    var json = {
                        ids: res
                    };
                    ////////////////////////////////////用户信息获取///////////////////////////
                    // 通讯路径
                    var apiUrl = "/api/user/info";
                    Network.loading(json, apiUrl, function (data) {
                        $scope.user = data.data.user_info;
                        console.log($scope.user);
                    });
                    /////////////////////////////////////////////////////////////////////////
                } else {
                    $scope.status = 0;
                }
            });

            /**
             * 到订单、收藏、个人信息、钱包、设置
             */
            $scope.goOrderform = function () {
                $state.go('tab.user-orders', {
                    'userId': userId
                });
            };
            $scope.goCollect = function () {
                $state.go('tab.user-collect', {
                    'userId': userId
                });
            };
            $scope.goUserInfo = function () {
                $state.go('tab.user-edit', {
                    'userId': userId
                });
            };
            $scope.goWallet = function (wallet) {
                $state.go('tab.user-purse', {
                    'wallet': wallet,
                    'userId': userId
                });
            };
            $scope.goSetting = function (mobile, flg) {
                $rootScope.notice = flg;
                $state.go('tab.user-setting', {
                    'mobile': mobile,
                    'notice': flg
                });
            };
        })

//----------------------------------------------------------------------
// 支付明细Controller
//----------------------------------------------------------------------
        .controller('UserPaymentDetailCtrl', function ($scope, $stateParams, Constants, Network) {
            var status = null;
            var page = '1';
            var userId = null;
            var count = 0;
            $scope.pay = $scope;
            $scope.pay.allpaginated = 0;
            $scope.pay.comepaginated = 0;
            $scope.pay.topaginated = 0;
            $scope.pay.userId = $stateParams.userId;

            /**
             * 点击tab
             */
            $scope.paymentAll = function (status) {
                count = 1;
                $scope.payAll = '';
                $scope.refresh(status);
            };
            $scope.paymentCome = function (status) {
                count = 1;
                $scope.payCome = '';
                $scope.refresh(status);
            };
            $scope.paymentTo = function (status) {
                count = 1;
                $scope.payTo = '';
                $scope.refresh(status);
            };

            /**
             * 刷新
             */
            $scope.refresh = function (status) {
                var flag = '';
                if (status == 0) {
                    flag = '';
                } else if (status == 1) {
                    flag = '1';
                } else if (status == 2) {
                    flag = '2';
                }
                var json = {
                    user_ids: $scope.pay.userId,
                    flag: flag + '',
                    pagination: {
                        page: '1',
                        count: Constants.pageItem
                    }
                };
                var apiUrl = "/api/user_in_out_detail/getUserInOutList";
                // 通讯路径
                Network.loading(json, apiUrl, function (data) {
                    if (status == 0) {
                        $scope.payAll = data.data;
                        $scope.pay.allpaginated = data.paginated.more;
                        if (!$scope.payAll || $scope.payAll.length == 0) {
                            $scope.isPrompt = true;
                        } else {
                            $scope.isPrompt = false;
                        }
                    } else if (status == 1) {
                        $scope.payCome = data.data;
                        $scope.pay.comepaginated = data.paginated.more;
                        if (!$scope.payCome || $scope.payCome.length == 0) {
                            $scope.isPrompt = true;
                        } else {
                            $scope.isPrompt = false;
                        }
                    } else if (status == 2) {
                        $scope.payTo = data.data;
                        $scope.pay.topaginated = data.paginated.more;
                        if (!$scope.payTo || $scope.payTo.length == 0) {
                            $scope.isPrompt = true;
                        } else {
                            $scope.isPrompt = false;
                        }
                    }
                    $scope.$broadcast("scroll.refreshComplete");
                    count = 1;
                });
            };

            /**
             * 加载
             */
            $scope.load_more_pay = function (status) {
                var flag = null;
                if (status == 0) {
                    flag = '';
                } else if (status == 1) {
                    flag = '1';
                } else if (status == 2) {
                    flag = '2';
                }
                count = count + 1;
                var json = {
                    user_ids: $scope.pay.userId,
                    flag: flag + '',
                    pagination: {
                        page: count + '',
                        count: Constants.pageItem
                    }
                };
                // 通讯路径
                Network.loading(json, "/api/user_in_out_detail/getUserInOutList", function (data) {
                    console.log(data);
                    var pays = data.data;
                    if (status == 0) {
                        if ($scope.payAll) {
                            $scope.payAll = $scope.payAll.concat(data.data);
                        } else {
                            $scope.payAll = data.data;
                        }
                        $scope.pay.allpaginated = data.paginated.more;
                        if (!$scope.payAll || $scope.payAll.length == 0) {
                            $scope.isPrompt = true;
                        } else {
                            $scope.isPrompt = false;
                        }
                    } else if (status == 1) {
                        if ($scope.payCome) {
                            $scope.payCome = $scope.payCome.concat(data.data);
                        } else {
                            $scope.payCome = data.data;
                        }
                        $scope.pay.comepaginated = data.paginated.more;
                        if (!$scope.payCome || $scope.payCome.length == 0) {
                            $scope.isPrompt = true;
                        } else {
                            $scope.isPrompt = false;
                        }
                    } else if (status == 2) {
                        if ($scope.payTo) {
                            $scope.payTo = $scope.payTo.concat(data.data);
                        } else {
                            $scope.payTo = data.data;
                        }
                        $scope.pay.topaginated = data.paginated.more;
                        if (!$scope.payTo || $scope.payTo.length == 0) {
                            $scope.isPrompt = true;
                        } else {
                            $scope.isPrompt = false;
                        }
                    }
                    $scope.$broadcast("scroll.infiniteScrollComplete");
                });
            };
        })

//----------------------------------------------------------------------
// 红包抵用券Controller
//----------------------------------------------------------------------
        .controller('UserRewardCouponCtrl', function ($rootScope, $state, $cordovaToast, $stateParams, $scope, Network, Constants) {
            var pageNum = '1';
            $scope.userId = $stateParams.userId;
            var userId = $stateParams.userId;
            console.log(userId);
            $scope.status = 1;
            $scope.isMore = 0;
            $scope.isNetworking = false;

            /**
             * 红包抵用券list
             */
            var getList = function () {
                $scope.isNetworking = true;
                var json = {
                    user_ids: userId,
                    status: $scope.status + '',
                    pagination: {
                        page: pageNum + '',
                        count: Constants.pageItem
                    }
                };
                Network.loading(json, "/api/user_reward_detail/getUserCouponRewardList", function (data) {
                    $scope.isMore = data.paginated.more;
                    $scope.isNetworking = false;
                    if (pageNum == 1) {
                        $scope.coupons = data.data;
                        console.log($scope.coupons);
                    } else {
                        $scope.coupons = $scope.coupons.concat(data.data);
                    }
                    pageNum = parseInt(pageNum) + 1;
                    $scope.$broadcast("scroll.refreshComplete");
                    $scope.$broadcast("scroll.infiniteScrollComplete");
                    if (!$scope.coupons || $scope.coupons.length == 0) {
                        $scope.isPrompt = true;
                    } else {
                        $scope.isPrompt = false;
                    }
                });
            };

            $scope.clickTab = function (index) {
                $scope.coupons = null;
                pageNum = '1';
                $scope.status = index;
                getList();
            };

            $scope.goAgentDtail = function (agentId, picture_list, agentName) {
                $rootScope.agentPics = picture_list;
                $state.go("tab.user-agentDetail", {agentId: agentId, tabType: 4, name: agentName});
            }

            /**
             * 加载、刷新
             */
            $scope.courseRefresh = function () {
                pageNum = '1';
                if (!$scope.isNetworking) {
                    getList();
                } else {
                    $scope.$broadcast("scroll.refreshComplete");
                }
            };
            $scope.load_more = function () {
                if (!$scope.isNetworking) {
                    getList();
                } else {
                    $scope.$broadcast("scroll.infiniteScrollComplete");
                }
            };
        })

//----------------------------------------------------------------------
// 现金红包Controller
//----------------------------------------------------------------------
        .controller('UserRewardCashCtrl', function ($cordovaToast, $stateParams, $scope, Constants, Network) {

            var pageNum = '1';
            // 是否还有下一页
            $scope.isMore = 1;
            var userId = $stateParams.userId;

            /**
             * 红包抵用券list
             */
            var getList = function () {
                var json = {
                    user_ids: userId,
                    pagination: {
                        page: pageNum + '',
                        count: Constants.pageItem
                    }
                };
                Network.loading(json, "/api/user_reward_detail/getUserCashRewardList", function (data) {
                    $scope.isMore = data.paginated.more;
                    if (pageNum == 1) {
                        $scope.list = data.data;
                    } else {
                        $scope.list = $scope.list.concat(data.data);
                    }
                    console.log($scope.list);
                    pageNum = parseInt(pageNum) + 1;
                    $scope.$broadcast("scroll.refreshComplete");
                    $scope.$broadcast("scroll.infiniteScrollComplete");
                    if (!$scope.list || $scope.list.length == 0) {
                        $scope.isPrompt = true;
                    } else {
                        $scope.isPrompt = false;
                    }
                });
            };

            /**
             * 加载、刷新
             */
            $scope.courseRefresh = function () {
                pageNum = '1';
                getList();
            };
            $scope.load_more = function () {
                getList();
            };
        })

//----------------------------------------------------------------------
// 我的预约Controller
//----------------------------------------------------------------------
        .controller('UserBespeakCtrl', function ($stateParams, $cordovaToast, $ionicLoading, $rootScope, Constants, $scope, $state, Network) {

            $scope.bespeak = $scope;
            // 是否还有下一页
            $scope.bespeak.paginated = '1';
            var userId = $stateParams.userId;
            var pageNum = 1;
            var getList = function () {
                var json = {
                    user_ids: userId,
                    pagination: {
                        page: pageNum + '',
                        count: Constants.pageItem
                    }
                };
                Network.loading(json, "/api/user_bespeak/getUserBespeakListByUserIds", function (data) {

                    if (pageNum == 1) {
                        $scope.bespeaks = data.data;
                    } else {
                        $scope.bespeaks = $scope.bespeaks.concat(data.data);
                    }
                    $scope.bespeak.paginated = data.paginated.more;
                    console.log(data);
                    if (!$scope.bespeaks || $scope.bespeaks.length == 0) {
                        $scope.isPrompt = true;
                    } else {
                        $scope.isPrompt = false;
                    }
                    pageNum = parseInt(pageNum) + 1;
                    $scope.$broadcast("scroll.refreshComplete");
                    $scope.$broadcast("scroll.infiniteScrollComplete");
                });
            };

            /**
             * 去详细
             */
            $scope.goDtail = function (courseId, coursePics, id_off, del_flg) {
                if (id_off != 1) {
                    $cordovaToast.showShortCenter('该课程已下架。');
                    return false;
                }
                if (del_flg == 1) {
                    $cordovaToast.showShortCenter('该课程已删除。');
                    return false;
                }
                $rootScope.coursePics = coursePics;
                $state.go('tab.user-course-detail', {
                    'courseId': courseId,
                    'tabType': 4
                });
            };

            /**
             * 加载、刷新
             */
            $scope.bespeakRefresh = function () {
                pageNum = 1;
                getList();
            };
            $scope.load_more_bespeak = function () {
                getList();
            };

            /**
             * 取消预约
             */
            $scope.bespeakcourse = function (bespeakIds) {
                var json = {
                    user_ids: userId,
                    bespeak_ids: bespeakIds
                };
                Network.loading(json, "/api/user_bespeak/cancelUserBespeak", function (data) {
                    console.log(data);
                    if (data.status.succeed == 1) {
                        $scope.bespeakIds = null;
                        $scope.bespeakTitle = '预约';
                        $ionicLoading.show({
                            template: "您已成功取消预约",
                            duration: 2000,
                            noBackdrop: true,
                            hideOnStateChange: true
                        });
                        $scope.bespeakRefresh();
                    } else {
                        $ionicLoading.show({
                            template: "发生未知错误，取消预约失败",
                            duration: 2000,
                            noBackdrop: true,
                            hideOnStateChange: true
                        });
                    }
                });
            };

        })

//----------------------------------------------------------------------
// 我的订单Controller
//----------------------------------------------------------------------
        .controller('UserOrdersCtrl', function ($ionicScrollDelegate, $ionicLoading, $cordovaToast, Network, Constants, $ionicPopup, $scope, $state, $stateParams) {
            // 显示订单分类(1、待确认 2、待支付 3、已确认 4、退款)
            var status;
            var page = '1';
            var userId;
            var count = 0;
            $scope.order = $scope;
            $scope.subTabStates;
            // 是否还有下一页
            $scope.order.paginated = 0;
            $scope.order.refundpaginated = 0;
            $scope.order.npaypaginated = 0;
            $scope.order.alreadypaginated = 0;
            $scope.order.userId = $stateParams.userId;
            var scrollListToTop = function () {
                $ionicScrollDelegate.$getByHandle('orderListScroll').scrollTop();
            };

            $scope.$on("$ionicView.enter", function (scopes, states) {
                if ($scope.subTabStates || $scope.subTabStates == 0) {
                    $scope.refresh($scope.subTabStates);
                }
            });

            /**
             * 点击tab
             */
            $scope.getAll = function (status) {
                $scope.subTabStates = status;
                count = 1;
                $scope.orderAll = '';
                $scope.refresh(status);
            };
            $scope.toBeIdentified = function (status) {
                $scope.subTabStates = status;
                count = 1;
                $scope.orderforms = '';
                $scope.refresh(status);
            };
            $scope.nPayment = function (status) {
                $scope.subTabStates = status;
                count = 1;
                $scope.nPayOrderforms = '';
                $scope.refresh(status);
            };
            $scope.okAlready = function (status) {
                $scope.subTabStates = status;
                count = 1;
                $scope.alreadyOrderforms = '';
                $scope.refresh(status);
            };
            $scope.refund = function (status) {
                $scope.subTabStates = status;
                count = 1;
                $scope.refundOrderforms = '';
                $scope.refresh(status);
            };

            /**
             * 加载、刷新
             */
            $scope.refresh = function (status) {
                var json = {
                    order_status: status + '',
                    user_ids: $scope.order.userId,
                    pagination: {
                        page: '1',
                        count: Constants.pageItem
                    }
                };
                $ionicLoading.show({
                    template: "努力加载中",
                    duration: 10000
                });
                var apiUrl = "/api/order/orderListForBuyerForPage";

                Network.loading(json, apiUrl, function (data) {
                    $ionicLoading.hide();
                    scrollListToTop();
                    if (status == 0) {
                        $scope.orderAll = data.data;
                        console.log($scope.orderAll);
                        $scope.order.paginateds = data.paginated.more;
                        if (!$scope.orderAll || $scope.orderAll.length == 0) {
                            $scope.isPrompt = true;
                        } else {
                            $scope.isPrompt = false;
                        }
                    } else if (status == 1) {
                        $scope.orderforms = data.data;
                        console.log($scope.orderforms);
                        $scope.order.paginated = data.paginated.more;
                        if (!$scope.orderforms || $scope.orderforms.length == 0) {
                            $scope.isPrompt = true;
                        } else {
                            $scope.isPrompt = false;
                        }
                    } else if (status == 2) {
                        $scope.nPayOrderforms = data.data;
                        $scope.order.npaypaginated = data.paginated.more;
                        if (!$scope.nPayOrderforms || $scope.nPayOrderforms.length == 0) {
                            $scope.isPrompt = true;
                        } else {
                            $scope.isPrompt = false;
                        }
                    } else if (status == 3) {
                        $scope.alreadyOrderforms = data.data;
                        console.log($scope.alreadyOrderforms);
                        $scope.order.alreadypaginated = data.paginated.more;
                        if (!$scope.alreadyOrderforms || $scope.alreadyOrderforms.length == 0) {
                            $scope.isPrompt = true;
                        } else {
                            $scope.isPrompt = false;
                        }
                    } else {
                        $scope.refundOrderforms = data.data;
                        $scope.order.refundpaginated = data.paginated.more;
                        if (!$scope.refundOrderforms || $scope.refundOrderforms.length == 0) {
                            $scope.isPrompt = true;
                        } else {
                            $scope.isPrompt = false;
                        }
                    }
                    $scope.$broadcast("scroll.refreshComplete");
                    count = 1;
                });
            };

            $scope.load_more_order = function (status) {
                count = count + 1;
                var json = {
                    order_status: status + '',
                    user_ids: $scope.order.userId,
                    pagination: {
                        page: count + '',
                        count: Constants.pageItem
                    }
                };
                $ionicLoading.show({
                    template: "努力加载中",
                    duration: 10000
                });
                Network.loading(json, "/api/order/orderListForBuyerForPage", function (data) {
                    console.log(data);
                    $ionicLoading.hide();
                    var courses = data.data;
                    if (status == 0) {
                        if ($scope.orderAll) {
                            $scope.orderAll = $scope.orderAll.concat(data.data);
                        } else {
                            $scope.orderAll = data.data;
                        }
                        $scope.order.paginateds = data.paginated.more;
                        if (!$scope.orderAll || $scope.orderAll.length == 0) {
                            $scope.isPrompt = true;
                        } else {
                            $scope.isPrompt = false;
                        }
                    } else if (status == 1) {
                        if ($scope.orderforms) {
                            $scope.orderforms = $scope.orderforms.concat(data.data);
                        } else {
                            $scope.orderforms = data.data;
                        }
                        $scope.order.paginated = data.paginated.more;
                        if (!$scope.orderforms || $scope.orderforms.length == 0) {
                            $scope.isPrompt = true;
                        } else {
                            $scope.isPrompt = false;
                        }
                    } else if (status == 2) {
                        if ($scope.nPayOrderforms) {
                            $scope.nPayOrderforms = $scope.nPayOrderforms.concat(data.data);
                        } else {
                            $scope.nPayOrderforms = data.data;
                        }
                        $scope.order.npaypaginated = data.paginated.more;
                        if (!$scope.nPayOrderforms || $scope.nPayOrderforms.length == 0) {
                            $scope.isPrompt = true;
                        } else {
                            $scope.isPrompt = false;
                        }
                    } else if (status == 3) {
                        if ($scope.alreadyOrderforms) {
                            $scope.alreadyOrderforms = $scope.alreadyOrderforms.concat(data.data);
                        } else {
                            $scope.alreadyOrderforms = data.data;
                        }
                        $scope.order.alreadypaginated = data.paginated.more;
                        if (!$scope.alreadyOrderforms || $scope.alreadyOrderforms.length == 0) {
                            $scope.isPrompt = true;
                        } else {
                            $scope.isPrompt = false;
                        }
                    } else {
                        if ($scope.refundOrderforms) {
                            $scope.refundOrderforms = $scope.refundOrderforms.concat(data.data);
                        } else {
                            $scope.refundOrderforms = data.data;
                        }
                        $scope.order.refundpaginated = data.paginated.more;
                        if (!$scope.refundOrderforms || $scope.refundOrderforms.length == 0) {
                            $scope.isPrompt = true;
                        } else {
                            $scope.isPrompt = false;
                        }
                    }
                    $scope.$broadcast("scroll.infiniteScrollComplete");
                });
            };

            /**
             * 点击评价
             */
            $scope.doEvaluation = function (orderId, agentId, courseId, id_off, del_flg, agentName, courseName) {
                if (id_off != 1) {
                    $cordovaToast.showShortCenter('该课程已下架。');
                    return false;
                }
                if (del_flg == 1) {
                    $cordovaToast.showShortCenter('该课程已删除。');
                    return false;
                }
                $state.go('tab.goto-evaluation', {
                    orderId: orderId,
                    userId: $scope.order.userId,
                    agentId: agentId,
                    courseId: courseId,
                    agentName: agentName,
                    courseName: courseName
                });
            };

            $scope.back = function () {
                $state.go('tab.user');
            };

            /**
             * 确认支付
             */
            $scope.pay = function (orderId) {
                $ionicPopup.confirm({
                    title: "确认支付",
                    template: "确认付款后, 钱将会转给门店, 款项不再受集团保护.",
                    buttons: [{
                        text: "取消"
                    }, {
                        text: "<b>确定</b>",
                        type: "button-positive",
                        onTap: function (e) {
                            return true;
                        }
                    }]
                }).then(function (res) {
                    if (res) {
                        var json = {
                            ids: orderId,
                            user_ids: $scope.order.userId
                        };
                        Network.loading(json, "/api/order/updateOrderForConfirmPay", function (data) {
                            $scope.refresh($scope.subTabStates);
                        });
                    } else {
                        return false;
                    }
                });
            };
            $scope.cancelOrder = function (orderId) {
                $ionicPopup.confirm({
                    title: "取消订单",
                    template: "确定取消订单?",
                    buttons: [{
                        text: "取消"
                    }, {
                        text: "<b>确定</b>",
                        type: "button-positive",
                        onTap: function (e) {
                            return true;
                        }
                    }]
                }).then(function (res) {
                    if (res) {
                        var json = {
                            ids: orderId,
                            user_ids: $scope.order.userId
                        };
                        Network.loading(json, "/api/order/updateOrderForCancel", function (data) {
                            console.log(data);
                            $scope.refresh($scope.subTabStates);
                        });
                    } else {
                        return false;
                    }
                });
            };

            /**
             * 去详情
             */
            $scope.goDetail = function (ids, orderType, id_off, del_flg) {
                if (orderType == 2 && id_off != 1) {
                    $cordovaToast.showShortCenter('该课程已下架。');
                    return false;
                }
                if (orderType == 2 && del_flg == 1) {
                    $cordovaToast.showShortCenter('该课程已删除。');
                    return false;
                }
                $state.go('tab.order-detail', {
                    'orderId': ids,
                    'orderType': orderType
                });
            };
            var popu;
            $scope.drawback = function (id) {
                popu = $ionicPopup.show({
                    template: "<input type='text' ng-model='order.reason' placeholder='退款理由限20字' maxlength='20'>",
                    title: "申请退款",
                    subTitle: "课程款将被冻结，请与门店协商。",
                    scope: $scope,
                    buttons: [{
                        text: "取消"
                    }, {
                        text: "<b>确定</b>",
                        type: "button-positive",
                        onTap: function (e) {
                            if ($scope.order.reason == null || $scope.order.reason == '') {
                                $cordovaToast.showShortCenter('请输入退款理由');
                                e.preventDefault();
                            }
                            else if ($scope.order.reason.length > 20) {
                                $cordovaToast.showShortCenter('退款理由过长');
                                e.preventDefault();
                            }
                            else {
                                var json = {
                                    ids: id,
                                    refund_reason: $scope.order.reason
                                };
                                $scope.order.reason = null;
                                Network.loading(json, "/api/order/updateOrderForApplyRefund", function (data) {
                                    console.log(data);
                                    popu.close();
                                    $scope.refresh($scope.subTabStates);
                                });
                            }
                        }
                    }]
                });
            };
            $scope.goAllDetail = function (ids, orderStatus, id_off, del_flg) {
                if (orderStatus == 1 || orderStatus == 8) {
                    orderStatus = 2;
                } else if (orderStatus == 2) {
                    orderStatus = 1;
                } else if (orderStatus == 3) {
                    orderStatus = 3;
                } else {
                    orderStatus = 4;
                }
                $scope.goDetail(ids, orderStatus, id_off, del_flg);
            };

            /**
             * 点击拒绝退款
             */
            $scope.rejectRefund = function (ids) {
                $ionicPopup.confirm({
                    title: "拒绝退款",
                    template: "确定拒绝退款?",
                    buttons: [{
                        text: "取消"
                    }, {
                        text: "<b>确定</b>",
                        type: "button-positive",
                        onTap: function (e) {
                            return true;
                        }
                    }]
                }).then(function (res) {
                    if (res) {
                        var json = {
                            ids: ids,
                            user_ids: $scope.order.userId
                        };
                        Network.loading(json, "/api/order/updateOrderForRefuseRefund", function (data) {
                            console.log(data);
                            if (data.status.succeed == 1) {
                                $scope.refresh($scope.subTabStates);
                            }
                        });
                    } else {
                        return false;
                    }
                });
            };

            /**
             * 点击同意退款
             */
            $scope.agreeRefund = function (ids) {
                $ionicPopup.confirm({
                    title: "同意退款",
                    template: "同意退款后，款项将于24小时内转到您的钱包账户，请注意查收。",
                    buttons: [{
                        text: "取消"
                    }, {
                        text: "<b>确定</b>",
                        type: "button-positive",
                        onTap: function (e) {
                            return true;
                        }
                    }]
                }).then(function (res) {
                    if (res) {
                        var json = {
                            ids: ids,
                            user_ids: $scope.order.userId
                        };
                        Network.loading(json, "/api/order/updateOrderForAgreeRefund", function (data) {
                            console.log(data);
                            if (data.status.succeed == 1) {
                                $scope.refresh($scope.subTabStates);
                            }
                        });
                    } else {
                        return false;
                    }
                });
            };

            /**
             * 点击支付
             */
            $scope.goPayPage = function (courseid, course_name, price, agentid, orderid, id_off, del_flg) {
                if (id_off != 1) {
                    $cordovaToast.showShortCenter('该课程已下架。');
                    return false;
                }
                if (del_flg == 1) {
                    $cordovaToast.showShortCenter('该课程已删除。');
                    return false;
                }
                if (navigator.connection.type == Connection.NONE) {
                    $cordovaToast.showShortCenter('网络异常，请检查网络');
                    return false;
                }
                $state.go('tab.user-course-pay', {
                    'courseid': courseid,
                    'userid': $scope.order.userId,
                    'name': course_name,
                    'price': price,
                    'agentid': agentid,
                    'orderid': orderid
                });
            };
        })

//----------------------------------------------------------------------
// 用户信息Controller
//----------------------------------------------------------------------
        .controller('UserInfoCtrl', function ($ionicScrollDelegate, AppConfig, $cordovaToast, $cordovaFileTransfer, CheckLogin, $ionicModal, $ionicActionSheet, Network, $scope, $ionicHistory, Common, $cordovaCamera, $rootScope, $ionicLoading) {
            // 临时省、市、区名
            var provinceName = '';
            var cityName = '';
            var areaName = '';
            // 昵称规则
            $scope.maxdate = new Date().format('yyyy-MM-dd');
            var namereg = new RegExp(/^[\u4E00-\u9FA5A-Za-z0-9_ ]+$/);
            // 注入地区选择Modal
            var userId = $rootScope.userIds;
            CheckLogin.checkLogin(function (res) {
                if (res != null) {
                    var json = {
                        ids: res
                    };
                    $ionicLoading.show({
                        template: "努力加载中...",
                        duration: 30000,
                        noBackdrop: true,
                        hideOnStateChange: true
                    });
                    // 获取用户信息
                    Network.loading(json, "/api/user/info", function (data) {
                        user = data.data.user_info;
                        console.log(user);
                        $scope.user = user;
                        if (user.gender == '' || user.gender == null) {
                            $scope.user.gender = '1';
                        } else {
                            $scope.user.gender = user.gender;
                        }
                        $scope.province_code = user.area_code_1;
                        $scope.area_code = user.area_code_3;
                        $scope.city_code = user.area_code_2;
                        $scope.provinceName = user.area_name_1;
                        $scope.cityName = user.area_name_2;
                        $scope.areaName = user.area_name_3;
                        $scope.birthday = new Date(user.birthday);
                        $scope.areamessage = user.area_name_1 + "-" + user.area_name_2 + "-" + user.area_name_3;
                        provinceName = user.area_name_1;
                        cityName = user.area_name_2;
                        areaName = user.area_name_3;
                    });
                } else {
                    $state.go('tab.clogin');
                }
            });

            /**
             * 点击保存
             */
            $scope.save = function () {
                var birthday = $('#birthday').val();
                if ($scope.province_code == null || $scope.province_code == '') {
                    $cordovaToast.showShortCenter('请选择省份');
                    return false;
                }
                if ($scope.city_code == null || $scope.city_code == '') {
                    $cordovaToast.showShortCenter('请选择城市');
                    return false;
                }
                if ($scope.area_code == null || $scope.area_code == '') {
                    $cordovaToast.showShortCenter('请选择区域');
                    return false;
                }
                if (birthday == null || birthday == '') {
                    $cordovaToast.showShortCenter('请选择出生日期');
                    return false;
                }
                if ($scope.user.name == null || $scope.user.name == '') {
                    $cordovaToast.showShortCenter('请填写姓名');
                    return false;
                }
                if (namereg.test($scope.user.name) != true) {
                    $cordovaToast.showShortCenter('姓名不能包含特殊字符');
                    return false;
                }
                if ($scope.user.name.length > 10) {
                    $cordovaToast.showShortCenter('姓名不能大于10位');
                    return false;
                }
                if ($scope.user.gender == null) {
                    $scope.user.gender = '';
                }
                json = {
                    ids: $scope.user.ids,
                    name: $scope.user.name,
                    gender: $scope.user.gender + '',
                    birthday: new Date(birthday).format('yyyy-MM-dd'),
                    area_code_1: $scope.province_code + '',
                    area_code_2: $scope.city_code + '',
                    area_code_3: $scope.area_code + ''
                };

                apiUrl = "/api/user/updateUserInfo";
                Network.loading(json, apiUrl, function (data) {
                    $ionicHistory.goBack();
                });
            };
            // 临时省、市、区id
            var provinc = '';
            var city = '';
            var area = '';

            /**
             * 打开地区选择，获取省级列表
             */
            $scope.showarea = function () {
                var areamodal = $ionicModal.fromTemplateUrl("templates/user/user_area.html", {
                    scope: $scope,
                    animation: "slide-in-up"
                }).then(function (modal) {
                    $scope.areaModal = modal;
                    $scope.areaModal.show();
                });
                provinc = '';
                city = '';
                area = '';
                provinceName = '';
                cityName = '';
                $scope.cityList = '';
                $scope.areaList = '';
                json = {};
                Network.loading(json, "/api/mst_area/getProvince", function (data) {
                    $scope.provinceList = data.data.data;
                });
                if ($scope.province_code) {
                    $scope.getCity($scope.province_code, $scope.provinceName);
                }
                if ($scope.city_code) {
                    $scope.getArea($scope.city_code, $scope.cityName);
                }
                if ($scope.area_code) {
                    $scope.setArea($scope.area_code, $scope.areaName);
                }
            };

            /**
             * 选择省
             */
            $scope.getUserCity = function (provinceId, name) {
                provinceName = '';
                cityName = '';
                area = '';
                $scope.getCity(provinceId, name);
            };

            /**
             * 设置省，获取市级列表
             */
            $scope.getCity = function (provinceId, name) {
                $ionicScrollDelegate.$getByHandle('smallAreaOne').scrollTop();
                $(".userprovince").removeClass('assertive');
                $("#user" + provinceId).addClass('assertive');
                province = provinceId;
                provinceName = name;
                $scope.cityList = null;
                $scope.areaList = null;
                var id = provinceId + '';
                json = {
                    province_code: id
                };
                Network.loading(json, "/api/mst_area/getCity", function (data) {
                    $scope.cityList = data.data.data;
                    console.log($scope.cityList);
                });
            };

            /**
             * 设置市，获取区级列表
             */
            $scope.getArea = function (cityId, name) {
                $ionicScrollDelegate.$getByHandle('smallAreaTwo').scrollTop();
                $scope.areaList = null;
                city = cityId;
                cityName = name;
                areaName = '';
                $(".usercity").removeClass('assertive');
                $("#user" + cityId + "").addClass('assertive');
                var id = cityId + '';
                json = {
                    city_code: id
                };
                Network.loading(json, "/api/mst_area/getArea", function (data) {
                    $scope.areaList = data.data.data;
                    console.log($scope.areaList);
                });
            };

            /**
             * 设置区
             */
            $scope.setArea = function (areaId, name) {
                $(".userarea").removeClass('assertive');
                area = areaId;
                areaName = name;
                $("#user" + areaId + "").addClass('assertive');
            };

            /**
             * 关闭地区选择
             */
            $scope.closeModal = function () {
                provinceName = $scope.provinceName;
                cityName = $scope.cityName;
                areaName = $scope.areaName;
                $scope.areamessage = $scope.provinceName + "-" + $scope.cityName + "-" + $scope.areaName;
                $scope.areaModal.remove();
                areamodal = null;
            };

            /**
             * 确定地区选择
             */
            $scope.areaMessage = function () {
                if (provinceName != '' && provinceName != null) {
                    if (cityName != '' && cityName != null) {
                        if (areaName != '' && areaName != null) {
                            $scope.provinceName = provinceName;
                            $scope.cityName = cityName;
                            $scope.areaName = areaName;
                        } else {
                            $cordovaToast.showShortCenter('请选择区域');
                            return false;
                        }
                    } else {
                        $cordovaToast.showShortCenter('请选择城市');
                        return false;
                    }
                } else {
                    $cordovaToast.showShortCenter('请选择省份');
                    return false;
                }
                $scope.areamessage = $scope.provinceName + "-" + $scope.cityName + "-" + $scope.areaName;
                $scope.province_code = province + '';
                $scope.area_code = area + '';
                $scope.city_code = city + '';
                $scope.areaModal.remove();
                areamodal = null;
            };

            /**
             * 设置头像
             */
            $scope.getPhoto = function () {
                $ionicActionSheet.show({
                    buttons: [
                        {text: '<div class="top-icon energized-bg"><i class="ion-ios-camera white"></i></div><div class="bottom-text">相机</div>'},
                        {text: '<div class="top-icon balanced-bg"><i class="ion-images white"></i></div><div class="bottom-text">图库</div>'}
                    ],
                    titleText: '更换个人头像',
                    cancelText: '关闭',
                    cancel: function () {
                        return true;
                    },
                    buttonClicked: function (index) {
                        switch (index) {
                            case 0:
                                appendByCamera(1);
                                break;
                            case 1:
                                appendByCamera(0);
                                break;
                            default:
                                break;
                        }
                        return true;
                    }
                });
            };

            /**
             * 设置头像来源
             * sourceType 图片来源(1、相机 2、图库)
             */
            var appendByCamera = function (sourceType) {
                var options = {
                    quality: 50,
                    destinationType: 1,
                    sourceType: sourceType,
                    allowEdit: true,
                    encodingType: 0,
                    targetWidth: 150,
                    targetHeight: 150,
                    correctOrientation: true,
                    popoverOptions: CameraPopoverOptions,
                    saveToPhotoAlbum: false
                };
                $cordovaCamera.getPicture(options).then(function (results) {
                    $scope.user.head_img = results;
                    var apiUrl = AppConfig.getConfig().BASE_API + "/api/user/headerPicUpload";
                    var header = Common.commonHeaders(apiUrl, null);
                    var fileName = results.substr(results.lastIndexOf('/') + 1);
                    if (!ionic.Platform.isIOS() && fileName.lastIndexOf('?') > 0) {
                        fileName = fileName.substr(0, fileName.lastIndexOf('?'));
                    }
                    var options = {
                        "fileKey": "file",
                        "fileName": fileName,
                        "mimeType": "image/jpeg",
                        params: {
                            "ids": $scope.user.ids
                        },
                        headers: header
                    };
                    $cordovaFileTransfer.upload(apiUrl, results, options).then(function (result) {
                        console.log(result);
                    }, function (err) {
                        $cordovaToast.showShortCenter(err);
                    }, function (progress) {
                    });
                }, function (error) {
                    if (error == 'Unable to retrieve path to picture!') {
                        $cordovaToast.showShortCenter('请上传png,jpg格式的图片');
                    }
                    console.error(error);
                });
            };
        })

//----------------------------------------------------------------------
// 我的收藏Controller
//----------------------------------------------------------------------
        .controller('UserCollectCtrl', function ($cordovaToast, $ionicLoading, $rootScope, $stateParams, Constants, CheckLogin, Network, $scope, $state) {

            // 通讯参数
            $scope.collect = $scope;
            $scope.collect.userId = $stateParams.userId;
            var userId = $scope.collect.userId;
            // 是否还有下一页
            $scope.collect.agentpaginated = 0;
            $scope.collect.coursepaginated = 0;
            var page;
            var count = 1;
            $scope.agents = '';
            $scope.courses = '';

            /**
             * 点击tab
             */
            $scope.toCollectCourse = function (type) {
                $scope.isPrompt = false;
                count = 1;
                var collectjson = {
                    user_ids: userId,
                    favorite_type: type + '',
                    pagination: {
                        page: '1',
                        count: Constants.pageItem
                    }
                };
                console.log(collectjson);
                Network.loading(collectjson, "/api/user_favorite/getUserFavoriteListByUserIds", function (data) {
                    $scope.courses = data.data;
                    console.log($scope.courses);
                    $scope.collect.coursepaginated = data.paginated.more;
                    if (!$scope.courses || $scope.courses.length == 0) {
                        $scope.isPrompt = true;
                    } else {
                        $scope.isPrompt = false;
                    }
                });
            };
            $scope.toCollectAgent = function (type) {
                $scope.isPrompt = false;
                count = 1;
                var collectjson = {
                    user_ids: userId,
                    favorite_type: type + '',
                    pagination: {
                        page: '1',
                        count: Constants.pageItem
                    }
                };
                Network.loading(collectjson, "/api/user_favorite/getUserFavoriteListByUserIds", function (data) {
                    $scope.agents = data.data;
                    console.log($scope.agents);
                    $scope.collect.agentpaginated = data.paginated.more;
                    if (!$scope.agents || $scope.agents.length == 0) {
                        $scope.isPrompt = true;
                    } else {
                        $scope.isPrompt = false;
                    }
                });
            };

            /**
             * 加载、刷新
             */
            $scope.refresh = function (type) {
                count = 1;
                var collectjson = {
                    user_ids: userId,
                    favorite_type: type + '',
                    pagination: {
                        page: '1',
                        count: Constants.pageItem
                    }
                };
                Network.loading(collectjson, "/api/user_favorite/getUserFavoriteListByUserIds", function (data) {
                    if (type == 1) {
                        $scope.agents = data.data;
                        $scope.collect.agentpaginated = data.paginated.more;
                        if (!$scope.agents || $scope.agents.length == 0) {
                            $scope.isPrompt = true;
                        } else {
                            $scope.isPrompt = false;
                        }
                    } else {
                        $scope.courses = data.data;
                        $scope.collect.coursepaginated = data.paginated.more;
                        if (!$scope.courses || $scope.courses.length == 0) {
                            $scope.isPrompt = true;
                        } else {
                            $scope.isPrompt = false;
                        }
                    }

                });
                $scope.$broadcast("scroll.refreshComplete");
            };
            $scope.loadMoreCollect = function (type) {
                count = count + 1;
                page = {
                    page: count + '',
                    count: Constants.pageItem
                };
                var collect = {
                    user_ids: userId,
                    favorite_type: type + '',
                    pagination: page
                };

                Network.loading(collect, "/api/user_favorite/getUserFavoriteListByUserIds", function (data) {
                    if (type == 1) {
                        if ($scope.agents != '') {
                            $scope.agents = $scope.agents.concat(data.data);
                        } else {
                            $scope.agents = data.data;
                        }
                        $scope.collect.agentpaginated = data.paginated.more;
                        if (!$scope.agents || $scope.agents.length == 0) {
                            $scope.isPrompt = true;
                        } else {
                            $scope.isPrompt = false;
                        }
                    } else {
                        if ($scope.courses != '') {
                            $scope.courses = $scope.courses.concat(data.data);
                        } else {
                            $scope.courses = data.data;
                        }
                        $scope.collect.coursepaginated = data.paginated.more;
                        if (!$scope.courses || $scope.courses.length == 0) {
                            $scope.isPrompt = true;
                        } else {
                            $scope.isPrompt = false;
                        }
                    }
                    count = count + 1;
                    $scope.$broadcast("scroll.infiniteScrollComplete");
                });
            };

            /**
             * 取消收藏
             */
            $scope.cancelAgentCollect = function (favoriteIds, type) {
                var json = {
                    user_ids: userId,
                    favorite_ids: favoriteIds
                };
                Network.loading(json, "/api/user_favorite/cancelUserFavorite", function (data) {
                    console.log(data);
                    if (data.status.succeed == 1) {
                        $scope.favoriteIds = null;
                        $scope.collectTitle = '收藏';
                        $ionicLoading.show({
                            template: "您已成功取消收藏！",
                            duration: 2000,
                            noBackdrop: true,
                            hideOnStateChange: true
                        });
                        $scope.refresh(type);
                    } else {
                        $ionicLoading.show({
                            template: "发生未知错误，取消收藏失败",
                            duration: 2000,
                            noBackdrop: true,
                            hideOnStateChange: true
                        });
                    }
                });
            };

            /**
             * 去详细
             */
            $scope.goCourseDtail = function (ids, coursePics, id_off, del_flg) {
                if (id_off != 1) {
                    $cordovaToast.showShortCenter('该课程已下架。');
                    return false;
                }
                if (del_flg == 1) {
                    $cordovaToast.showShortCenter('该课程已删除。');
                    return false;
                }
                console.log(coursePics);
                // 轮播图片
                $rootScope.coursePics = coursePics;
                $state.go('tab.user-course-detail', {
                    'courseId': ids,
                    'tabType': 4
                });
            };
            $scope.goAgentDtail = function (agentId, agentPics, agentName) {
                // 轮播图片
                $rootScope.agentPics = agentPics;
                $state.go('tab.user-agentDetail', {
                    'agentId': agentId,
                    'tabType': 4,
                    'name': agentName
                });
            };
        })

//----------------------------------------------------------------------
// 订单详情Controller
//----------------------------------------------------------------------
        .controller('orderDetailCtrl', function ($ionicModal, $cordovaToast, $ionicPopup, $rootScope, CheckLogin, $ionicHistory, $scope, Network, $state, $stateParams, $ionicLoading) {

            $ionicModal.fromTemplateUrl('templates/refund-agreement.html', {
                scope: $scope
            }).then(function (modal) {
                $scope.refund_agreement = modal;
            });
            $scope.orderId = $stateParams.orderId;
            // 订单状态
            $scope.orderType = $stateParams.orderType;
            $scope.orderdetail = $scope;

            ////////////////////////////////////订单信息获取///////////////////////////
            // 通讯参数
            var json = {
                order_ids: $scope.orderId
            };
            $ionicLoading.show({
                template: "努力加载中...",
                duration: 30000,
                noBackdrop: true,
                hideOnStateChange: true
            });
            Network.loading(json, "/api/order/getOrderByIds", function (data) {
                $scope.order = data.data.data;
                console.log($scope.order);
            });
            /////////////////////////////////////////////////////////////////////////

            var userId;
            CheckLogin.checkLogin(function (res) {
                console.log(res);
                if (res != null) {
                    userId = res;
                }
            });

            /**
             * 课程详细
             */
            $scope.goDtail = function (courseId, coursePics, id_off, del_flg) {
                if (id_off != 1) {
                    $cordovaToast.showShortCenter('该课程已下架。');
                    return false;
                }
                if (del_flg == 1) {
                    $cordovaToast.showShortCenter('该课程已删除。');
                    return false;
                }
                $rootScope.coursePics = coursePics;
                $state.go('tab.user-course-detail', {
                    'courseId': courseId,
                    'tabType': 4
                });
            };

            /**
             * 点击支付
             */
            $scope.goPayPage = function (courseid, course_name, price, agentid, orderid, id_off, del_flg) {
                if (id_off != 1) {
                    $cordovaToast.showShortCenter('该课程已下架。');
                    return false;
                }
                if (del_flg == 1) {
                    $cordovaToast.showShortCenter('该课程已删除。');
                    return false;
                }
                if (navigator.connection.type == Connection.NONE) {
                    $cordovaToast.showShortCenter('网络异常，请检查网络');
                    return false;
                }
                $state.go('tab.user-course-pay', {
                    'courseid': courseid,
                    'userid': userId,
                    'name': course_name,
                    'price': price,
                    'agentid': agentid,
                    'orderid': orderid
                });
            };
            var pop;

            /**
             * 点击申请退款
             */
            $scope.drawback = function (id) {
                pop = $ionicPopup.show({
                    template: "<input type='text' ng-model='orderdetail.reason' placeholder='退款理由限20字' maxlength='20'>",
                    title: "申请退款",
                    subTitle: "课程款将被冻结，请与门店协商。",
                    scope: $scope,
                    buttons: [{
                        text: "取消"
                    }, {
                        text: "<b>确定</b>",
                        type: "button-positive",
                        onTap: function (e) {
                            if ($scope.orderdetail.reason == null || $scope.orderdetail.reason == '') {
                                $cordovaToast.showShortCenter('请输入退款理由');
                                e.preventDefault();
                            }
                            else if ($scope.orderdetail.reason.length > 20) {
                                $cordovaToast.showShortCenter('退款理由过长');
                                e.preventDefault();
                            }
                            else {
                                var json = {
                                    ids: id,
                                    refund_reason: $scope.orderdetail.reason
                                };
                                $scope.orderdetail.reason = null;
                                Network.loading(json, "/api/order/updateOrderForApplyRefund", function (data) {
                                    console.log(data);
                                    $ionicHistory.goBack();
                                });
                            }
                        }
                    }]
                })
                        .then(function (res) {

                        });
            };

            /**
             * 点击拒绝退款
             */
            $scope.rejectRefund = function (ids) {
                $ionicPopup.confirm({
                    title: "拒绝退款",
                    template: "确定拒绝退款?",
                    buttons: [{
                        text: "取消"
                    }, {
                        text: "<b>确定</b>",
                        type: "button-positive",
                        onTap: function (e) {
                            return true;
                        }
                    }]
                }).then(function (res) {
                    if (res) {
                        var json = {
                            ids: ids,
                            user_ids: userId
                        };
                        Network.loading(json, "/api/order/updateOrderForRefuseRefund", function (data) {
                            console.log(data);
                            $ionicHistory.goBack();
                        });
                    } else {
                        return false;
                    }
                });
            };

            /**
             * 点击同意退款
             */
            $scope.agreeRefund = function (ids) {
                $ionicPopup.confirm({
                    title: "同意退款",
                    template: "同意退款后，款项将于24小时内转到您的钱包账户，请注意查收",
                    buttons: [{
                        text: "取消"
                    }, {
                        text: "<b>确定</b>",
                        type: "button-positive",
                        onTap: function (e) {
                            return true;
                        }
                    }]
                }).then(function (res) {
                    if (res) {
                        var json = {
                            ids: ids,
                            user_ids: userId
                        };
                        Network.loading(json, "/api/order/updateOrderForAgreeRefund", function (data) {
                            console.log(data);
                            if (data.status.succeed == 1) {
                                $ionicHistory.goBack();
                            }
                        });
                    } else {
                        return false;
                    }
                });
            };

            /**
             * 点击评价
             */
            $scope.doEvaluation = function (orderId, agentId, courseId, id_off, del_flg, agentName, courseName) {
                if (id_off != 1) {
                    $cordovaToast.showShortCenter('该课程已下架。');
                    return false;
                }
                if (del_flg == 1) {
                    $cordovaToast.showShortCenter('该课程已删除。');
                    return false;
                }
                $state.go('tab.goto-evaluation', {
                    orderId: orderId,
                    userId: $scope.order.userId,
                    agentId: agentId,
                    courseId: courseId,
                    agentName: agentName,
                    courseName: courseName
                });
            };
            $scope.pay = function (orderId) {
                $ionicPopup.confirm({
                    title: "确认支付",
                    template: "确认付款后, 钱将会转给门店, 款项不再受集团保护.",
                    buttons: [{
                        text: "取消"
                    }, {
                        text: "<b>确定</b>",
                        type: "button-positive",
                        onTap: function (e) {
                            return true;
                        }
                    }]
                }).then(function (res) {
                    if (res) {
                        var json = {
                            ids: orderId,
                            user_ids: userId
                        };
                        Network.loading(json, "/api/order/updateOrderForConfirmPay", function (data) {
                            console.log(data);
                            $ionicHistory.goBack();
                        });
                    } else {
                        return false;
                    }
                });
            };

        })

//----------------------------------------------------------------------
// 更换手机号Controller
//----------------------------------------------------------------------
        .controller('UserChangeCtrl', function ($interval, $cordovaToast, CheckLogin, Network, $scope, $stateParams, Common, $ionicPopup, $ionicHistory) {
            // 旧手机号
            if (changeMobile == '') {
                $scope.mobile = $stateParams.mobile;
            } else {
                $scope.mobile = changeMobile;
            }
            var userId;
            CheckLogin.checkLogin(function (res) {
                console.log(res);
                if (res != null) {
                    userId = res;
                }
            });

            $scope.change = $scope;
            // 手机号与密码规则
            var reg = new RegExp(/^(0|86|17951)?(13[0-9]|15[012356789]|17[0-9]|18[0-9]|14[57])[0-9]{8}$/);
            var passwordreg = new RegExp(/^\w{6,16}$/);

            /**
             * 点击确定
             */
            $scope.userChange = function () {
                var password = $scope.change.password;
                var telephone = $scope.change.telephone;
                var verification = $scope.change.checking;
                var checkingreg = new RegExp(/^[0-9]*$/);
                if (telephone == null || telephone == "") {
                    $cordovaToast.showShortCenter('请输入手机号').then(function (success) {
                    }, function (error) {
                    });
                    return false;
                }
                if (password == null || password == '') {
                    $cordovaToast.showShortCenter('请输入密码').then(function (success) {
                    }, function (error) {
                    });
                    return false;
                }
                if (passwordreg.test(password) != true) {
                    $cordovaToast.showShortCenter('密码必须由6～16位字母、数字、下划线组成');
                    return false;
                }
                if (reg.test(telephone) != true) {
                    $cordovaToast.showShortCenter('手机号格式错误');
                    return false;
                }
                if (verification == null || verification == "") {
                    $cordovaToast.showShortCenter('请输入验证码');
                    return false;
                }
                if (checkingreg.test(verification) != true) {
                    $cordovaToast.showShortCenter('验证码格式错误');
                    return false;
                }
                if (verification.length < 6) {
                    $cordovaToast.showShortCenter('验证码少于6位');
                    return false;
                }
                json = {
                    ids: userId,
                    password: password,
                    mobile: telephone + '',
                    verification_code: verification + ''
                };
                apiUrl = "/api/user/changeMobile";
                Network.loading(json, apiUrl, function (data) {
                    changeMobile = data.data;
                    $cordovaToast.showShortCenter('修改手机号成功');
                    // 返回上一页
                    $ionicHistory.goBack();
                });
            };

            $scope.change.checkcodenum = '';

            /**
             * 获取验证码
             */
            $scope.getChecking = function () {
                // 新电话
                var telephone;
                if ($scope.change.telephone == null || $scope.change.telephone == '') {
                    $cordovaToast.showShortCenter('请输入手机号');
                    return false;
                }
                if (reg.test($scope.change.telephone) != true) {
                    $cordovaToast.showShortCenter('手机号格式错误');
                    return false;
                }
                telephone = $scope.change.telephone + '';
                $('#changchecknum').show();

                Network.loading({
                    mobile: telephone,
                    status: '3'
                }, "/api/user/validate", function (data) {
                    checkCode = data.data;
                });

                $scope.change.count = 1;
                $scope.change.checkcodenum = 60;
                var timer = $interval(function () {
                    $scope.change.checkcodenum = $scope.change.checkcodenum - 1;
                    if ($scope.change.checkcodenum <= 0) {
                        $('#changchecknum').hide();
                        $scope.change.checkcodenum = '';
                        $scope.change.count = 0;
                        $interval.cancel(timer);
                        timer = undefined;
                        return false;
                    }
                }, 1000);
            };
        })

//----------------------------------------------------------------------
// 修改密码Controller
//----------------------------------------------------------------------
        .controller('PasswordChangeCtrl', function ($cordovaToast, CheckLogin, $ionicHistory, Network, $scope, Common, $rootScope, $state, $cordovaSQLite) {
            $scope.chang = $scope;
            // 密码规则
            var passwordreg = new RegExp(/^\w{6,16}$/);
            var userId;
            CheckLogin.checkLogin(function (res) {
                console.log(res);
                if (res != null) {
                    userId = res;
                }
            });
            /**
             * 关闭消息推送
             */
            var stopBaiduPush = function (ids) {
                baidu_push.stopWork(function (resultJson) {
                    // 解除与百度的绑定
                });
            };
            /**
             * 确定
             */
            $scope.update = function () {
                var newPasswordAgain = $scope.chang.newpasswordagain;
                var newPassword = $scope.chang.newpassword;
                var oldPassword = $scope.chang.oldpassword;

                if (oldPassword == null || oldPassword == '') {
                    $cordovaToast.showShortCenter('请输入旧密码');
                    return false;
                }
                if (newPassword == null || newPassword == '') {
                    $cordovaToast.showShortCenter('请输入新密码');
                    return false;
                }
                if (passwordreg.test(oldPassword) != true) {
                    $cordovaToast.showShortCenter('密码必须由6～16位字母、数字、下划线组成');
                    return false;
                }
                if (passwordreg.test(newPassword) != true) {
                    $cordovaToast.showShortCenter('新密码必须由6～16位字母、数字、下划线组成');
                    return false;
                }
                if (newPassword != newPasswordAgain) {
                    $cordovaToast.showShortCenter('两次输入的密码不符').then(function (success) {
                    }, function (error) {
                    });
                    return false;
                }

                var json = {
                    ids: userId,
                    password: oldPassword,
                    password_new: newPassword
                };
                var apiUrl = "/api/user/changePassword";
                Network.loading(json, apiUrl, function (data) {
                    $cordovaToast.showShortCenter('密码修改成功');
                    var type = 1;
                    var json = {
                        ids: userId
                    };
                    // 通讯路径
                    Network.loading(json, "/api/user/signout", function (data) {
                        console.log(data);
                        $cordovaSQLite.execute(db, 'DELETE FROM Login').then(function (result) {
                            console.log('删除' + result);
                        }, function (error) {
                            console.log('删除' + error);
                        });
                        $scope.status = 0;
                        $rootScope.userIds = null;
                        stopBaiduPush(userId);
                        $ionicHistory.goBack();
                    });
                });
            };
        })

//----------------------------------------------------------------------
// 我的钱包Controller
//----------------------------------------------------------------------
        .controller('PurseCtrl', function ($scope, $state, $stateParams, $rootScope, $ionicHistory, Network) {
            // 钱包金额
            $scope.userId = $stateParams.userId;
            var userId = $stateParams.userId;
            var json = {
                ids: userId
            };
            ////////////////////////////////////用户信息获取///////////////////////////
            // 通讯路径
            var apiUrl = "/api/user/info";
            Network.loading(json, apiUrl, function (data) {
                $scope.user = data.data.user_info;
                $scope.wallet = $scope.user.balance;
                console.log($scope.user);
            });
            /**
             * go收支明细、红包抵用券
             */
            $scope.goPayment = function () {
                $state.go('tab.user-purse-paymentdetail', {
                    'userId': userId
                });
            };
            $scope.goEvaluation = function () {
                $state.go('tab.user-reward-coupon', {
                    'userId': userId
                });
            };
        })

//----------------------------------------------------------------------
// 我的评价Controller
//----------------------------------------------------------------------
        .controller('UserEvaluationCtrl', function ($ionicModal, $ionicPopover, $ionicLoading, Constants, $stateParams, Network, CheckLogin, $scope) {

            var pageNum = 0;
            // 是否还有下一页 (1、有)
            $scope.isMore = 1;
            var userId;
            CheckLogin.checkLogin(function (res) {
                console.log(res);
                if (res != null) {
                    userId = res;
                }
            });

            /**
             * 获取用户评价list
             */
            var getEvaluationList = function () {
                ////////////////////////////////////用户评价list获取///////////////////////////
                // 通讯参数
                var courseJson = {
                    user_ids: userId,
                    order_ids: $stateParams.orderId,
                    pagination: {
                        page: pageNum + '',
                        count: Constants.pageItem
                    }
                };
                apiUrl = "/api/evaluate_course/getEvaluateListByUserIds";
                Network.loading(courseJson, apiUrl, function (data) {
                    console.log(data);
                    $scope.isMore = data.paginated.more;
                    if (pageNum == 1) {
                        $scope.list = data.data.evaluateList;
                    } else {
                        $scope.list = $scope.list.concat(data.data.evaluateList);
                    }
                    if (!$scope.list || $scope.list.length == 0) {
                        $scope.isPrompt = true;
                        $ionicLoading.show({
                            template: "您未对此订单进行过评价",
                            noBackdrop: true,
                            duration: 1000,
                            hideOnStateChange: true
                        });
                    } else {
                        $scope.isPrompt = false;
                    }
                    $scope.$broadcast("scroll.refreshComplete");
                    $scope.$broadcast("scroll.infiniteScrollComplete");
                });
                /////////////////////////////////////////////////////////////////////////
            };
            $scope.openPopover = function (eval, picUrl) {
                $ionicModal.fromTemplateUrl("templates/agent/agent-picture.html", {
                    scope: $scope,
                    animation: "slide-in-up"
                }).then(function (modal) {
                    $scope.pictureModal = modal;
                    $scope.data = eval.pic_b;
                });
                setTimeout(function () {
                    $scope.pictureModal.show();
                }, 500);
                console.log($scope.data);
                console.log(picUrl);
                console.log(eval.pic_s.indexOf(picUrl));
            };
            /**
             * 关闭图片大图model
             */
            $scope.closeModal = function () {
                $scope.pictureModal.remove();
            };

            /**
             * 刷新、加载
             */
            $scope.institutionRefresh = function () {
                pageNum = '1';
                getEvaluationList();
            };
            $scope.load_more = function () {
                pageNum = pageNum + 1;
                CheckLogin.checkLogin(function (res) {
                    if (res != null) {
                        userId = res;
                    }
                    getEvaluationList();
                });
            };

        })

//----------------------------------------------------------------------
// 充值Controller
//----------------------------------------------------------------------
        .controller('RechargeCtrl', function (CheckLogin, $state, Network, $scope, $cordovaToast, Pay, $rootScope, $ionicHistory, $ionicLoading) {
            $scope.recharge = $scope;
            // 充值方式
            $scope.recharge.paychoose = '2';
            // 充值金额
            $scope.recharge.paynumber = null;
            var orderId;
            var userId;
            CheckLogin.checkLogin(function (res) {
                if (res != null) {
                    userId = res;
                }
            });
            Network.loading({}, "/api/user/getRechargeNo", function (data) {
                orderId = data.data;
            });

            /**
             * 点击充值
             */
            $scope.pay = function () {
                if ($scope.recharge.paychoose == '0' || $scope.recharge.paychoose == null) {
                    $cordovaToast.showShortCenter('请选择支付方式');
                    return false;
                }
                if ($scope.recharge.paynumber == 0 || $scope.recharge.paynumber == null) {
                    $cordovaToast.showShortCenter('请输入金额');
                    return false;
                }
                if ($scope.recharge.paynumber > 2000) {
                    $cordovaToast.showShortCenter('金额须小于2000元');
                    return false;
                }
                if($scope.recharge.paynumber < 0.01){
                    $cordovaToast.showShortCenter('金额须不小于0.01元');
                    return false;
                }
                $ionicLoading.show({
                    template: '正在连接，请稍候...'
                });
                if ($scope.recharge.paychoose == '2') {
                    Pay.wxPay(orderId, '充值', $scope.recharge.paynumber + '', function (res) {
                        if (res == 1) {
                            Network.loading({
                                ids: userId,
                                balance: $scope.recharge.paynumber + '',
                                in_out_name: '微信'
                            }, "/api/user/userRecharge", function (data) {
                                $ionicLoading.hide();
                                $cordovaToast.showShortCenter('充值成功');
                                $ionicHistory.goBack();
                            });
                        } else if (res == 2) {
                            $ionicLoading.hide();
                            $cordovaToast.showShortCenter('充值取消');
                            return false;
                        } else if(res == 3){
                            $ionicLoading.hide();
                            $cordovaToast.showShortCenter('充值失败');
                        }
                    });
                } else {
                    Pay.aliPay(orderId, '充值', $scope.recharge.paynumber + '', function (res) {
                        if (res == 1) {
                            Network.loading({
                                ids: userId,
                                balance: $scope.recharge.paynumber + '',
                                in_out_name: '支付宝'
                            }, "/api/user/userRecharge", function (data) {
                                $ionicLoading.hide();
                                $cordovaToast.showShortCenter('充值成功');
                                $ionicHistory.goBack();
                            });
                        } else {
                            $ionicLoading.hide();
                            $cordovaToast.showShortCenter('充值失败');
                        }
                    });
                }
            };
        })
//----------------------------------------------------------------------
// 关于我们Controller
//----------------------------------------------------------------------
        .controller('UserAboutCtrl', function () {
        })

        .controller('TabCtrl', function () {
        })

        .controller('FeedbackCtrl', function ($rootScope, $stateParams, $scope, $cordovaToast, $ionicLoading, $ionicHistory, Network) {
            $scope.feedback = {};
            $scope.tel = $stateParams.mobile;
            $scope.submitFeedback = function () {
                if (!$scope.feedback.content) {
                    $cordovaToast.showShortBottom("您还没有填写任何反馈意见");
                    return;
                }
                var contentRegex = /^([\u4E00-\u9FA5]|[\x00-\x80]||[\u3002]|[\uFE30-\uFFA0]|[\x21-\x7e]|\s)*$/;
                if (!contentRegex.test($scope.feedback.content)) {
                    $cordovaToast.showShortBottom("反馈意见中只可输入文字或中英数符号");
                    return;
                }

                $ionicLoading.show({
                    template: "正在提交，请稍后...",
                    duration: 20000
                });

                var json = {
                    userIds: $rootScope.userIds,
                    userMobile: $scope.tel,
                    content: $scope.feedback.content
                }
                var apiUrl = "/api/user/saveFeedBackInfo";
                var request = Network.loading(json, apiUrl, function (data) {
                    $ionicLoading.hide();
                    $cordovaToast.showShortBottom("您的意见已提交，感谢您的支持");
                    $ionicHistory.goBack();
                });
            };
        });