angular.module('starter.userServices', [])

//----------------------------------------------------------------------
// check登录
//----------------------------------------------------------------------
.factory("CheckLogin", function($cordovaSQLite) {
  return {
    checkLogin: function(callBack) {
      $cordovaSQLite.execute(db, 'SELECT * FROM Login ORDER BY id DESC').then(
        function(res) {
          if (res.rows.length > 0) {
            console.log(res);
            callBack(res.rows.item(0).user_id + '');
          } else {
            callBack(null);
          }
        },
        function(error) {
          callBack(null);
        }
      );
    }
  };
})

//----------------------------------------------------------------------
// 支付
//----------------------------------------------------------------------
.factory("Pay", function(Network, $cordovaToast) {
  return {
    wxPay: function(orderId, name, price, callBack) {
      var payJson = {
        out_trade_no: orderId,
        body: name,
        total_fee: price * 100 + ''
      };
      console.log(payJson);
      Network.loading(payJson, "/api/payment/unifiedorder", function(data) {
        console.log(data.data);
        Wechat.isInstalled(function(installed) {
          Wechat.payment(data.data, function(success) {
            if (success.code == 0) {
              Network.loading({
                ids: orderId
              }, "/api/payment", function(data) {
                callBack('1');
              });
            }
          }, function(error) {
            if (error == 'ERR_USER_CANCEL' || error == '用户点击取消并返回') {
              callBack('2');
            } else {
              $cordovaToast.showShortCenter('错误：' + error);
              //return false;
              callBack('3');
            }
          });
        }, function(reason) {
          $cordovaToast.showShortCenter('没有安装微信，支付失败');
          callBack('4');
        });
      });
    },

    aliPay: function(orderId, name, price, callBack) {
      var payJson = {
        out_trade_no: orderId,
        subject: name,
        total_fee: price + ''
      };
      Network.loading(payJson, "/api/payment/alipay", function(data) {
        console.log(data.data);
        alipay.payment(data.data, function(success) {
          var result = JSON.parse(success);
          if (result.resultStatus == 9000) {
            Network.loading({
              ids: orderId
            }, "/api/payment", function(data) {
              console.log(data);
              $cordovaToast.showShortCenter('支付成功');
              callBack('1');
            });
          } else {
            $cordovaToast.showShortCenter('支付取消');
            callBack('2');
          }
        }, function(error) {
          $cordovaToast.showShortCenter('错误：' + error);
          callBack('3');
        });
      });
    }
  };
})

;