angular.module('starter.versionUpServices',[])

//----------------------------------------------------------------------
// check版本更新
//----------------------------------------------------------------------
.factory("VersionCheck", function($timeout, $ionicLoading, $cordovaAppVersion, $ionicPopup, $cordovaFileTransfer, $cordovaFile, $cordovaFileOpener2, $cordovaToast) {

  return {
    check: function() {
      // 获取服务器上最新版本
      $.get("http://www.haoban173.com/hbindex/resources/update/ShopperApp_Version.xml", function(ver) {

        /////////////////////////////////////////
        var serverAppVersion = $(ver).find('versionCode').text();
        var serverAppDownloadUrl = $(ver).find('downloadUrl').text();
        var serverAppUpdLog = $(ver).find('updateLog').text();
        var localFilePath = $(ver).find('localFilePath').text();
        // 获取app当前版本
        cordova.getAppVersion.getVersionCode(function(version) { 
          
          // 检查版本是否一致
          if (version != serverAppVersion) {
              var confirmPopup = $ionicPopup.confirm({
                  title: '版本升级',
                  template: serverAppUpdLog, // 从服务端获取更新的内容
                  cancelText: '取消',
                  okText: '升级'
              });
              confirmPopup.then(function (res) {
                  if (res) {
                      $ionicLoading.show({
                          template: "已经下载：0%"
                      });
                      var url = serverAppDownloadUrl; // 可以从服务端获取更新APP的路径
                      var targetPath = localFilePath; // APP下载存放的路径，可以使用cordova file插件进行相关配置
                      var trustHosts = true;
                      var options = {};
                      $cordovaFileTransfer.download(url, targetPath, options, trustHosts).then(function (result) {
                          // 打开下载下来的APP
                          $cordovaFileOpener2.open(targetPath, 'application/vnd.android.package-archive'
                          ).then(function () {
                                  // 成功
                              }, function (err) {
                                  // 错误，清除进度条
                                  // $ionicLoading.hide();
                              });
                          $ionicLoading.hide();
                      }, function (err) {
                          // 下载失败，清除进度条
                          $ionicLoading.hide();
                          $cordovaToast.showShortBottom('下载失败:(');
                      }, function (progress) {
                          // 进度，这里使用文字显示下载百分比
                          $timeout(function () {
                              var downloadProgress = (progress.loaded / progress.total) * 100;
                              
                              $ionicLoading.show({
                                  template: "已经下载：" + Math.floor(downloadProgress) + "%"
                              });
                              if (downloadProgress > 99) {
                                  $ionicLoading.hide();
                              }
                          });
                      });
                  } else {
                      // 取消更新
                  }
              });
          } else {
              $cordovaToast.showShortBottom('你的应用已经是最新版本');
          }
        });
      });
    }
  };
});
